import java.awt.*;
import java.net.*;
import java.io.*;
import java.applet.*;
import java.awt.event.*;
import javax.swing.*;
public class DarkwarBase extends JApplet implements KeyListener,MouseListener{
    Image spaceship1;
    Image spaceship2;
    Image spaceship3;
    Image cannon1;
    Image cannon2;
    Image cannon3;
    Image bomb1;
    Image bomb2;
    Image bomb3;
    Image absorber;
    Image base1;
    Image base2;
    Image base3;
    Image fire1;
    Image fire2;
    Image fire3;
    XCanvasDarkwarBase xc;
    int state=0;
    int teil=0;
    MediaTracker tracker;
    CannonOrBomb cb;
    static DarkwarBase app;
    private static final long serialVersionUID = 3368571458023782883L;
    public void init(){
        app=this;
        setSize(640,520);
        setLayout(null);
        spaceship1=getImage("spaceship1.gif");
        spaceship2=getImage("spaceship2.gif");
        spaceship3=getImage("spaceship3.gif");
        cannon1=getImage("cannon1.gif");
        cannon2=getImage("cannon2.gif");
        cannon3=getImage("cannon3.gif");
        bomb1=getImage("bomb1.gif");
        bomb2=getImage("bomb2.gif");
        bomb3=getImage("bomb3.gif");
        absorber=getImage("absorber.gif");
        base1=getImage("base1.gif");
        base2=getImage("base2.gif");
        base3=getImage("base3.gif");
        fire1=getImage("fire1.gif");
        fire2=getImage("fire2.gif");
        fire3=getImage("fire3.gif");
        tracker=new MediaTracker(this);
        tracker.addImage(spaceship1,0);
        tracker.addImage(spaceship2,0);
        tracker.addImage(spaceship3,0);
        tracker.addImage(cannon1,0);
        tracker.addImage(cannon2,0);
        tracker.addImage(cannon3,0);
        tracker.addImage(bomb1,0);
        tracker.addImage(bomb2,0);
        tracker.addImage(bomb3,0);
        tracker.addImage(absorber,0);
        tracker.addImage(base1,0);
        tracker.addImage(base2,0);
        tracker.addImage(base3,0);
        tracker.addImage(fire1,0);
        tracker.addImage(fire2,0);
        tracker.addImage(fire3,0);
        try{
            tracker.waitForID(0);
        }
        catch(Exception me){
        }
        xc=new XCanvasDarkwarBase(this,640,480);
        add(xc);
        xc.setBounds(0,40,640,480);
        setFocusable(true);
        requestFocus();
        setVisible(true);
        addKeyListener(this);
        addMouseListener(this);
    }
    public static Image getImage(String filename){
        try{
            URL url=DarkwarBase.app.getClass().getResource("/"+filename);
            Image img=DarkwarBase.app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public static void main(String[]args){
        new DarkwarBase();
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        int key=e.getKeyCode();
        if(key>0){
            process(e);
        }
//System.out.println("kpressed"+key);
    }
    public void keyReleased(KeyEvent e){
    }
    public void mousePressed(MouseEvent me) {
        requestFocus();
        mprocess(me);
//System.out.println("mousePressed");
    }
    public void mouseReleased(MouseEvent e) {
    }
    public void mouseEntered(MouseEvent e) {
    }
    public void mouseExited(MouseEvent e) {
    }
    public void mouseClicked(MouseEvent e) {
    }
    public void mprocess(MouseEvent evt){
        if(xc!=null){
            xc.mprocess(evt,xc);
        }
    }
    public void process(KeyEvent evt){
        int key=evt.getKeyCode();
            if(key==27){
                xc.running=false;
                remove(xc);
                init();
            }
    }
}
class XCanvasDarkwarBase extends JPanel implements Runnable{
    Thread t;
    DarkwarBase db;
    int width;
    int height;
    Image img;
    Graphics h;
    boolean running=true;
    SpaceShip[]sp=new SpaceShip[100];
    Kugel[]kugeln=new Kugel[500];
    int[]starsx=new int[500];
    int[]starsy=new int[500];
    int[]starsm=new int[500];
    int[]teilliste=new int[32];
    int treffer;
    int[]basex=new int[10];
    int[]basey=new int[10];
    int[]baseart=new int[10];
    int[]baseactive=new int[10];
    int framex;
    int framey;
    CannonOrBomb start;
    CannonOrBomb end;
    boolean painted=true;
    int enemies=0;
    private static final long serialVersionUID = -3424517590734201124L;
    public XCanvasDarkwarBase(DarkwarBase db,int width,int height){
        this.db=db;
        this.width=width;
        this.height=height;
        start=new CannonOrBomb(1000,1000,1);
        end=start;
        framex=1000-width/2;
        framey=1000-height/2;
        ImFrameDarkwarBase im=new ImFrameDarkwarBase(width+200,height+200);
        img=im.img;
        h=img.getGraphics();
        t=new Thread(this);
        t.start();
    }
    public synchronized void mprocess(MouseEvent evt,XCanvasDarkwarBase xc){
        int state=db.state;
        int teil=db.teil;
        CannonOrBomb cb=db.cb;
            int x=evt.getX();
            int y=evt.getY()-40;
            if(state==0){
                if(y<20&&y>=0&&x>=0&&x<640){
                    int ipos=x/20;
                    teil=xc.teilliste[ipos];
                    xc.teilliste[ipos]=0;
                    if(teil!=0){
                        state=1;
                    }
                }
                else if(xc.isinframe(xc.framex,xc.framey-20)&&y>=20&&y<40&&x>=0&&x<640){
                    xc.framey=xc.framey-20;
                }
                else if(xc.isinframe(xc.framex,xc.framey+20)&&y>=460&&y<480&&x>=0&&x<640){
                    xc.framey=xc.framey+20;
                }
                else if(xc.isinframe(xc.framex-20,xc.framey)&&x<20&&x>=0&&y>=20&&y<480){
                    xc.framex=xc.framex-20;
                }
                else if(xc.isinframe(xc.framex+20,xc.framey)&&x<640&&x>=620&&y>=20&&y<480){
                    xc.framex=xc.framex+20;
                }
                else{
                    cb=xc.start;
                    while(cb!=null){
                        double diff=Math.sqrt((cb.x+10-xc.framex-x)*(cb.x+10-xc.framex-x)+(cb.y+10-xc.framey-y)*(cb.y+10-xc.framey-y));
                        if(diff<12&&cb.art>=1&&cb.art<4){
                            state=2;
                            db.state=state;
                            db.cb=cb;
                            return;
                        }
                        cb=cb.next;
                    }
                }
            }
            else if(state==1){
                if(x>=0&&x<640&&y>=20){
                    xc.end.next=new CannonOrBomb(xc.framex+x,xc.framey+y,teil);
                    xc.end=xc.end.next;
                    state=0;
                }
            }
            else if(state==2){
                if(x>=0&&x<640&&y>=20){
                    int diffx=xc.framex+x-cb.x-10;
                    int diffy=xc.framey+y-cb.y-10;
                    double len=Math.sqrt(diffx*diffx+diffy*diffy);
                    double alpha=Math.atan((double)diffy/diffx);
                    if(diffx<0){
                        alpha=alpha+Math.PI;
                    }
                    xc.addkugel(cb.x+10,cb.y+10,alpha,true);
                    state=0;
                }
            }
            db.state=state;
            db.teil=teil;
    }
    public boolean isinframe(int x,int y){
        CannonOrBomb cur=start;
        while(cur!=null){
            double diffx=cur.x+10-x;
            double diffy=cur.y+10-y;
            if(diffx>=0&&diffx<width&&diffy>=20&&diffy<height){
                return true;
            }
            cur=cur.next;
        }
        return false;
    }
    public void addkugel(double xp,double yp,double alpha,boolean yours){
        int ipos=0;
        while(kugeln[ipos]!=null&&ipos<500){
            ipos++;
        }
        if(ipos==500){
            ipos=(int)(Math.random()*500);
        }
        kugeln[ipos]=new Kugel(xp,yp,Math.cos(alpha)*6,Math.sin(alpha)*6,yours);
    }
    public void addteil(int teil){
        int ipos=0;
        while(ipos<32){
            if(teilliste[ipos]==0){
                teilliste[ipos]=teil;
                return;
            }
            ipos++;
        }
        for(int i=0;i<31;i++){
            teilliste[i]=teilliste[i+1];
        }
        teilliste[31]=teil;
    }
    public synchronized void createworld(){
        for(int i=0;i<500;i++){
            starsx[i]=(int)(Math.random()*2000);
            starsy[i]=(int)(Math.random()*2000);
            starsm[i]=(int)(Math.random()*3)+1;
        }
        for(int i=0;i<10;i++){
            boolean notfound=true;
            int bx=1000;
            int by=1000;
            while(notfound){
                bx=(int)(Math.random()*2000);
                by=(int)(Math.random()*2000);
                if((bx<900-width/2||bx>1100+width/2)||(by<900-height/2||by>1100+height/2)){
                    notfound=false;
                }
            }
            basex[i]=bx;
            basey[i]=by;
            baseart[i]=(int)(Math.random()*3)+1;
        }
    }
    public void run(){
        createworld();
        while(running){
            try{
                Thread.sleep(100);
                painted=false;
                repaint();
            }
            catch(Exception e){
                e.printStackTrace(System.out);
            }
        }
    }
//    public void paint(Graphics g){
//    }
    public synchronized void paint(Graphics g){
        if(painted){
            return;
        }
        h.setColor(Color.black);
        h.fillRect(0,0,width+200,height+200);
        h.setColor(Color.white);
        h.drawRect(100,121,640,2);
        for(int i=0;i<500;i++){
            if(starsx[i]>=framex&&starsx[i]<framex+width&&starsy[i]>=framey&&starsy[i]<framey+height){
                h.fillOval(starsx[i]-framex+100-1,starsy[i]-framey+100-1,starsm[i],starsm[i]);
            }
        }
        for(int i=0;i<10;i++){
            if(baseactive[i]==0&&basex[i]>=framex&&basex[i]<framex+width&&basey[i]>=framey&&basey[i]<framey+height){
                if(baseart[i]==1){
                    h.drawImage(db.base1,basex[i]-framex+100-1,basey[i]-framey+100-1,this);
                }
                if(baseart[i]==2){
                    h.drawImage(db.base2,basex[i]-framex+100-1,basey[i]-framey+100-1,this);
                }
                if(baseart[i]==3){
                    h.drawImage(db.base3,basex[i]-framex+100-1,basey[i]-framey+100-1,this);
                }
            }
            if(baseactive[i]==0){
                if((int)(Math.random()*200)==0){
                    int c=0;
                    CannonOrBomb cb=start;
                    while(cb!=null){
                        cb=cb.next;
                        c++;
                    }
                    int pos=(int)(Math.random()*c-1);
                    CannonOrBomb cm=start;
                    for(int j=0;j<pos;j++){
                        cm=cm.next;
                    }
                    double xdiff=cm.x-basex[i];
                    double ydiff=cm.y-basey[i];
                    double len=Math.sqrt(xdiff*xdiff+ydiff*ydiff);
                    double alpha=Math.atan(ydiff/xdiff);
                    if(xdiff<0){
                        alpha=alpha+Math.PI;
                    }
                    double alphaplus=Math.random()*Math.PI/8-Math.PI/16;
                    double spxd=Math.cos(alpha+alphaplus);
                    double spyd=Math.sin(alpha+alphaplus);
                    int zufall=(int)(Math.random()*10);
                    int bonusart=0;
                    if(zufall==0){
                        bonusart=7;
                    }
                    else if(zufall==1||zufall==2){
                        bonusart=(int)(Math.random()*3)+4;
                    }
                    else if(zufall==3||zufall==4){
                        bonusart=(int)(Math.random()*3)+1;
                    }
                    SpaceShip sp1=new SpaceShip(basex[i]+spxd*20,basey[i]+spyd*20,spxd*5,spyd*5,baseart[i],bonusart,alpha+alphaplus);
                    int spi=0;
                    while(spi<100&&sp[spi]!=null){
                        spi++;
                    }
                    if(spi==100){
                        spi=(int)(Math.random()*100);
                    }
                    sp[spi]=sp1;
                }
            }
        }
        CannonOrBomb cur=start;
        while(cur!=null){
            if(cur.active==0){
                for(int i=0;i<100;i++){
                    if(sp[i]!=null){
                        double len=Math.sqrt((sp[i].x-cur.x)*(sp[i].x-cur.x)+(sp[i].y-cur.y)*(sp[i].y-cur.y));
                        if(len<20){
                            if(cur.art<4){
                                cur.active=1;
                            }
                            else if(cur.art<7){
                                cur.explo=10;
                            }
                        }
                    }
                }
                for(int i=0;i<500;i++){
                    if(kugeln[i]!=null&&!kugeln[i].yours){
                        double len=Math.sqrt((kugeln[i].x-cur.x)*(kugeln[i].x-cur.x)+(kugeln[i].y-cur.y)*(kugeln[i].y-cur.y));
                        if(len<12){
                            if(cur.art>=4&&cur.art<7){
                                cur.explo=10;
                            }
                            if(cur.art<4){
                                cur.active=1;
                            }
                            kugeln[i]=null;
                        }
                    }
                }
            }
            if(cur.active==0&&cur.explo>0){
                h.setColor(Color.white);
                for(int i=0;i<cur.explo;i=i+3){
                    h.drawOval(cur.x-i/2-framex+100+10,cur.y-i/2-framey+100+10,i,i);
                }
                cur.explo=cur.explo+10;
                if(cur.explo>100){
                    cur.active=1;
                }
                for(int i=0;i<100;i++){
                    if(sp[i]!=null&&sp[i].fire==0){
                        double len=Math.sqrt((sp[i].x-cur.x-10)*(sp[i].x-cur.x-10)+(sp[i].y-cur.y-10)*(sp[i].y-cur.y-10));
                        if(len<cur.explo){
                            sp[i].fire=1;
                            addteil(sp[i].bonus);
                        }
                    }
                }
                for(int i=0;i<10;i++){
                    if(baseactive[i]==0){
                        if(baseart[i]==cur.art-3){
                            double len=Math.sqrt((cur.x+10-basex[i])*(cur.x+10-basex[i])+(cur.y+10-basey[i])*(cur.y+10-basey[i]));
                            if(len<cur.explo){
                                baseactive[i]=1;
                            }
                        }
                    }
                }
                for(int i=0;i<500;i++){
                    if(kugeln[i]!=null){
                        double len=Math.sqrt((kugeln[i].x-cur.x-10)*(kugeln[i].x-cur.x-10)+(kugeln[i].y-cur.y-10)*(kugeln[i].y-cur.y-10));
                        if(len<cur.explo){
                            kugeln[i]=null;
                        }
                    }
                }
            }
            if(cur.art==1&&cur.active==0){
                h.drawImage(db.cannon1,cur.x-framex+100,cur.y-framey+100,this);
            }
            else if(cur.art==2&&cur.active==0){
                h.drawImage(db.cannon2,cur.x-framex+100,cur.y-framey+100,this);
            }
            else if(cur.art==3&&cur.active==0){
                h.drawImage(db.cannon3,cur.x-framex+100,cur.y-framey+100,this);
            }
            else if(cur.art==4&&cur.active==0){
                h.drawImage(db.bomb1,cur.x-framex+100,cur.y-framey+100,this);
            }
            else if(cur.art==5&&cur.active==0){
                h.drawImage(db.bomb2,cur.x-framex+100,cur.y-framey+100,this);
            }
            else if(cur.art==6&&cur.active==0){
                h.drawImage(db.bomb3,cur.x-framex+100,cur.y-framey+100,this);
            }
            else if(cur.art==7&&cur.active==0){
                h.drawImage(db.absorber,cur.x-framex+100,cur.y-framey+100,this);
            }
            cur=cur.next;
        }
        for(int i=0;i<100;i++){
            if(sp[i]!=null){
                int m=(int)(Math.random()*100);
                if(m==0){
                    addkugel(sp[i].x+10,sp[i].y+10,sp[i].alpha,false);
                }
                sp[i].x=sp[i].x+sp[i].xdrift;
                sp[i].y=sp[i].y+sp[i].ydrift;
                if(sp[i].x>=framex-100&&sp[i].x<framex+width+100&&sp[i].y>=framey-100&&sp[i].y<framey+height+100){
                    if(sp[i].fire==0){
                        if(sp[i].art==1){
                            h.drawImage(db.spaceship1,(int)sp[i].x-framex+100,(int)sp[i].y-framey+100,this);
                        }
                        else if(sp[i].art==2){
                            h.drawImage(db.spaceship2,(int)sp[i].x-framex+100,(int)sp[i].y-framey+100,this);
                        }
                        else if(sp[i].art==3){
                            h.drawImage(db.spaceship3,(int)sp[i].x-framex+100,(int)sp[i].y-framey+100,this);
                        }
                    }
                    else if(sp[i].fire<4){
                        if(sp[i].fire==1){
                            h.drawImage(db.fire1,(int)sp[i].x-framex+100,(int)sp[i].y-framey+100,this);
                        }
                        else if(sp[i].fire==2){
                            h.drawImage(db.fire2,(int)sp[i].x-framex+100,(int)sp[i].y-framey+100,this);
                        }
                        else if(sp[i].fire==3){
                            h.drawImage(db.fire3,(int)sp[i].x-framex+100,(int)sp[i].y-framey+100,this);
                        }
                        sp[i].fire++;
                    }
                    else{
                        sp[i]=null;
                        enemies++;
                    }
                }
                if(sp[i]!=null&&(sp[i].x<0||sp[i].y<0||sp[i].x>2000||sp[i].y>2000)){
                    sp[i]=null;
                }
                for(int j=0;sp[i]!=null&&j<500;j++){
                    if(kugeln[j]!=null&&kugeln[j].yours){
                        double entf=Math.sqrt((sp[i].x+10-kugeln[j].x)*(sp[i].x+10-kugeln[j].x)+(sp[i].y+10-kugeln[j].y)*(sp[i].y+10-kugeln[j].y));
                        if(entf<12){
                            sp[i].fire=1;
                            addteil(sp[i].bonus);
                            kugeln[j]=null;
                        }
                    }
                }
            }
        }
        for(int i=0;i<500;i++){
            if(kugeln[i]!=null){
                kugeln[i].x=kugeln[i].x+kugeln[i].xdrift;
                kugeln[i].y=kugeln[i].y+kugeln[i].ydrift;
                if(kugeln[i].x>=framex&&kugeln[i].x<framex+width&&kugeln[i].y>=framey&&kugeln[i].y<framey+height){
                    if(kugeln[i].yours){
                        h.setColor(Color.green);
                        h.fillOval((int)kugeln[i].x-framex-1+100,(int)kugeln[i].y-framey-1+100,2,2);
                    }
                    else{
                        h.setColor(Color.red);
                        h.fillOval((int)kugeln[i].x-framex-1+100,(int)kugeln[i].y-framey-1+100,2,2);
                    }
                }
                if(kugeln[i].counter>50){
                    kugeln[i]=null;
                }
                else{
                    kugeln[i].counter++;
                }
            }
        }
        for(int i=0;i<32;i++){
            if(teilliste[i]==1){
                h.drawImage(db.cannon1,100+i*20,100,this);
            }
            else if(teilliste[i]==2){
                h.drawImage(db.cannon2,100+i*20,100,this);
            }
            else if(teilliste[i]==3){
                h.drawImage(db.cannon3,100+i*20,100,this);
            }
            else if(teilliste[i]==4){
                h.drawImage(db.bomb1,100+i*20,100,this);
            }
            else if(teilliste[i]==5){
                h.drawImage(db.bomb2,100+i*20,100,this);
            }
            else if(teilliste[i]==6){
                h.drawImage(db.bomb3,100+i*20,100,this);
            }
            else if(teilliste[i]==7){
                h.drawImage(db.absorber,100+i*20,100,this);
            }
        }
        boolean existing=false;
        for(int i=0;i<10;i++){
            if(baseactive[i]==0){
                existing=true;
            }
        }
        if(!existing){
            h.setColor(Color.white);
            h.drawString("You have won! Enemies: "+enemies,120,140);
        }
        else{
            h.setColor(Color.white);
            h.drawString("Darkwar Base Enemies: "+enemies,120,140);
        }
        g.drawImage(img,-100,-100,this);
//        paint(g);
        painted=true;
    }
}
class SpaceShip{
    int art;
    double x;
    double y;
    double xdrift;
    double ydrift;
    int bonus;
    int fire=0;
    double alpha;
    public SpaceShip(double x,double y,double xdrift,double ydrift,int art,int bonus,double alpha){
        this.x=x;
        this.y=y;
        this.xdrift=xdrift;
        this.ydrift=ydrift;
        this.art=art;
        this.bonus=bonus;
        this.alpha=alpha;
    }
}
class Kugel{
    double x;
    double y;
    double xdrift;
    double ydrift;
    int counter;
    boolean yours=false;
    public Kugel(double x,double y,double xdrift,double ydrift,boolean yours){
        this.x=x;
        this.y=y;
        this.xdrift=xdrift;
        this.ydrift=ydrift;
        this.yours=yours;
    }
}
class CannonOrBomb{
    int art;
    int x;
    int y;
    CannonOrBomb next;
    int active=0;
    int explo=0;
    public CannonOrBomb(int x,int y,int art){
        this.x=x;
        this.y=y;
        this.art=art;
    }
}
class ImFrameDarkwarBase extends JFrame{
    Image img;
    private static final long serialVersionUID = -5324593524211057483L;
    public ImFrameDarkwarBase(int w,int h){
        pack();
        img=createImage(w,h);
    }
}
