#define APP_NAME                "Astro Solutions Planet Velocity"
#define _USE_MATH_DEFINES 
#pragma comment (lib, "wsock32.lib")
#include <cstdio>
#include <cstdlib>
#include "gl/glut.h"
#include "TextureLoader.h"
#include <math.h>
#include<string>
using namespace std;
#include <sstream>
#include <windows.h>
#include <gl\gl.h> // Header File For The OpenGL32 Library
#include <gl\glu.h> // Header File For The GLu32 Library
#include "List.h"
#include "ListElem.h"
#include <time.h>
#include<iostream>
#include<fstream>
#include<string>
#include "StreamList.h"
#include "StreamlistElem.h"

float* flightb=new float[9];
int* imh=new int(0);
int* imw=new int(0);
void *font = GLUT_BITMAP_9_BY_15;
int winW = 800; /* window width */
int winH = 600; /* window height */
int mode=1;
int kchanged=0;
int keynr=0;
int changed=0;
int loso=0;
int rev=0;
float ac1=0;
float ac2=0;
float ac3=0;
List* liste;
int leftb=0;
int rightb=0;
int upb=0;
int downb=0;
int enterb=0;
int plusb=0;
int minusb=0;
float mpin=(float)M_PI;
float xpos=0;
float ypos=0;
float zpos=1400;
float xdrift=0;
float ydrift=1;
float zdrift=0;
float upxd=0;
float upyd=0;
float upzd=1;
float rightxd=1;
float rightyd=0;
float rightzd=0;
float drehmat[3][3];
float result[3];
int newgame=1;
int planet[48][24];
int kugelactive[250];
float kugelx[250];
float kugely[250];
float kugelz[250];
int kugeltype[250];
float kugeldx[250];
float kugeldy[250];
float kugeldz[250];
int gegneractive[50];
int gegnertype[50];
int gegnercount[50];
float gegnerx[50];
float gegnery[50];
float gegnerz[50];
float gegneralpha[50];
float gegnerbeta[50];
int treffer=0;
int lifes=3;
float wxv=3*mpin/2;
float wyv=3*mpin/2;
int level=0;
string* files=new string[0];
glTexture* glt=new glTexture[0];
static void remotekeyboard(void);
StreamList* sl;
DWORD WINAPI ServerThread(void *par);
DWORD WINAPI Changer(void *par);
static void getImages(void){
	srand ( time(NULL) );
    files=new string[13];
    glt=new glTexture[13];
    files[0]=*(new string("planet1.gif"));
    files[1]=*(new string("planet2.gif"));
    files[2]=*(new string("planet3.gif"));
    files[3]=*(new string("planet4.gif"));
    files[4]=*(new string("back.gif"));
    files[5]=*(new string("side1.gif"));
    files[6]=*(new string("side2.gif"));
    files[7]=*(new string("side3.gif"));
    files[8]=*(new string("side4.gif"));
    files[9]=*(new string("side5.gif"));
    files[10]=*(new string("explo1.gif"));
    files[11]=*(new string("explo2.gif"));
    files[12]=*(new string("explo3.gif"));
}
void rotate(float x,float y,float z,float angle,float xv,float yv,float zv){
    float entf=sqrt(x*x+y*y+z*z);
    float n1=x/entf;
    float n2=y/entf;
    float n3=z/entf;
    drehmat[0][0]=1-(n2*n2+n3*n3)*(1-cos(angle));
    drehmat[0][1]=n1*n2*(1-cos(angle))+n3*sin(angle);
    drehmat[0][2]=n1*n3*(1-cos(angle))-n2*sin(angle);
    drehmat[1][0]=n1*n2*(1-cos(angle))-n3*sin(angle);
    drehmat[1][1]=1-(n1*n1+n3*n3)*(1-cos(angle));
    drehmat[1][2]=n2*n3*(1-cos(angle))+n1*sin(angle);
    drehmat[2][0]=n1*n3*(1-cos(angle))+n2*sin(angle);
    drehmat[2][1]=n2*n3*(1-cos(angle))-n1*sin(angle);
    drehmat[2][2]=1-(n1*n1+n2*n2)*(1-cos(angle));
    float a=xv*drehmat[0][0];
    float b=xv*drehmat[1][0];
    float c=xv*drehmat[2][0];
    a=a+yv*drehmat[0][1];
    b=b+yv*drehmat[1][1];
    c=c+yv*drehmat[2][1];
    a=a+zv*drehmat[0][2];
    b=b+zv*drehmat[1][2];
    c=c+zv*drehmat[2][2];
    result[0]=a;
    result[1]=b;
    result[2]=c;
}
void invrev(void){
	if(rev==0){
		rev=1;
	}
	else{
		rev=0;
	}
}
void drehmalrechts(void){
	rotate(upxd,upyd,upzd,mpin/90,xdrift,ydrift,zdrift);
	xdrift=result[0];
	ydrift=result[1];
	zdrift=result[2];
	rotate(upxd,upyd,upzd,mpin/90,rightxd,rightyd,rightzd);
	rightxd=result[0];
	rightyd=result[1];
	rightzd=result[2];
}
void drehmallinks(void){
	rotate(upxd,upyd,upzd,-mpin/90,xdrift,ydrift,zdrift);
	xdrift=result[0];
	ydrift=result[1];
	zdrift=result[2];
	rotate(upxd,upyd,upzd,-mpin/90,rightxd,rightyd,rightzd);
	rightxd=result[0];
	rightyd=result[1];
	rightzd=result[2];
}
void drehmalunten(void){
	rotate(rightxd,rightyd,rightzd,mpin/90,xdrift,ydrift,zdrift);
	xdrift=result[0];
	ydrift=result[1];
	zdrift=result[2];
	rotate(rightxd,rightyd,rightzd,mpin/90,upxd,upyd,upzd);
	upxd=result[0];
	upyd=result[1];
	upzd=result[2];
}
void drehmaloben(void){
	rotate(rightxd,rightyd,rightzd,-mpin/90,xdrift,ydrift,zdrift);
	xdrift=result[0];
	ydrift=result[1];
	zdrift=result[2];
	rotate(rightxd,rightyd,rightzd,-mpin/90,upxd,upyd,upzd);
	upxd=result[0];
	upyd=result[1];
	upzd=result[2];
}
void output(int x, int y, const char *string)
{
  int len, i;

  len = (int) strlen(string);
  for (i = 0; i < len; i++) {
    glutBitmapCharacter(font, string[i]);
  }
}
static int randb(int max){
    if(max==0){
        return 0;
    }
    int ret=rand();
    if(ret<0){
        return ((-ret)%max);
    }
    return ret%max;
}
static void buildworld(void){
    srand(time(NULL));
    for(int i=0;i<250;i++){
        kugelactive[i]=0;
    }
    for(int i=0;i<50;i++){
        gegneractive[i]=0;
    }
}
static void createworld(void){
    liste=new List();
    for(int i=0;i<50;i++){
        if(gegneractive[i]==1){
            float vorausz=(float)cos(gegnerbeta[i])*64;
            float vorausw=(float)sin(gegnerbeta[i])*64;
            float vorausy=(float)sin(gegneralpha[i])*vorausw;
            float vorausx=(float)cos(gegneralpha[i])*vorausw;

            float upz=(float)cos(gegnerbeta[i]+mpin/2)*32;
            float upw=(float)sin(gegnerbeta[i]+mpin/2)*32;
            float upy=(float)sin(gegneralpha[i])*upw;
            float upx=(float)cos(gegneralpha[i])*upw;

            float leftz=(float)cos(mpin/2)*32;
            float leftw=(float)sin(mpin/2)*32;
            float lefty=(float)sin(gegneralpha[i]-mpin/2)*leftw;
            float leftx=(float)cos(gegneralpha[i]-mpin/2)*leftw;

            int xp=gegnerx[i];
            int yp=gegnery[i];
            int zp=gegnerz[i];
            int backart=4;
            if(gegnertype[i]==5){
                backart=10+randb(3);
            }
            int sideart=gegnertype[i]+5;
            if(sideart==10){
                sideart=sideart+randb(3);
            }
            ListElem* back=new ListElem(xp+leftx+upx,yp+lefty+upy,zp+leftz+upz,xp-leftx+upx,yp-lefty+upy,zp-leftz+upz,xp-leftx-upx,yp-lefty-upy,zp-leftz-upz,xp+leftx-upx,yp+lefty-upy,zp+leftz-upz,backart);
            liste->add(back);
            ListElem* side1=new ListElem(xp+leftx+upx,yp+lefty+upy,zp+leftz+upz,xp+vorausx,yp+vorausy,zp+vorausz,xp-leftx+upx,yp-lefty+upy,zp-leftz+upz,sideart);
            liste->add(side1);
            ListElem* side2=new ListElem(xp+leftx-upx,yp+lefty-upy,zp+leftz-upz,xp+vorausx,yp+vorausy,zp+vorausz,xp-leftx-upx,yp-lefty-upy,zp-leftz-upz,sideart);
            liste->add(side2);
            ListElem* side3=new ListElem(xp+leftx+upx,yp+lefty+upy,zp+leftz+upz,xp+vorausx,yp+vorausy,zp+vorausz,xp+leftx-upx,yp+lefty-upy,zp+leftz-upz,sideart);
            liste->add(side3);
            ListElem* side4=new ListElem(xp-leftx+upx,yp-lefty+upy,zp-leftz+upz,xp+vorausx,yp+vorausy,zp+vorausz,xp-leftx-upx,yp-lefty-upy,zp-leftz-upz,sideart);
            liste->add(side4);
        }
    }
    for(int i=0;i<48;i++){
        float firstbeta=1.0f/12.0f*mpin/2;
        float firstz=cos(firstbeta)*1200;
        float firstw=sin(firstbeta)*1200;
        float firstx1=cos((float)i/48.0f*mpin*2.0f)*firstw;
        float firsty1=sin((float)i/48.0f*mpin*2.0f)*firstw;
        float firstx2=cos((float)(i+1)/48.0f*mpin*2.0f)*firstw;
        float firsty2=sin((float)(i+1)/48.0f*mpin*2.0f)*firstw;
        int art=planet[i][0];
		if(newgame==1){
		    art=randb(4);
			planet[i][0]=art;
		}
        ListElem* cronpart=new ListElem(firstx1,firsty1,firstz,0,0,1200,firstx2,firsty2,firstz,art);
        liste->add(cronpart);
    }
    for(int j=1;j<23;j++){
        for(int i=0;i<48;i++){
            float firstbeta=((float)j)/12.0f*mpin/2;
            float firstz=cos(firstbeta)*1200;
            float firstw=sin(firstbeta)*1200;
            float firstx1=cos((float)i/48.0f*mpin*2.0f)*firstw;
            float firsty1=sin((float)i/48.0f*mpin*2.0f)*firstw;
            float firstx2=cos((float)(i+1)/48.0f*mpin*2.0f)*firstw;
            float firsty2=sin((float)(i+1)/48.0f*mpin*2.0f)*firstw;

            float secondbeta=((float)(j+1))/12.0f*mpin/2;
            float secondz=cos(secondbeta)*1200;
            float secondw=sin(secondbeta)*1200;
            float secondx1=cos((float)i/48.0f*mpin*2.0f)*secondw;
            float secondy1=sin((float)i/48.0f*mpin*2.0f)*secondw;
            float secondx2=cos((float)(i+1)/48.0f*mpin*2.0f)*secondw;
            float secondy2=sin((float)(i+1)/48.0f*mpin*2.0f)*secondw;
            int art=planet[i][j];
			if(newgame==1){
                art=randb(4);
				planet[i][j]=art;
			}
            ListElem* middlepart=new ListElem(firstx1,firsty1,firstz,firstx2,firsty2,firstz,secondx2,secondy2,secondz,secondx1,secondy1,secondz,art);
            liste->add(middlepart);
        }
    }
    for(int i=0;i<48;i++){
        float firstbeta=23.0f/12.0f*mpin/2;
        float firstz=cos(firstbeta)*1200;
        float firstw=sin(firstbeta)*1200;
        float firstx1=cos((float)i/48.0f*mpin*2.0f)*firstw;
        float firsty1=sin((float)i/48.0f*mpin*2.0f)*firstw;
        float firstx2=cos((float)(i+1)/48.0f*mpin*2.0f)*firstw;
        float firsty2=sin((float)(i+1)/48.0f*mpin*2.0f)*firstw;
		int art=planet[i][23];
		if(newgame==1){
            art=randb(4);
			planet[i][23]=art;
		}
        ListElem* bodypart=new ListElem(firstx1,firsty1,firstz,0,0,-1200,firstx2,firsty2,firstz,art);
        liste->add(bodypart);
    }
	newgame=0;
}
static void move(void){
    loso=0;
    float vz=(float)cos(wyv)*16;
    float vw=(float)sin(wyv)*16;
    float vy=(float)sin(wxv)*vw;
    float vx=(float)cos(wxv)*vw;
    xpos=xpos+xdrift*16;
    ypos=ypos+ydrift*16;
    zpos=zpos+zdrift*16;
	if(sqrt(xpos*xpos+ypos*ypos+zpos*zpos)<1200){
        loso=1;
	}
    if(randb(25)==0){
        float wx=randb(1000)/1000.0f*mpin*2;
        float wy=randb(500)/500.0f*mpin;
        float addv=randb(600);
        float zpoint=(float)cos(wy)*(1400+addv);
        float wpoint=(float)sin(wy)*(1400+addv);
        float ypoint=(float)sin(wx)*wpoint;
        float xpoint=(float)cos(wx)*wpoint;
        float xdrift=(float)cos(wx+mpin/2);
        float ydrift=(float)sin(wx+mpin/2);
        int k=0;
        while(k<50&&gegneractive[k]==1){
            k++;
        }
        if(k==50){
            k=randb(50);
        }
        gegnertype[k]=randb(level+1);
        gegneractive[k]=1;
        gegnerx[k]=xpoint-xdrift*1500;
        gegnery[k]=ypoint-ydrift*1500;
        gegnerz[k]=zpoint;
        gegnerbeta[k]=mpin/2;
        gegneralpha[k]=wx+mpin/2;
    }
    for(int i=0;i<50;i++){
        if(gegneractive[i]==1){

            float diffx=xpos-gegnerx[i];
			float diffy=ypos-gegnery[i];
			float diffz=zpos-gegnerz[i];
			float bodenlen=sqrt(diffx*diffx+diffy*diffy);
            float beta1=mpin/2;
			if(bodenlen!=0){
				beta1=atan(diffz/bodenlen);
			}
            float beta2=-beta1+mpin/2;
            float alpha1=0;
			if(diffx!=0){
				alpha1=atan(diffy/diffx);
			}
			else{
				if(diffy>0){
					alpha1=mpin/2;
				}
				else{
					alpha1=-mpin/2;
				}
			}
			if(diffx<0){
				alpha1=alpha1+mpin;
			}
			if(gegnerbeta[i]>beta2){
				gegnerbeta[i]=gegnerbeta[i]-mpin/180*(gegnertype[i]+1);
			}
			if(gegnerbeta[i]<beta2){
				gegnerbeta[i]=gegnerbeta[i]+mpin/180*(gegnertype[i]+1);
			}
			if(gegneralpha[i]>alpha1){
				gegneralpha[i]=gegneralpha[i]-mpin/180*(gegnertype[i]+1);
			}
			if(gegneralpha[i]<alpha1){
				gegneralpha[i]=gegneralpha[i]+mpin/180*(gegnertype[i]+1);
			}

            float vorausz=(float)cos(gegnerbeta[i])*(8+gegnertype[i]);
            float vorausw=(float)sin(gegnerbeta[i])*(8+gegnertype[i]);
            float vorausy=(float)sin(gegneralpha[i])*vorausw;
            float vorausx=(float)cos(gegneralpha[i])*vorausw;
            gegnerx[i]=gegnerx[i]+vorausx;
            gegnery[i]=gegnery[i]+vorausy;
            gegnerz[i]=gegnerz[i]+vorausz;
            int rande=randb(30);
            if(rande==0){
                int k=0;
                while(k<250&&kugelactive[k]==1){
                    k++;
                }
                if(k==250){
                    k=randb(250);
                }
                kugelactive[k]=1;
                kugeltype[k]=2;
                kugelx[k]=gegnerx[i]+vorausx*2;
                kugely[k]=gegnery[i]+vorausy*2;
                kugelz[k]=gegnerz[i]+vorausz*2;
                kugeldx[k]=vorausx*2;
                kugeldy[k]=vorausy*2;
                kugeldz[k]=vorausz*2;
            }
            float diff=sqrt((gegnerx[i]-xpos)*(gegnerx[i]-xpos)+(gegnery[i]-ypos)*(gegnery[i]-ypos)+(gegnerz[i]-zpos)*(gegnerz[i]-zpos));
            if(diff<48){
                loso=1;
            }
            float ediff=sqrt((gegnerx[i]*gegnerx[i])+(gegnery[i]*gegnery[i])+(gegnerz[i]*gegnerz[i]));
            if(gegnertype[i]<=4&&(ediff<1200||gegnerx[i]>3000||gegnery[i]>3000||gegnerz[i]>3000)){
                gegneractive[i]=0;
//                gegnertype[i]=5;
//                gegnercount[i]=10;
            }
            for(int j=0;j<250;j++){
                if(kugelactive[j]==1&&kugeltype[j]==1&&gegnertype[i]<5){
                    float kdiff=sqrt((kugelx[j]-gegnerx[i])*(kugelx[j]-gegnerx[i])+(kugely[j]-gegnery[i])*(kugely[j]-gegnery[i])+(kugelz[j]-gegnerz[i])*(kugelz[j]-gegnerz[i]));
                    if(kdiff<48&&gegnertype[i]<=4){
                        gegnercount[i]=10;
                        gegnertype[i]=5;
                        treffer=treffer+1;
						if(treffer%25==0){
							level=level+1;
						}
                        kugelactive[j]=0;
                    }
                }
            }
            if(gegnertype[i]==5){
                if(gegnercount[i]>0){
                    gegnercount[i]=gegnercount[i]-1;
                }
                else{
                    gegneractive[i]=0;
                }
            }
        }
    }
    for(int i=0;i<250;i++){
        if(kugelactive[i]==1){
            kugelx[i]=kugelx[i]+kugeldx[i];
            kugely[i]=kugely[i]+kugeldy[i];
            kugelz[i]=kugelz[i]+kugeldz[i];
            if(kugeltype[i]==2){
                float kdiff2=sqrt((kugelx[i]-xpos)*(kugelx[i]-xpos)+(kugely[i]-ypos)*(kugely[i]-ypos)+(kugelz[i]-zpos)*(kugelz[i]-zpos));
                if(kdiff2<48){
                    kugelactive[i]=0;
                    loso=1;
                }
            }
			if(kugelx[i]>3000||kugely[i]>3000||kugelz[i]>3000){
				kugelactive[i]=0;
			}
        }
    }
    if(loso==1){
        lifes=lifes-1;
        loso=0;
		xpos=0;
		ypos=0;
		zpos=1400;
		xdrift=0;
        ydrift=1;
		zdrift=0;
		upxd=0;
		upyd=0;
		upzd=1;
		rightxd=1;
		rightyd=0;
		rightzd=0;
        wxv=-M_PI/2;
        wyv=-M_PI/2;
    }
}
void drawElem(ListElem* se){
    if(se->quad==0){
        glEnable(GL_TEXTURE_2D);
	if(se->art==0){
            glBindTexture(GL_TEXTURE_2D,glt[0].TextureID);
        }
        else if(se->art==1){
            glBindTexture(GL_TEXTURE_2D,glt[1].TextureID);
        }
        else if(se->art==2){
            glBindTexture(GL_TEXTURE_2D,glt[2].TextureID);
        }
        else if(se->art==3){
            glBindTexture(GL_TEXTURE_2D,glt[3].TextureID);
        }
        else if(se->art==4){
            glBindTexture(GL_TEXTURE_2D,glt[4].TextureID);
        }
        else if(se->art==5){
            glBindTexture(GL_TEXTURE_2D,glt[5].TextureID);
        }
        else if(se->art==6){
            glBindTexture(GL_TEXTURE_2D,glt[6].TextureID);
        }
        else if(se->art==7){
            glBindTexture(GL_TEXTURE_2D,glt[7].TextureID);
        }
        else if(se->art==8){
            glBindTexture(GL_TEXTURE_2D,glt[8].TextureID);
        }
        else if(se->art==9){
            glBindTexture(GL_TEXTURE_2D,glt[9].TextureID);
        }
        else if(se->art==10){
            glBindTexture(GL_TEXTURE_2D,glt[10].TextureID);
        }
        else if(se->art==11){
            glBindTexture(GL_TEXTURE_2D,glt[11].TextureID);
        }
        else if(se->art==12){
            glBindTexture(GL_TEXTURE_2D,glt[12].TextureID);
        }
        glBegin(GL_TRIANGLES);
        glTexCoord2f(0.0f,1.0f);
        glVertex3f(se->x1,se->y1,se->z1);
        glTexCoord2f(0.5f,0.0f);
        glVertex3f(se->x2,se->y2,se->z2);
        glTexCoord2f(1.0f,1.0f);
        glVertex3f(se->x3,se->y3,se->z3);
        glEnd();
        glDisable(GL_TEXTURE_2D);
    }
    else{
        glEnable(GL_TEXTURE_2D);
	if(se->art==0){
            glBindTexture(GL_TEXTURE_2D,glt[0].TextureID);
        }
        else if(se->art==1){
            glBindTexture(GL_TEXTURE_2D,glt[1].TextureID);
        }
        else if(se->art==2){
            glBindTexture(GL_TEXTURE_2D,glt[2].TextureID);
        }
        else if(se->art==3){
            glBindTexture(GL_TEXTURE_2D,glt[3].TextureID);
        }
        else if(se->art==4){
            glBindTexture(GL_TEXTURE_2D,glt[4].TextureID);
        }
        else if(se->art==5){
            glBindTexture(GL_TEXTURE_2D,glt[5].TextureID);
        }
        else if(se->art==6){
            glBindTexture(GL_TEXTURE_2D,glt[6].TextureID);
        }
        else if(se->art==7){
            glBindTexture(GL_TEXTURE_2D,glt[7].TextureID);
        }
        else if(se->art==8){
            glBindTexture(GL_TEXTURE_2D,glt[8].TextureID);
        }
        else if(se->art==9){
            glBindTexture(GL_TEXTURE_2D,glt[9].TextureID);
        }
        else if(se->art==10){
            glBindTexture(GL_TEXTURE_2D,glt[10].TextureID);
        }
        else if(se->art==11){
            glBindTexture(GL_TEXTURE_2D,glt[11].TextureID);
        }
        else if(se->art==12){
            glBindTexture(GL_TEXTURE_2D,glt[12].TextureID);
        }
        glBegin(GL_QUADS);
        glTexCoord2f(0.0f,0.0f);
        glVertex3f(se->x1,se->y1,se->z1);
        glTexCoord2f(1.0f,0.0f);
        glVertex3f(se->x2,se->y2,se->z2);
        glTexCoord2f(1.0f,1.0f);
        glVertex3f(se->x3,se->y3,se->z3);
        glTexCoord2f(0.0f,1.0f);
        glVertex3f(se->x4,se->y4,se->z4);
        glEnd();
        glDisable(GL_TEXTURE_2D);
    }
}
void drawFace(void){
    for(int i=0;i<250;i++){
        if(kugelactive[i]==1){
            glPushMatrix();
            glPushAttrib(GL_CURRENT_BIT);
            if(kugeltype[i]==2){
                glColor3f(0.0f,1.0f,0.0f);
            }
            else{
                glColor3f(1.0f,0.0f,0.0f);
            }
            glTranslatef(kugelx[i],kugely[i],kugelz[i]);
            glutSolidSphere(8,20,20);
            glPopAttrib();
            glPopMatrix();
        }
    }
    ListElem* cur=liste->start;
    while(cur!=NULL){
        drawElem(cur);
        cur=cur->next;
    }
}
void changeLookAt(void)
{
	float z=(float)cos(wyv)*32;
	float w=(float)sin(wyv)*32;
	float y=(float)sin(wxv)*w;
	float x=(float)cos(wxv)*w;
        double wy2=wyv+M_PI/2;
        double wx2=wxv;
	float z2=(float)cos(wy2);
	float w2=(float)sin(wy2);
	float y2=(float)sin(wx2)*w2;
	float x2=(float)cos(wx2)*w2;
        flightb[0]=xpos;
        flightb[1]=ypos;
        flightb[2]=zpos;
        flightb[3]=xpos+xdrift*32;
        flightb[4]=ypos+ydrift*32;
        flightb[5]=zpos+zdrift*32;
        flightb[6]=upxd;
        flightb[7]=upyd;
        flightb[8]=upzd;
}
static void accelero(void){
	if(changed==1){
		if(ac1>=0.2){
			drehmalrechts();
		}
		if(ac1>=0.4){
			drehmalrechts();
		}
		if(ac1>=0.6){
			drehmalrechts();
		}
		if(ac1<=-0.2){
			drehmallinks();
		}
		if(ac1<=-0.4){
			drehmallinks();
		}
		if(ac1<=-0.6){
			drehmallinks();
		}
		if(ac2>=0.2){
			drehmaloben();
		}
		if(ac2>=0.4){
			drehmaloben();
		}
		if(ac2>=0.6){
			drehmaloben();
		}
		if(ac2<=-0.2){
			drehmalunten();
		}
		if(ac2<=-0.4){
			drehmalunten();
		}
		if(ac2<=-0.6){
			drehmalunten();
		}
	if(wyv<0){
		wyv=wyv+mpin*2;
	}
	if(wyv>mpin*2){
		wyv=wyv-mpin*2;
	}
		changed=0;
	}
}
static void timerCallback (int value) { 
	/* Do timer processing */ /* maybe glutPostRedisplay(), if necessary */ /* call back again after elapsedUSecs have passed */ 
//    remotekeyboard();
	move();
        createworld();
	glutPostRedisplay();
	glutTimerFunc (40, timerCallback, value);
} 
void glutDisplay (void)
{
	if (!winH)
        return;
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	changeLookAt();
	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity ();
	gluLookAt  ( flightb[0] , flightb[1] , flightb[2] , flightb[3] , flightb[4] , flightb[5] , flightb[6] , flightb[7] , flightb[8] );
    drawFace ();

    glPushMatrix();
    glLoadIdentity();
	gluLookAt(0,0,-2000,0,0,-400,0,1,0);
gluOrtho2D(0,0,winW,winH);
	glPushAttrib(GL_CURRENT_BIT);
  glColor3f(1.0f,1.0f,1.0f);
    glRasterPos3d(1400,1400,-400);
	stringstream sout;
        if(lifes<=0){
            sout<<"you have lost!";
        }
        else if(treffer>=125){
            sout<<"you have won!";
        }
        else{
            sout<<"level "<<(level+1)<<" lifes "<<lifes<<" hits "<<treffer;
        }
	output(0,0,sout.str().c_str());
	glPopAttrib();
	glPopMatrix();
	glutSwapBuffers();
}
void glutKeyboard (unsigned char key, int x, int y)
{
    	if(key==27){
            exit (1);
	}
	else if(key==32){
                int k=0;
                while(k<250&&kugelactive[k]==1){
                    k++;
                }
                if(k==250){
                    k=randb(250);
                }
                kugelactive[k]=1;
                kugeltype[k]=1;
            float vorausz=(float)cos(wyv);
            float vorausw=(float)sin(wyv);
            float vorausy=(float)sin(wxv)*vorausw;
            float vorausx=(float)cos(wxv)*vorausw;
                kugelx[k]=xpos+xdrift*32;
                kugely[k]=ypos+ydrift*32;
                kugelz[k]=zpos+zdrift*32;
                kugeldx[k]=xdrift*24;
                kugeldy[k]=ydrift*24;
                kugeldz[k]=zdrift*24;
	}
}
void special (int key, int x, int y)
{
    if(key==GLUT_KEY_RIGHT){
//        wxv=wxv-M_PI/90;
		drehmalrechts();
	changeLookAt();
    }
    else if(key==GLUT_KEY_RIGHT&&mode==0){
        rightb=1;
    }
    else if(key==GLUT_KEY_LEFT&&mode==0){
        leftb=1;
    }
    else if(key==GLUT_KEY_UP&&mode==0){
        upb=1;
    }
    else if(key==GLUT_KEY_DOWN&&mode==0){
        downb=1;
    }
    else if(key==GLUT_KEY_LEFT){
//        wxv=wxv+M_PI/90;
        drehmallinks();
		changeLookAt();
    }
    else if(key==GLUT_KEY_DOWN&&mode==1){
        wyv=wyv-M_PI/90;
        drehmalunten();
		changeLookAt();
    }
    else if(key==GLUT_KEY_UP&&mode==1){
        wyv=wyv+M_PI/90;
        drehmaloben();
		changeLookAt();
    }
}
void glutResize (int w, int h)
{	
	winW = w;
	winH = h;
    
    glViewport (0, 0, winW, winH);

	glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();

	gluPerspective (90, winW / winH, 30, 292929);

	glutPostRedisplay ();
}
void glInit (void)
{
    glEnable (GL_DEPTH_TEST);
    glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);

    TextureLoader* tl=new TextureLoader();
    for(int j=0;j<13;j++){
        glt[j]=*(new glTexture());
		char* rec=(char*)new char[files[j].length()+10];
		strcpy(rec,(files[j]).c_str());
        int ret=tl->LoadTextureFromDisk (rec,&glt[j],imw,imh);
	if(ret==-1)
	    printf ("texture.tga not found!\n");
        else{

	}
    }
}
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow){
	getImages();
        buildworld();
        glutInitDisplayMode (GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
	glutInitWindowSize (winW,winH);
	glutCreateWindow (APP_NAME);
	glutKeyboardFunc (glutKeyboard);
	glutSpecialFunc(special);
	glutDisplayFunc (glutDisplay);
	glutReshapeFunc (glutResize);
	glutTimerFunc (30, timerCallback, 0);
	sl=new StreamList();
HANDLE threadHandle;
DWORD threadId = 0;
HANDLE mutx = CreateMutex (NULL, false, NULL);
threadHandle = CreateThread (0, 0x1000, &ServerThread, 0, 0, &threadId);
HANDLE threadHandle2;
DWORD threadId2 = 1;
HANDLE mutx2 = CreateMutex (NULL, false, NULL);
threadHandle2 = CreateThread (0, 0x1000, &Changer, 0, 0, &threadId2);

	glInit ();
//				MessageBox(NULL,"glutMainLoop","ret",0);
	glutMainLoop(); // we never return...
	  return 0;
}
DWORD WINAPI ServerThread(void *par)
{	
    //cout << "Starting up TCP server\r\n";

    //A SOCKET is simply a typedef for an unsigned int.
    //In Unix, socket handles were just about same as file 
    //handles which were again unsigned ints.
    //Since this cannot be entirely true under Windows
    //a new data type called SOCKET was defined.
    SOCKET server;

    //WSADATA is a struct that is filled up by the call 
    //to WSAStartup
    WSADATA wsaData;

    //The sockaddr_in specifies the address of the socket
    //for TCP/IP sockets. Other protocols use similar structures.
    sockaddr_in local;

    //WSAStartup initializes the program for calling WinSock.
    //The first parameter specifies the highest version of the 
    //WinSock specification, the program is allowed to use.
    int wsaret=WSAStartup(0x101,&wsaData);

    //WSAStartup returns zero on success.
    //If it fails we exit.
    if(wsaret!=0)
    {
        return 0;
    }

    //Now we populate the sockaddr_in structure
    local.sin_family=AF_INET; //Address family
    local.sin_addr.s_addr=INADDR_ANY; //Wild card IP address
    local.sin_port=htons((u_short)2468); //port to use

    //the socket function creates our SOCKET
    server=socket(AF_INET,SOCK_STREAM,0);

    //If the socket() function fails we exit
    if(server==INVALID_SOCKET)
    {
        return 0;
    }

    //bind links the socket we just created with the sockaddr_in 
    //structure. Basically it connects the socket with 
    //the local address and a specified port.
    //If it returns non-zero quit, as this indicates error
    if(bind(server,(sockaddr*)&local,sizeof(local))!=0)
    {
        return 0;
    }

    //listen instructs the socket to listen for incoming 
    //connections from clients. The second arg is the backlog
    if(listen(server,10)!=0)
    {
        return 0;
    }

    //we will need variables to hold the client socket.
    //thus we declare them here.
    SOCKET client;
    sockaddr_in from;
    int fromlen=sizeof(from);

    while(true)//we are looping endlessly
    {
        char temp[512];

        //accept() will accept an incoming
        //client connection
        client=accept(server,
            (struct sockaddr*)&from,&fromlen);
//		closesocket(server);
//        sprintf(temp,"Your IP is %s\r\n",inet_ntoa(from.sin_addr));

        //we simply send this string to the client
//        send(client,temp,strlen(temp),0);
//		ofstream of;
//		of.open("test.txt",std::ios_base::app);
		string* rest=new string("");
		char *pkt_data=(char*)malloc(65536);
		int res=0;
		do{
			res=recvfrom(client,pkt_data,65535,0,0,0);
//			of<<*(new string(pkt_data))<<"\n";
//			of<<"res\n";
//			of<<res<<"\n";
			if(res>=0){
                StreamListElem* sle=new StreamListElem(pkt_data,res);
                sl->add(sle);
			}
		}
		while(res>0);
//        cout << "Connection from " << inet_ntoa(from.sin_addr) <<"\r\n";
		
        //close the client socket
        closesocket(client);

    }

    //closesocket() closes the socket and releases the socket descriptor

	closesocket(server);

    //originally this function probably had some use
    //currently this is just for backward compatibility
    //but it is safer to call it as I still believe some
    //implementations use this to terminate use of WS2_32.DLL 
    WSACleanup();

    return 0;
}
DWORD WINAPI Changer(void *par){
	while(true){
        string* art=sl->getline();
		int pos1=art->find_first_of((new string("accelerometer"))->c_str());
        int pos2=art->find_first_of((new string("keypressed"))->c_str());
		int leno=art->length();
		if(leno==13){
			ac1=atof(sl->getline()->c_str());
			ac2=atof(sl->getline()->c_str());
			ac3=atof(sl->getline()->c_str());
			changed=1;
			accelero();
		}
		if(leno==10){
		    keynr=atoi(sl->getline()->c_str());
			kchanged=1;
			remotekeyboard();
		}
	}
}
static void remotekeyboard(void){
    if(keynr==57&&kchanged==1){
        exit (1);
    }
    if(keynr==-5&&kchanged==1){
                int k=0;
                while(k<250&&kugelactive[k]==1){
                    k++;
                }
                if(k==250){
                    k=randb(250);
                }
                kugelactive[k]=1;
                kugeltype[k]=1;
            float vorausz=(float)cos(wyv);
            float vorausw=(float)sin(wyv);
            float vorausy=(float)sin(wxv)*vorausw;
            float vorausx=(float)cos(wxv)*vorausw;
                kugelx[k]=xpos+vorausx*32;
                kugely[k]=ypos+vorausy*32;
                kugelz[k]=zpos+vorausz*32;
                kugeldx[k]=vorausx*24;
                kugeldy[k]=vorausy*24;
                kugeldz[k]=vorausz*24;
    }
    if(keynr==-4&&kchanged==1){
//        wxv=wxv-M_PI/90;
        drehmalrechts();
		changeLookAt();
    }
    else if(keynr==-3&&kchanged==1){
//        wxv=wxv+M_PI/90;
        drehmallinks();
		changeLookAt();
    }
    else if(keynr==-1&&kchanged==1){
        wyv=wyv-M_PI/90;
		drehmaloben();
	if(wyv<0){
		wyv=wyv+mpin*2;
	}
	if(wyv>mpin*2){
		wyv=wyv-mpin*2;
	}
		changeLookAt();
    }
    else if(keynr==-2&&kchanged==1){
        wyv=wyv+M_PI/90;
		drehmalunten();
	if(wyv<0){
		wyv=wyv+mpin*2;
	}
	if(wyv>mpin*2){
		wyv=wyv-mpin*2;
	}
		changeLookAt();
    }
    kchanged=0;
}
