import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.*;
import java.applet.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.image.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.behaviors.vp.*;
import com.sun.j3d.utils.image.*;
public class Darkwar3D2 extends JApplet implements KeyListener{
    JLabel l1;
    JLabel info;
    static JApplet app;
    GameDarkwar3D2 g;
    KeyboardMapperAppletSwing km=null;
    private static final long serialVersionUID = -2575922815713886466L;
    public void init(){
        app=this;
        setSize(800,440);
        setLayout(null);
        l1=new JLabel("");
        l1.setText("(1): cursor keys, return, delete, +, - (2): s y x c a d q w");
        add(l1);
        l1.setBounds(200,5,420,27);
        info=new JLabel("info");
        add(info);
        info.setBounds(10,5,180,27);
        g=new GameDarkwar3D2(this);
        setFocusable(true);
        requestFocus();
        addKeyListener(this);
    }
    public void destroy(){
        g.running=false;
        try{
            g.t.join();
            g=null;
            System.gc();
        }
        catch(Exception e){
        }
    }
    public static String readLine(InputStream is){
        String ret="";
        boolean bol=true;
        try{
            int in=0;
            while((in=is.read())!=-1&&in!=13){
                byte[]by=new byte[1];
                by[0]=(byte)in;
                bol=false;
                ret=ret+new String(by);
            }
            in=is.read();
        }
        catch(Exception e){
        }
        if(bol)return null;
        return ret;
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        int key=e.getKeyCode();
        if(km!=null&&km.applyb){
            key=km.getKeyCode(key);
        }
        if(key!=0&&g!=null){
            g.eng.keycode=key;
        }
//System.out.println("kpressed"+key);
    }
    public void keyReleased(KeyEvent e){
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public static Image getImage(String filename){
        try{
            URL url=app.getClass().getResource("/"+filename);
            Image img=app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
}
class XCanvasDarkwar3D2 extends JPanel{
    BufferedImage img;
    private static final long serialVersionUID = -6436181171966521977L;
//    public void paint(Graphics g){
//    }
    public void paint(Graphics g){
        g.drawImage(img,0,0,this);
//        paint(g);
    }
}
class GameDarkwar3D2 implements Runnable{
    EngineDarkwar3D2 eng;
    EngineDarkwar3D2 eng2;
    Thread t;
    int xstart;
    int ystart;
    int xpos=2*128;
    int ypos=2*128;
    int zpos=1*128;
    int xpos2=2*128;
    int ypos2=2*128;
    int zpos2=3*128;
    double xdrift=0;
    double ydrift=0;
    double malpha=0;
    boolean mreverse=false;
    boolean running=true;
    double alpha=Math.PI;
    double beta=-Math.PI/2;
    double alpha2=Math.PI;
    double beta2=-Math.PI/2;
    int fahnen=0;
    int robos=0;
    int lifes=10;
    int lifes2=10;
    int mode=0;
    int mode2=0;
    int ax=0;
    int ay=0;
    Image back;
    Image back1;
    Image back2;
    Image back3;
    Image back4;
    Image back5;
    Image back6;
    Image back7;
    Image back8;
    Image back9;
    Image back10;
    Image side;
    Image side1;
    Image side2;
    Image side3;
    Image side4;
    Image side5;
    Image side6;
    Image side7;
    Image side8;
    Image side9;
    Image side10;
    Image wall;
    Image wallb;
//    Darkwar3Dmo m;
    Darkwar3D2 loa;
    int dist=128;
    int dist2=128;
    Group[]gegners=new Group[25];
    Group[]gegners2=new Group[25];
    int[]gx=new int[25];
    int[]gy=new int[25];
    int[]gz=new int[25];
    int[]gt=new int[25];
    int[]gg=new int[25];
    Group[]kugels=new Group[50];
    Group[]kugels2=new Group[50];
    int[]kx=new int[50];
    int[]ky=new int[50];
    int[]kz=new int[50];
    int[]kt=new int[50];
    int[]kg=new int[50];
    Group playerg;
    Group playergc;
    Group side1g;
    Group side2g;
    Group side3g;
    Group side4g;
    Group side5g;
    Group playerg2;
    Group playergc2;
    Group side1g2;
    Group side2g2;
    Group side3g2;
    Group side4g2;
    Group side5g2;
    Random rand;
    int level=0;
    int treffer=0;
    static XCanvasDarkwar3D2 canvas;
    static XCanvasDarkwar3D2 canvas2;
    public GameDarkwar3D2(Darkwar3D2 loa){
//        this.m=m;
        this.loa=loa;
        rand=new Random(System.currentTimeMillis());
        eng=new EngineDarkwar3D2();
        eng2=new EngineDarkwar3D2();
        try{
            back=Darkwar3D2.getImage("back.png");
            back1=Darkwar3D2.getImage("back1.png");
            back2=Darkwar3D2.getImage("back2.png");
            back3=Darkwar3D2.getImage("back3.png");
            back4=Darkwar3D2.getImage("back4.png");
            back5=Darkwar3D2.getImage("back5.png");
            back6=Darkwar3D2.getImage("back6.png");
            back7=Darkwar3D2.getImage("back7.png");
            back8=Darkwar3D2.getImage("back8.png");
            back9=Darkwar3D2.getImage("back9.png");
            back10=Darkwar3D2.getImage("back10.png");
            side=Darkwar3D2.getImage("side.png");
            side1=Darkwar3D2.getImage("side1.png");
            side2=Darkwar3D2.getImage("side2.png");
            side3=Darkwar3D2.getImage("side3.png");
            side4=Darkwar3D2.getImage("side4.png");
            side5=Darkwar3D2.getImage("side5.png");
            side6=Darkwar3D2.getImage("side6.png");
            side7=Darkwar3D2.getImage("side7.png");
            side8=Darkwar3D2.getImage("side8.png");
            side9=Darkwar3D2.getImage("side9.png");
            side10=Darkwar3D2.getImage("side10.png");
            wall=Darkwar3D2.getImage("wall.png");
            wallb=Darkwar3D2.getImage("wallb.png");
        }
        catch(Exception e){
System.out.println("e: "+e);
e.printStackTrace();
        }
        canvas=new XCanvasDarkwar3D2();
        loa.add(canvas);
        canvas.setBounds(0,40,400,400);
        canvas2=new XCanvasDarkwar3D2();
        loa.add(canvas2);
        canvas2.setBounds(400,40,400,400);
        t=new Thread(this);
        t.start();
    }
    public void newgegner(){
        int i=0;
        while(i<25&&gegners[i]!=null){
            i++;
        }
        if(i==25){
            i=rand.nextInt()%25;
            if(i<0){
                i=-i;
            }
            eng.remove(gegners[i]);
            eng2.remove(gegners2[i]);
        }
        gx[i]=20*128;
        gy[i]=randb(4*128);
        gz[i]=randb(4*128);
        gt[i]=randb(level);
        gg[i]=rand.nextInt()%2;
        if(gg[i]<0){
            gg[i]=-gg[i];
        }
        Image a=null;
        Image b=null;
        if(gt[i]==0){
            a=back1;
            b=side1;
        }
        else if(gt[i]==1){
            a=back2;
            b=side2;
        }
        else if(gt[i]==2){
            a=back3;
            b=side3;
        }
        else if(gt[i]==3){
            a=back4;
            b=side4;
        }
        else if(gt[i]==4){
            a=back5;
            b=side5;
        }
        else if(gt[i]==5){
            a=back6;
            b=side6;
        }
        else if(gt[i]==6){
            a=back7;
            b=side7;
        }
        else if(gt[i]==7){
            a=back8;
            b=side8;
        }
        else if(gt[i]==8){
            a=back9;
            b=side9;
        }
        else if(gt[i]==9){
            a=back10;
            b=side10;
        }
        gegners[i]=ObjectGenerator.getgegner(a,b);
        gegners[i].transform(gx[i],gy[i],gz[i]);
        eng.add(gegners[i]);
        gegners2[i]=ObjectGenerator.getgegner(a,b);
        gegners2[i].transform(gx[i],gy[i],gz[i]);
        eng2.add(gegners2[i]);
    }
    public void newkugel(){
        int i=0;
        while(i<50&&kugels[i]!=null){
            i++;
        }
        if(i==50){
            i=rand.nextInt()%50;
            if(i<0){
                i=-i;
            }
            eng.remove(kugels[i]);
            eng2.remove(kugels2[i]);
        }
        kt[i]=11;
        kx[i]=xpos;
        ky[i]=ypos;
        kz[i]=zpos;
        kugels[i]=ObjectGenerator.getkugel(0,255,0);
        kugels[i].transform(xpos,ypos,zpos);
        eng.add(kugels[i]);
        kugels2[i]=ObjectGenerator.getkugel(0,255,0);
        kugels2[i].transform(xpos,ypos,zpos);
        eng2.add(kugels2[i]);
    }
    public void newkugel2(){
        int i=0;
        while(i<50&&kugels[i]!=null){
            i++;
        }
        if(i==50){
            i=rand.nextInt()%50;
            if(i<0){
                i=-i;
            }
            eng.remove(kugels[i]);
            eng2.remove(kugels2[i]);
        }
        kt[i]=11;
        kx[i]=xpos2;
        ky[i]=ypos2;
        kz[i]=zpos2;
        kugels[i]=ObjectGenerator.getkugel(0,255,0);
        kugels[i].transform(xpos2,ypos2,zpos2);
        eng.add(kugels[i]);
        kugels2[i]=ObjectGenerator.getkugel(0,255,0);
        kugels2[i].transform(xpos2,ypos2,zpos2);
        eng2.add(kugels2[i]);
    }
    public void newkugelgegner(int j){
        int i=0;
        while(i<50&&kugels[i]!=null){
            i++;
        }
        if(i==50){
            i=rand.nextInt()%50;
            if(i<0){
                i=-i;
            }
            eng.remove(kugels[i]);
            eng2.remove(kugels2[i]);
        }
        kt[i]=gt[j]+1;
        kx[i]=gx[j];
        ky[i]=gy[j];
        kz[i]=gz[j];
        kg[i]=rand.nextInt()%2;
        if(kg[i]<0){
            kg[i]=-kg[i];
        }
        kugels[i]=ObjectGenerator.getkugel(0,0,255);
        kugels[i].transform(kx[i],ky[i],kz[i]);
        eng.add(kugels[i]);
        kugels2[i]=ObjectGenerator.getkugel(0,0,255);
        kugels2[i].transform(kx[i],ky[i],kz[i]);
        eng2.add(kugels2[i]);
    }
    public int randb(int max){
        int ret=rand.nextInt()%max;
        if(ret<0){
            ret=-ret;
        }
        return ret;
    }
    public void fly(){
        if(randb(100)==0){
            newgegner();
        }
        for(int i=0;i<25;i++){
            if(gegners[i]!=null){
                if(randb(100)==0){
                    newkugelgegner(i);
                }
                if(gt[i]<=3){
                    gx[i]=gx[i]-4;
                    gegners[i].transform(-4,0,0);
                    gegners2[i].transform(-4,0,0);
                }
                else if(gt[i]<=7){
                    gx[i]=gx[i]-8;
                    gegners[i].transform(-8,0,0);
                    gegners2[i].transform(-8,0,0);
                    if((gy[i]>ypos&&gg[i]==0)||(gy[i]>ypos2&&gg[i]==1)){
                        gy[i]=gy[i]-(1+gt[i]-3)/4;
                        gegners[i].transform(0,-(1+gt[i]-3)/4,0);
                        gegners2[i].transform(0,-(1+gt[i]-3)/4,0);
                    }
                    else if((gy[i]<ypos&&gg[i]==0)||(gy[i]<ypos2&&gg[i]==1)){
                        gy[i]=gy[i]+(1+gt[i]-3)/4;
                        gegners[i].transform(0,(1+gt[i]-3)/4,0);
                        gegners2[i].transform(0,(1+gt[i]-3)/4,0);
                    }
                    if((gz[i]>zpos&&gg[i]==0)||(gz[i]>zpos2&&gg[i]==1)){
                        gz[i]=gz[i]-(1+gt[i]-3)/4;
                        gegners[i].transform(0,0,-(1+gt[i]-3)/4);
                        gegners2[i].transform(0,0,-(1+gt[i]-3)/4);
                    }
                    else if((gz[i]<zpos&&gg[i]==0)||(gz[i]<zpos2&&gg[i]==1)){
                        gz[i]=gz[i]+(1+gt[i]-3)/4;
                        gegners[i].transform(0,0,(1+gt[i]-3)/4);
                        gegners2[i].transform(0,0,(1+gt[i]-3)/4);
                    }
                }
                else if(gt[i]<=12){
                    gx[i]=gx[i]-12;
                    gegners[i].transform(-12,0,0);
                    gegners2[i].transform(-12,0,0);
                    if((gy[i]>ypos&&gg[i]==0)||(gy[i]>ypos2&&gg[i]==1)){
                        gy[i]=gy[i]-(3+gt[i]-3)/4;
                        gegners[i].transform(0,-(1+gt[i]-3)/4,0);
                        gegners2[i].transform(0,-(1+gt[i]-3)/4,0);
                    }
                    else if((gy[i]<ypos&&gg[i]==0)||(gy[i]<ypos2&&gg[i]==1)){
                        gy[i]=gy[i]+(3+gt[i]-3)/4;
                        gegners[i].transform(0,(1+gt[i]-3)/4,0);
                        gegners2[i].transform(0,(1+gt[i]-3)/4,0);
                    }
                    if((gz[i]>zpos&&gg[i]==0)||(gz[i]>zpos2&&gg[i]==1)){
                        gz[i]=gz[i]-(3+gt[i]-3)/4;
                        gegners[i].transform(0,0,-(1+gt[i]-3)/4);
                        gegners2[i].transform(0,0,-(1+gt[i]-3)/4);
                    }
                    else if((gz[i]<zpos&&gg[i]==0)||(gz[i]<zpos2&&gg[i]==1)){
                        gegners[i].transform(0,0,(1+gt[i]-3)/4);
                        gegners2[i].transform(0,0,(1+gt[i]-3)/4);
                        gz[i]=gz[i]+(3+gt[i]-3)/4;
                    }
                }
                for(int j=0;j<50;j++){
                    if(kugels[j]!=null&&kt[j]==11){
                        double diff=Math.sqrt((gx[i]-kx[j])*(gx[i]-kx[j])+(gy[i]-ky[j])*(gy[i]-ky[j])+(gz[i]-kz[j])*(gz[i]-kz[j]));
                        if(diff<16){
                            eng.remove(gegners[i]);
                            eng.remove(kugels[j]);
                            eng2.remove(gegners2[i]);
                            eng2.remove(kugels2[j]);
                            gegners[i]=null;
                            kugels[j]=null;
                            treffer++;
                        }
                    }
                }
                if(gx[i]<0&&gegners[i]!=null){
                    eng.remove(gegners[i]);
                    eng2.remove(gegners2[i]);
                    gegners[i]=null;
                }
            }
            if(gegners[i]!=null){
                double diff=Math.sqrt((gx[i]-xpos)*(gx[i]-xpos)+(gy[i]-ypos)*(gy[i]-ypos)+(gz[i]-zpos)*(gz[i]-zpos));
                if(diff<32){
                    lifes=lifes-1;
                    playerg.transform(2*128-xpos,2*128-ypos,1*128-zpos);
                    playerg2.transform(2*128-xpos,2*128-ypos,1*128-zpos);
                    xpos=2*128;
                    ypos=2*128;
                    zpos=1*128;
                    eng.remove(gegners[i]);
                    eng2.remove(gegners2[i]);
                }
                double diff2=Math.sqrt((gx[i]-xpos2)*(gx[i]-xpos2)+(gy[i]-ypos2)*(gy[i]-ypos2)+(gz[i]-zpos2)*(gz[i]-zpos2));
                if(diff2<32){
                    lifes2=lifes2-1;
                    playergc.transform(2*128-xpos2,2*128-ypos2,3*128-zpos2);
                    playergc2.transform(2*128-xpos2,2*128-ypos2,3*128-zpos2);
                    xpos2=2*128;
                    ypos2=2*128;
                    zpos2=3*128;
                    eng.remove(gegners[i]);
                    eng2.remove(gegners2[i]);
                }
            }
        }
        for(int j=0;j<50;j++){
            if(kt[j]==11&&kugels[j]!=null){
                kx[j]=kx[j]+10;
                kugels[j].transform(10,0,0);
                kugels2[j].transform(10,0,0);
            }
            if(kt[j]!=11&&kt[j]!=0&&kugels[j]!=null){
                double entf=Math.sqrt((kx[j]-xpos)*(kx[j]-xpos)+(ky[j]-ypos)*(ky[j]-ypos)+(kz[j]-zpos)*(kz[j]-zpos));
                if(entf<16){
                    lifes=lifes-1;
                    playerg.transform(2*128-xpos,2*128-ypos,1*128-zpos);
                    playerg2.transform(2*128-xpos,2*128-ypos,1*128-zpos);
                    xpos=2*128;
                    ypos=2*128;
                    zpos=1*128;
                    kt[j]=0;
                    if(kugels[j]!=null){
                        eng.remove(kugels[j]);
                        kugels[j]=null;
                        eng2.remove(kugels2[j]);
                        kugels2[j]=null;
                    }
                }
                double entf2=Math.sqrt((kx[j]-xpos2)*(kx[j]-xpos2)+(ky[j]-ypos2)*(ky[j]-ypos2)+(kz[j]-zpos2)*(kz[j]-zpos2));
                if(entf2<16){
                    lifes2=lifes2-1;
                    playergc.transform(2*128-xpos,2*128-ypos,3*128-zpos);
                    playergc2.transform(2*128-xpos,2*128-ypos,3*128-zpos);
                    xpos2=2*128;
                    ypos2=2*128;
                    zpos2=3*128;
                    kt[j]=0;
                    if(kugels[j]!=null){
                        eng.remove(kugels[j]);
                        kugels[j]=null;
                        eng2.remove(kugels2[j]);
                        kugels2[j]=null;
                    }
                }
                if(kt[j]<=3){
                    kx[j]=kx[j]-8;
                    if(kugels[j]!=null){
                        kugels[j].transform(-8,0,0);
                        kugels2[j].transform(-8,0,0);
                    }
                }
                else if(kt[j]<=7){
                    kx[j]=kx[j]-12;
                    if(kugels[j]!=null){
                        kugels[j].transform(-12,0,0);
                        kugels2[j].transform(-12,0,0);
                    }
                    if((ky[j]>ypos&&kg[j]==0)||(ky[j]>ypos2&&kg[j]==1)){
                        ky[j]=ky[j]-(1+kt[j]-5)/6;
                        kugels[j].transform(0,-(1+kt[j]-5)/6,0);
                        kugels2[j].transform(0,-(1+kt[j]-5)/6,0);
                    }
                    else if((ky[j]<ypos&&kg[j]==0)||(ky[j]<ypos2&&kg[j]==1)){
                        ky[j]=ky[j]+(1+kt[j]-5)/6;
                        kugels[j].transform(0,(1+kt[j]-5)/6,0);
                        kugels2[j].transform(0,(1+kt[j]-5)/6,0);
                    }
                    if((kz[j]>zpos&&kg[j]==0)||(kz[j]>zpos2&&kg[j]==1)){
                        kz[j]=kz[j]-(1+kt[j]-5)/6;
                        kugels[j].transform(0,0,-(1+kt[j]-5)/6);
                        kugels2[j].transform(0,0,-(1+kt[j]-5)/6);
                    }
                    else if((kz[j]<zpos&&kg[j]==0)||(kz[j]<zpos2&&kg[j]==1)){
                        kz[j]=kz[j]+(1+kt[j]-5)/6;
                        kugels[j].transform(0,0,(1+kt[j]-5)/6);
                        kugels2[j].transform(0,0,(1+kt[j]-5)/6);
                    }
                }
                else if(kt[j]<=12){
                    kx[j]=kx[j]-12;
                    if(kugels[j]!=null){
                        kugels[j].transform(-12,0,0);
                        kugels2[j].transform(-12,0,0);
                    }
                    if((ky[j]>ypos&&kg[j]==0)||(ky[j]>ypos2&&kg[j]==1)){
                        ky[j]=ky[j]-(1+kt[j]-5)/6;
                        kugels[j].transform(0,-(1+kt[j]-5)/6,0);
                        kugels2[j].transform(0,-(1+kt[j]-5)/6,0);
                    }
                    else if((ky[j]<ypos&&kg[j]==0)||(ky[j]<ypos2&&kg[j]==1)){
                        ky[j]=ky[j]+(1+kt[j]-5)/6;
                        kugels[j].transform(0,(1+kt[j]-5)/6,0);
                        kugels2[j].transform(0,(1+kt[j]-5)/6,0);
                    }
                    if((kz[j]>zpos&&kg[j]==0)||(kz[j]>zpos2&&kg[j]==1)){
                        kz[j]=kz[j]-(1+kt[j]-5)/6;
                        kugels[j].transform(0,0,-(1+kt[j]-5)/6);
                        kugels2[j].transform(0,0,-(1+kt[j]-5)/6);
                    }
                    else if((kz[j]<zpos&&kg[j]==0)||(kz[j]<zpos2&&kg[j]==1)){
                        kz[j]=kz[j]+(1+kt[j]-5)/6;
                        kugels[j].transform(0,0,(1+kt[j]-5)/6);
                        kugels2[j].transform(0,0,(1+kt[j]-5)/6);
                    }
                }
            }
            if(kx[j]<0||kx[j]>20*128){
                kt[j]=0;
                if(kugels[j]!=null){
                    eng.remove(kugels[j]);
                    eng2.remove(kugels[j]);
                    kugels[j]=null;
                }
            }
        }
        level=treffer/25+1;
//        level=10;
    }
    public void left(){
        if(mode==0){
            alpha=alpha-Math.PI/90;
        }
        else{
            ypos=ypos-10;
            playerg.transform(0,-10,0);
            playerg2.transform(0,-10,0);
        }
    }
    public void right(){
        if(mode==0){
            alpha=alpha+Math.PI/90;
        }
        else{
            ypos=ypos+10;
            playerg.transform(0,10,0);
            playerg2.transform(0,10,0);
        }
    }
    public void up(){
        if(mode==0){
            beta=beta-Math.PI/90;
        }
        else{
            zpos=zpos-10;
            playerg.transform(0,0,-10);
            playerg2.transform(0,0,-10);
        }
    }
    public void down(){
        if(mode==0){
            beta=beta+Math.PI/90;
        }
        else{
            zpos=zpos+10;
            playerg.transform(0,0,10);
            playerg2.transform(0,0,10);
        }
    }

    public void left2(){
        if(mode2==0){
            alpha2=alpha2-Math.PI/90;
        }
        else{
            ypos2=ypos2-10;
            playergc.transform(0,-10,0);
            playergc2.transform(0,-10,0);
        }
    }
    public void right2(){
        if(mode2==0){
            alpha2=alpha2+Math.PI/90;
        }
        else{
            ypos2=ypos2+10;
            playergc.transform(0,10,0);
            playergc2.transform(0,10,0);
        }
    }
    public void up2(){
        if(mode2==0){
            beta2=beta2-Math.PI/90;
        }
        else{
            zpos2=zpos2-10;
            playergc.transform(0,0,-10);
            playergc2.transform(0,0,-10);
        }
    }
    public void down2(){
        if(mode2==0){
            beta2=beta2+Math.PI/90;
        }
        else{
            zpos2=zpos2+10;
            playergc.transform(0,0,10);
            playergc2.transform(0,0,10);
        }
    }
    public void run(){
        if(loa.km==null){
            loa.km=new KeyboardMapperAppletSwing(loa);
            loa.add(loa.km);
            loa.km.setBounds(0,40,400,400);
            loa.km.setVisible(true);
            while(!loa.km.closed){
                try{
                    Thread.sleep(100);
                }
                catch(Exception e){
                }
            }
            loa.repaint();
        }
try{
//        loa.add(eng);
//        eng.reshape(0,40,400,400);
//        loa.add(eng2);
//        eng2.reshape(400,40,400,400);
        loa.info.setText("loading side1");
        side1g=ObjectGenerator.getSide1(wallb);
        eng.add(side1g);
        side1g2=ObjectGenerator.getSide1(wallb);
        eng2.add(side1g2);
//        eng.repaint();
        loa.info.setText("loading side2");
        side2g=ObjectGenerator.getSide2(wall);
        eng.add(side2g);
        side2g2=ObjectGenerator.getSide2(wall);
        eng2.add(side2g2);
//        eng.repaint();
        loa.info.setText("loading side3");
        side3g=ObjectGenerator.getSide3(wall);
        eng.add(side3g);
        side3g2=ObjectGenerator.getSide3(wall);
        eng2.add(side3g2);
//        eng.repaint();
        loa.info.setText("loading side4");
        side4g=ObjectGenerator.getSide4(wall);
        eng.add(side4g);
        side4g2=ObjectGenerator.getSide4(wall);
        eng2.add(side4g2);
//        eng.repaint();
        loa.info.setText("loading side5");
        side5g=ObjectGenerator.getSide5(wall);
        eng.add(side5g);
        side5g2=ObjectGenerator.getSide5(wall);
        eng2.add(side5g2);
//        eng.repaint();
        loa.info.setText("load player");
Group player0=ObjectGenerator.getplayer(back,side);
player0.transform(100,100,100);
        playerg=ObjectGenerator.getplayer(back,side);
        playerg.transform(2*128,2*128,1*128);
        playergc=ObjectGenerator.getplayer(back,side);
        playergc.transform(2*128,2*128,3*128);
        eng.add(playerg);
        eng.add(playergc);
        playerg2=ObjectGenerator.getplayer(back,side);
        playerg2.transform(2*128,2*128,1*128);
        playergc2=ObjectGenerator.getplayer(back,side);
        playergc2.transform(2*128,2*128,3*128);
        eng2.add(playerg2);
        eng2.add(playergc2);
//        eng.repaint();

        Vektor camerapos=new Vektor((short)xpos,(short)ypos,(short)zpos);
        Vektor cameraposplus=new Vektor(0,0,0);
        Vektor camerapos2=new Vektor((short)xpos2,(short)ypos2,(short)zpos2);
        Vektor cameraposplus2=new Vektor(0,0,0);
        eng.setStatus("running");
//        eng.repaint();
//        eng.setSize(400,400);
//        eng2.setSize(400,400);
    int winW=400;
    int winH=400;
    Screen3D sc=eng.getScreen3D();
    sc.setSize(winW,winH);
    sc.setPhysicalScreenWidth(0.8);
    sc.setPhysicalScreenHeight(0.6);
    Screen3D sc2=eng2.getScreen3D();
    sc2.setSize(winW,winH);
    sc2.setPhysicalScreenWidth(0.8);
    sc2.setPhysicalScreenHeight(0.6);
        while(running){
try{
            fly();
            int xw=320;
            int yw=240;
            xw=eng.getWidth();
            yw=eng.getHeight();
            if(xw!=ax||yw!=ay){
                ax=xw;
                ay=yw;
            }
            camerapos.x=(short)xpos;
            camerapos.y=(short)ypos;
            camerapos.z=(short)zpos;
            camerapos2.x=(short)xpos2;
            camerapos2.y=(short)ypos2;
            camerapos2.z=(short)zpos2;
//            double w=Math.sin(beta)*dist;
//            cameraposplus.x=(short)(Math.cos(alpha)*w);
//            cameraposplus.y=(short)(Math.cos(beta)*dist);
//            cameraposplus.z=(short)(Math.sin(alpha)*w);
            cameraposplus.z=(short)(Math.cos(beta)*dist);
            double w=Math.sin(beta)*dist;
            cameraposplus.y=(short)(Math.sin(alpha)*w);
            cameraposplus.x=(short)(Math.cos(alpha)*w);
            double xtrans=camerapos.x-cameraposplus.x;
            double ytrans=camerapos.y-cameraposplus.y;
            double ztrans=camerapos.z-cameraposplus.z;
            cameraposplus2.z=(short)(Math.cos(beta2)*dist2);
            double w2=Math.sin(beta2)*dist2;
            cameraposplus2.y=(short)(Math.sin(alpha2)*w2);
            cameraposplus2.x=(short)(Math.cos(alpha2)*w2);
            double xtrans2=camerapos2.x-cameraposplus2.x;
            double ytrans2=camerapos2.y-cameraposplus2.y;
            double ztrans2=camerapos2.z-cameraposplus2.z;
//System.out.println("xtrans: "+cameraposplus.x+" ytrans: "+cameraposplus.y+" ztrans: "+cameraposplus.z);
            double alphab=alpha;
            double betab=beta;
            double alphab2=alpha2;
            double betab2=beta2;
            Vektor vt=new Vektor((int)xtrans,(int)ytrans,(int)ztrans);
            eng.setCam(vt,(float)(alphab+Math.PI),(float)(-betab));
            Vektor vt2=new Vektor((int)xtrans2,(int)ytrans2,(int)ztrans2);
            eng2.setCam(vt2,(float)(alphab2+Math.PI),(float)(-betab2));
//            eng.repaint();
            try{
                Thread.sleep(100);
            }
            catch(Exception f){
            }
            int key=eng.getKeyCode();
            int key2=eng2.getKeyCode();
            if(key!=0||key2!=0){
//System.out.println("key: "+key);
//System.out.println("alpha: "+alpha+" beta: "+beta);
//System.out.println("key: "+key+" "+key2);
                if(key==37||key2==37){
                    left();
                }
                if(key==39||key2==39){
                    right();
                }
                if(key==40||key2==40){
                    down();
                }
                if(key==38||key2==38){
                    up();
                }
                if(key==521||key2==521){
                    dist+=10;
                }
                if(key==45||key2==45){
                    dist-=10;
                }
                if(key==10||key2==10){
                    newkugel();
                }
                if(key==27||key2==27){
                    running=false;
//                    Display d2=Display.getDisplay(m);
//                    d2.setCurrent(loa);
                    loa.remove(canvas);
                    loa.remove(canvas2);
                    loa.g=new GameDarkwar3D2(loa);
                }
                if(key==127||key2==127){
                    if(mode==0){
                        mode=1;
                    }
                    else{
                        mode=0;
                    }
                }


                if(key==89||key2==89){
                    left2();
                }
                if(key==67||key2==67){
                    right2();
                }
                if(key==88||key2==88){
                    down2();
                }
                if(key==83||key2==83){
                    up2();
                }
                if(key==81||key2==81){
                    dist2+=10;
                }
                if(key==87||key2==87){
                    dist2-=10;
                }
                if(key==65||key2==65){
                    newkugel2();
                }
                if(key==68||key2==68){
                    if(mode2==0){
                        mode2=1;
                    }
                    else{
                        mode2=0;
                    }
                }

            }
            if(lifes<=0||lifes2<=0){
                loa.l1.setText("You habe lost!");
            }
            else{
                if(level>=11){
                    loa.l1.setText("You have won!");
                }
                else{
                    loa.l1.setText("level: "+level+" score: "+treffer+" lifes (1): "+lifes+" (2): "+lifes2);
                }
            }
            ImageComponent2D buff=new ImageComponent2D(ImageComponent2D.FORMAT_RGBA,new BufferedImage(winW,winH,BufferedImage.TYPE_INT_ARGB));
            eng.setOffScreenBuffer(buff);
            eng.renderOffScreenBuffer();
            eng.waitForOffScreenRendering();
            canvas.img=eng.getOffScreenBuffer().getImage();
            canvas.repaint();
            ImageComponent2D buff2=new ImageComponent2D(ImageComponent2D.FORMAT_RGBA,new BufferedImage(winW,winH,BufferedImage.TYPE_INT_ARGB));
            eng2.setOffScreenBuffer(buff2);
            eng2.renderOffScreenBuffer();
            eng2.waitForOffScreenRendering();
            canvas2.img=eng2.getOffScreenBuffer().getImage();
            canvas2.repaint();
}
catch(Exception exc1){
exc1.printStackTrace();
}
        }
}
catch(Exception exc){
exc.printStackTrace();
}
    }
}
class ObjectGenerator{
    public static Group getkugel(int r,int g,int b){
        Group gr=new Group();
        Vektor v=new Vektor(0,0,0);
        Kugel k=new Kugel(v,5,r,g,b);
        gr.add(k);
        return gr;
    }
    public static Group getgegner(Image back,Image side){
        Vektor v1=new Vektor(16,16,16);
        Vektor v2=new Vektor(v1.x+0,v1.y-32,v1.z+0);
        Vektor v3=new Vektor(v1.x+0,v1.y-32,v1.z-32);
        Vektor v4=new Vektor(v1.x+0,v1.y+0,v1.z-32);
        Polygon p1=new Polygon(v1,v2,v3,v4,back);
        Vektor v5=new Vektor(16,16,16);
        Vektor v6=new Vektor(v5.x+0,v5.y-32,v5.z+0);
        Vektor v7=new Vektor(v5.x-32,v5.y-16,v5.z-16);
        Polygon p2=new Polygon(v5,v6,v7,side);
        Vektor v8=new Vektor(16,-16,16);
        Vektor v9=new Vektor(v8.x+0,v8.y+0,v8.z-32);
        Vektor v10=new Vektor(v8.x-32,v8.y+16,v8.z-16);
        Polygon p3=new Polygon(v8,v9,v10,side);
        Vektor v11=new Vektor(16,-16,-16);
        Vektor v12=new Vektor(v11.x+0,v11.y+32,v11.z+0);
        Vektor v13=new Vektor(v11.x-32,v11.y+16,v11.z+16);
        Polygon p4=new Polygon(v11,v12,v13,side);
        Vektor v14=new Vektor(16,16,-16);
        Vektor v15=new Vektor(v14.x+0,v14.y+0,v14.z+32);
        Vektor v16=new Vektor(v14.x-32,v14.y-16,v14.z+16);
        Polygon p5=new Polygon(v14,v15,v16,side);
        Group g=new Group();
        g.add(p1);
        g.add(p2);
        g.add(p3);
        g.add(p4);
        g.add(p5);
        return g;
    }
    public static Group getplayer(Image back,Image side){
        Group g=ObjectGenerator.getgegner(back,side);
        g.rotLeft((float)Math.PI);
        return g;
    }
    public static Group getSide1(Image wallb){
        Group g=new Group();
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                Vektor v1=new Vektor(0,i*128,j*128);
                Vektor v2=new Vektor(v1.x+0,v1.y+128,v1.z+0);
                Vektor v3=new Vektor(v1.x+0,v1.y+128,v1.z+128);
                Vektor v4=new Vektor(v1.x+0,v1.y+0,v1.z+128);
                Polygon p=new Polygon(v1,v2,v3,v4,wallb);
                g.add(p);
            }
        }
        return g;
    }
    public static Group getSide2(Image wall){
        Group g=new Group();
        for(int i=0;i<20;i++){
            for(int j=0;j<4;j++){
                Vektor v1=new Vektor(i*128,0,j*128);
                Vektor v2=new Vektor(v1.x+128,v1.y+0,v1.z+0);
                Vektor v3=new Vektor(v1.x+128,v1.y+0,v1.z+128);
                Vektor v4=new Vektor(v1.x+0,v1.y+0,v1.z+128);
                Polygon p=new Polygon(v1,v2,v3,v4,wall);
                g.add(p);
            }
        }
        return g;
    }
    public static Group getSide3(Image wall){
        Group g=new Group();
        for(int i=0;i<20;i++){
            for(int j=0;j<4;j++){
                Vektor v1=new Vektor(i*128,4*128,j*128);
                Vektor v2=new Vektor(v1.x+128,v1.y+0,v1.z+0);
                Vektor v3=new Vektor(v1.x+128,v1.y+0,v1.z+128);
                Vektor v4=new Vektor(v1.x+0,v1.y+0,v1.z+128);
                Polygon p=new Polygon(v1,v2,v3,v4,wall);
                g.add(p);
            }
        }
        return g;
    }
    public static Group getSide4(Image wall){
        Group g=new Group();
        for(int i=0;i<20;i++){
            for(int j=0;j<4;j++){
                Vektor v1=new Vektor(i*128,j*128,0);
                Vektor v2=new Vektor(v1.x+128,v1.y+0,v1.z+0);
                Vektor v3=new Vektor(v1.x+128,v1.y+128,v1.z+0);
                Vektor v4=new Vektor(v1.x+0,v1.y+128,v1.z+0);
                Polygon p=new Polygon(v1,v2,v3,v4,wall);
                g.add(p);
            }
        }
        return g;
    }
    public static Group getSide5(Image wall){
        Group g=new Group();
        for(int i=0;i<20;i++){
            for(int j=0;j<4;j++){
                Vektor v1=new Vektor(i*128,j*128,4*128);
                Vektor v2=new Vektor(v1.x+128,v1.y+0,v1.z+0);
                Vektor v3=new Vektor(v1.x+128,v1.y+128,v1.z+0);
                Vektor v4=new Vektor(v1.x+0,v1.y+128,v1.z+0);
                Polygon p=new Polygon(v1,v2,v3,v4,wall);
                g.add(p);
            }
        }
        return g;
    }
}
class EngineDarkwar3D2 extends Canvas3D{
    Group start;
    Group end;
    int w;
    int h;
    boolean keypressed=false;
    int keycode=0;
    Group direct;
    String status="";
    TransformGroup world2;
    BranchGroup world;
    BranchGroup temp;
//    AWTBehavior behavior;
    AmbientLight ambientlight;
    SimpleUniverse simplu;
    Node disp;
    View view;
    Transform3D trans;
    ViewPlatform vp;
    ViewPlatformBehavior vpb;
    TransformGroup vpcontainer;
    private static final long serialVersionUID = 8949536980361603403L;
    public EngineDarkwar3D2(){
        super(SimpleUniverse.getPreferredConfiguration(),true);
        direct=new Group();
        world2=new TransformGroup();
        ambientlight=new AmbientLight();
        world=new BranchGroup();
        world.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
        world.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
        world.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
        world.setCapability(BranchGroup.ALLOW_DETACH);
        world.addChild(world2);
        world.addChild(ambientlight);
//        behavior=new AWTBehavior(this);
        disp=world.cloneTree();
        temp=new BranchGroup();
        temp.addChild(disp);
        simplu=new SimpleUniverse(this);
        view=getView();
        view.setBackClipDistance(33000.0f);
        view.setFieldOfView(50.0f/180.0f*Math.PI);
        vp=new ViewPlatform();
        view.attachViewPlatform(vp);
        vpcontainer=new TransformGroup();
        vpcontainer.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        vpcontainer.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        vpcontainer.addChild(vp);
        BranchGroup bg=new BranchGroup();
        bg.addChild(vpcontainer);
//        bg.addChild(behavior);
        simplu.addBranchGraph(bg);
        simplu.addBranchGraph(world);
    }
    public void repaint2(){
        simplu=new SimpleUniverse(this);
        disp=world.cloneTree();
        temp=new BranchGroup();
        temp.addChild(disp);
        view=getView();
        view.setBackClipDistance(33000.0f);
        view.setFieldOfView(50.0f/180.0f*Math.PI);
        simplu.addBranchGraph(temp);
    }
    public void setCam(Vektor campos,float wx,float wy){
	float z=(float)Math.cos(wy);
	float w=(float)Math.sin(wy);
	float y=(float)Math.sin(wx)*w;
	float x=(float)Math.cos(wx)*w;
        double wy2=wy+Math.PI/2;
        double wx2=wx;
	float z2=(float)Math.cos(wy2);
	float w2=(float)Math.sin(wy2);
	float y2=(float)Math.sin(wx2)*w2;
	float x2=(float)Math.cos(wx2)*w2;
        trans=new Transform3D();
        trans.lookAt(new Point3d(campos.x,campos.y,campos.z),new Point3d(campos.x+x,campos.y+y,campos.z+z),new Vector3d(x2,y2,z2));
        trans.invert();
        vpcontainer.setTransform(trans);
    }
    public void paintb(Graphics g){
        if(world==null){
            return;
        }
        if(!"".equals(status)){
            g.setColor(Color.black);
            g.fillRect(0,0,w,15);
            g.setColor(Color.white);
            g.drawLine(0,15,w,15);
            g.drawString(status,10,0);
        }
    }
    public void setStatus(String status){
        this.status=status;
    }
    public int getKeyCode(){
        int key=keycode;
        keycode=0;
        return key;
    }
    public void add(Polygon pol){
        if(pol.mesh!=null){
            world.addChild(pol.bg);
            direct.add(pol);
        }
    }
    public void add(Kugel kugel){
        if(kugel.mesh!=null){
            world.addChild(kugel.bg);
            direct.add(kugel);
        }
    }
    public void remove(Polygon pol){
        direct.remove(pol);
        if(pol.mesh!=null){
            world.removeChild(pol.bg);
//            pol.bg.removeChild(pol.mesh);
        }
    }
    public void remove(Kugel kugel){
        direct.remove(kugel);
        if(kugel.mesh!=null){
            world.removeChild(kugel.bg);
//            kugel.bg.removeChild(kugel.mesh);
        }
    }
    public void add(Group g){
        if(start==null){
            start=g;
            end=g;
        }
        else{
            end.next=g;
            end=end.next;
        }
        Polygon cur=g.start;
        while(cur!=null){
            if(cur.mesh!=null){
                world.addChild(cur.bg);
            }
            cur=cur.next;
        }
        Kugel curb=g.startb;
        while(curb!=null){
            if(curb.mesh!=null){
                world.addChild(curb.bg);
            }
            curb=curb.next;
        }
    }
    public void remove(Group g){
        Group cur=start;
        Group fore=null;
        while(cur!=null){
            boolean b=true;
            if(cur==g){
                if(fore==null){
                    if(end==start){
                        end=null;
                        start=null;
                    }
                    else{
                        start=start.next;
                    }
                }
                else{
                    fore.next=cur.next;
                    b=false;
                }
            }
            if(b){
                fore=cur;
                cur=cur.next;
            }
            else{
                cur=cur.next;
            }
        }
        Polygon curb=g.start;
        while(curb!=null){
            if(curb.mesh!=null){
//                curb.bg.removeChild(curb.mesh);
                world.removeChild(curb.bg);
            }
            curb=curb.next;
        }
        Kugel curb2=g.startb;
        while(curb2!=null){
            if(curb2.mesh!=null){
//                curb2.bg.removeChild(curb2.mesh);
                world.removeChild(curb2.bg);
            }
            curb2=curb2.next;
        }
    }
    public void transform(float x,float y,float z){
        Group cur=start;
        while(cur!=null){
            cur.transform(x,y,z);
            cur=cur.next;
        }
        direct.transform(x,y,z);
    }
    public void rotLeft(float w){
        Group cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
        direct.rotLeft(w);
    }
    public void rotUp(float w){
        Group cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
        direct.rotUp(w);
    }
}
class Group{
    Polygon start;
    Polygon end;
    Kugel startb;
    Kugel endb;
    Group next;
    public Group(){
    }
    public void add(Polygon pol){
        if(start==null){
            start=pol;
            end=pol;
        }
        else{
            end.next=pol;
            end=end.next;
        }
    }
    public void remove(Polygon pol){
        Polygon cur=start;
        Polygon fore=null;
        while(cur!=null){
            boolean b=true;
            if(cur==pol){
                if(fore==null){
                    if(end==start){
                        end=null;
                        start=null;
                    }
                    else{
                        start=start.next;
                    }
                }
                else{
                    fore.next=cur.next;
                    b=false;
                }
            }
            if(b){
                fore=cur;
                cur=cur.next;
            }
            else{
                cur=cur.next;
            }
        }
    }
    public void add(Kugel kugel){
        if(startb==null){
            startb=kugel;
            endb=kugel;
        }
        else{
            endb.next=kugel;
            endb=endb.next;
        }
    }
    public void remove(Kugel kugel){
        Kugel curb=startb;
        Kugel fore=null;
        while(curb!=null){
            boolean b=true;
            if(curb==kugel){
                if(fore==null){
                    if(endb==startb){
                        endb=null;
                        startb=null;
                    }
                    else{
                        startb=startb.next;
                    }
                }
                else{
                    fore.next=curb.next;
                    b=false;
                }
            }
            if(b){
                fore=curb;
                curb=curb.next;
            }
            else{
                curb=curb.next;
            }
        }
    }
    public void transform(float x,float y,float z){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(x,y,z);
            cur=cur.next;
        }
        Kugel curb=startb;
        while(curb!=null){
            curb.transform(x,y,z);
            curb=curb.next;
        }
    }
    public void rotLeft(float w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
        Kugel curb=startb;
        while(curb!=null){
            curb.rotLeft(w);
            curb=curb.next;
        }
    }
    public void rotUp(float w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
        Kugel curb=startb;
        while(curb!=null){
            curb.rotUp(w);
            curb=curb.next;
        }
    }
}
class Polygon{
    Polygon next;
    Vektor v1;
    Vektor v2;
    Vektor v3;
    Vektor v4;
    TransformGroup mesh;
    BufferedImage img;
    Transform3D transform;
    TriangleArray meshb;
    Shape3D meshc;
    boolean triangle=false;
    float[]pos;
    float[]texval;
    Texture2D tex;
    BranchGroup bg;
    public Polygon(Vektor v1,Vektor v2,Vektor v3,Vektor v4,Image img){
        this.v1=v1;
        this.v2=v2;
        this.v3=v3;
        this.v4=v4;
        Frame f=new Frame();
        int w=img.getWidth(f);
        int h=img.getHeight(f);
        while(w==-1||h==-1){
            try{
                w=img.getWidth(f);
                h=img.getHeight(f);
                Thread.yield();
            }
            catch(Exception e){
            }
        }
        TextureLoader tl=new TextureLoader(img,f);
        int bw=1;
        while(bw<w){
            bw=bw*2;
        }
        int bh=1;
        while(bh<h){
            bh=bh*2;
        }
        ImageComponent2D image = tl.getScaledImage(bw,bh);
        tex=new Texture2D();
        int form=tex.getFormat();
        int base=tex.getMipMapMode();
        tex = new Texture2D(base,form,bw,bh);
        tex.setImage(0,image);
        buildq();
    }
    public Polygon(Vektor v1,Vektor v2,Vektor v3,Image img){
        triangle=true;
        this.v1=v1;
        this.v2=v2;
        this.v3=v3;
        Frame f=new Frame();
        int w=img.getWidth(f);
        int h=img.getHeight(f);
        while(w==-1||h==-1){
            try{
                w=img.getWidth(f);
                h=img.getHeight(f);
                Thread.yield();
            }
            catch(Exception e){
            }
        }
        TextureLoader tl=new TextureLoader(img,f);
        int bw=1;
        while(bw<w){
            bw=bw*2;
        }
        int bh=1;
        while(bh<h){
            bh=bh*2;
        }
        ImageComponent2D image = tl.getScaledImage(bw,bh);
        tex=new Texture2D();
        int form=tex.getFormat();
        int base=tex.getMipMapMode();
        tex = new Texture2D(base,form,bw,bh);
        tex.setImage(0,image);
        buildt();
    }
    public void buildt(){
        try{
            pos=new float[9];
            pos[0]=v1.x;
            pos[1]=v1.y;
            pos[2]=v1.z;
            pos[3]=v2.x;
            pos[4]=v2.y;
            pos[5]=v2.z;
            pos[6]=v3.x;
            pos[7]=v3.y;
            pos[8]=v3.z;
            texval=new float[6];
            texval[0]=0.0f;
            texval[1]=0.0f;
            texval[2]=1.0f;
            texval[3]=0.0f;
            texval[4]=0.0f;
            texval[5]=1.0f;
            meshb=new TriangleArray(3,GeometryArray.COORDINATES|GeometryArray.TEXTURE_COORDINATE_2);
            meshb.setCoordinates(0,pos,0,3);
            meshb.setTextureCoordinates(0,0,texval,0,3);
            meshc=new Shape3D(meshb);
            Appearance app=new Appearance();
            PolygonAttributes pa=new PolygonAttributes();
            pa.setCullFace(PolygonAttributes.CULL_NONE);
            app.setPolygonAttributes(pa);
            mesh=new TransformGroup();
            mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
            mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
            app.setTexture(tex);
            meshc.setAppearance(app);
            mesh.addChild(meshc);
            transform=new Transform3D();
            mesh.setTransform(transform);
            bg=new BranchGroup();
            bg.setCapability(BranchGroup.ALLOW_DETACH);
            bg.addChild(mesh);
        }
        catch(Exception e){
        }
    }
    public void buildq(){
        try{
            pos=new float[18];
            pos[0]=v1.x;
            pos[1]=v1.y;
            pos[2]=v1.z;
            pos[3]=v2.x;
            pos[4]=v2.y;
            pos[5]=v2.z;
            pos[6]=v4.x;
            pos[7]=v4.y;
            pos[8]=v4.z;
            pos[9]=v2.x;
            pos[10]=v2.y;
            pos[11]=v2.z;
            pos[12]=v3.x;
            pos[13]=v3.y;
            pos[14]=v3.z;
            pos[15]=v4.x;
            pos[16]=v4.y;
            pos[17]=v4.z;
            texval=new float[12];
            texval[0]=0.0f;
            texval[1]=0.0f;
            texval[2]=1.0f;
            texval[3]=0.0f;
            texval[4]=0.0f;
            texval[5]=1.0f;
            texval[6]=1.0f;
            texval[7]=0.0f;
            texval[8]=1.0f;
            texval[9]=1.0f;
            texval[10]=0.0f;
            texval[11]=1.0f;
            meshb=new TriangleArray(6,GeometryArray.COORDINATES|GeometryArray.TEXTURE_COORDINATE_2);
            meshb.setCoordinates(0,pos,0,6);
            meshb.setTextureCoordinates(0,0,texval,0,6);
            meshc=new Shape3D(meshb);
            Appearance app=new Appearance();
            PolygonAttributes pa=new PolygonAttributes();
            pa.setCullFace(PolygonAttributes.CULL_NONE);
            app.setPolygonAttributes(pa);
            mesh=new TransformGroup();
            mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
            mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
            app.setTexture(tex);
            meshc.setAppearance(app);
            mesh.addChild(meshc);
            transform=new Transform3D();
            mesh.setTransform(transform);
            bg=new BranchGroup();
            bg.setCapability(BranchGroup.ALLOW_DETACH);
            bg.addChild(mesh);
        }
        catch(Exception e){
        }
    }
    public void transform(float x,float y,float z){
        Transform3D tf=new Transform3D();
        tf.setTranslation(new Vector3f(x,y,z));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
    public void rotLeft(float w){
        float w2=(float)(w*180/Math.PI);
        Transform3D tf=new Transform3D();
        tf.setRotation(new AxisAngle4f(0.0f,1.0f,0.0f,w));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
    public void rotUp(float w){
        float w2=(float)(w*180/Math.PI);
        Transform3D tf=new Transform3D();
        tf.setRotation(new AxisAngle4f(1.0f,0.0f,0.0f,w));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
}
class Kugel{
    Kugel next;
    float[]pos=new float[3*3*2*256];
    Transform3D transform;
    TriangleArray meshb;
    Shape3D meshc;
    TransformGroup mesh;
    short radius;
    double[]posf=new double[3*3*2*256];
    BranchGroup bg;
    public Kugel(Vektor middle,int radiusb,int r,int g,int b){
        radius=(short)radiusb;
        for(int i=0;i<16;i++){
            for(int j=0;j<16;j++){
                double wx=((double)i/16.0)*Math.PI*2;
                double wy=((double)j/16.0)*Math.PI-Math.PI/2;
                double wxp=((double)(i+1)/16.0)*Math.PI*2;
                double wyp=((double)(j+1)/16.0)*Math.PI-Math.PI/2;
                double zu=Math.sin(wyp)*radius;
                double zd=Math.sin(wy)*radius;
                double hu=Math.cos(wyp)*radius;
                if(hu<0){
                    hu=-hu;
                }
                double hd=Math.cos(wy)*radius;
                if(hd<0){
                    hd=-hd;
                }
                double xuu=Math.cos(wxp)*hu;
                double yuu=Math.sin(wxp)*hu;
                double xdd=Math.cos(wx)*hd;
                double ydd=Math.sin(wx)*hd;
                double xud=Math.cos(wx)*hu;
                double yud=Math.sin(wx)*hu;
                double zud=zu;
                double xdu=Math.cos(wxp)*hd;
                double ydu=Math.sin(wxp)*hd;
                double zdu=zd;
                posf[(i*16+j)*18]=xdd;
                posf[(i*16+j)*18+1]=ydd;
                posf[(i*16+j)*18+2]=zd;
                posf[(i*16+j)*18+3]=xuu;
                posf[(i*16+j)*18+4]=yuu;
                posf[(i*16+j)*18+5]=zu;
                posf[(i*16+j)*18+6]=xud;
                posf[(i*16+j)*18+7]=yud;
                posf[(i*16+j)*18+8]=zud;

                posf[(i*16+j)*18+9]=xdd;
                posf[(i*16+j)*18+10]=ydd;
                posf[(i*16+j)*18+11]=zd;
                posf[(i*16+j)*18+12]=xuu;
                posf[(i*16+j)*18+13]=yuu;
                posf[(i*16+j)*18+14]=zu;
                posf[(i*16+j)*18+15]=xdu;
                posf[(i*16+j)*18+16]=ydu;
                posf[(i*16+j)*18+17]=zdu;
            }
        }
        for(int i=0;i<3*3*2*16*16;i++){
            pos[i]=(float)posf[i];
        }
        meshb=new TriangleArray(3*2*16*16,GeometryArray.COORDINATES|GeometryArray.COLOR_3);
        meshb.setCoordinates(0,pos,0,3*2*16*16);
        byte[]colbyte=new byte[3*3*2*16*16];
        for(int i=0;i<3*2*16*16;i++){
            colbyte[i*3]=(byte)r;
            colbyte[i*3+1]=(byte)g;
            colbyte[i*3+2]=(byte)b;
        }
        meshb.setColors(0,colbyte);
        meshc=new Shape3D(meshb);
        Appearance app=new Appearance();
        PolygonAttributes pa=new PolygonAttributes();
        pa.setCullFace(PolygonAttributes.CULL_NONE);
        app.setPolygonAttributes(pa);
        meshc.setAppearance(app);
        transform=new Transform3D();
        transform.setTranslation(new Vector3f(middle.x,middle.y,middle.z));
        mesh=new TransformGroup();
        mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        mesh.addChild(meshc);
        mesh.setTransform(transform);
        bg=new BranchGroup();
        bg.setCapability(BranchGroup.ALLOW_DETACH);
        bg.addChild(mesh);
    }
    public void transform(float x,float y,float z){
        Transform3D tf=new Transform3D();
        tf.setTranslation(new Vector3f(x,y,z));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
    public void rotLeft(float w){
        float w2=(float)(w/Math.PI*180.0f);
        Transform3D tf=new Transform3D();
        tf.setRotation(new AxisAngle4f(0.0f,1.0f,0.0f,w));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
    public void rotUp(float w){
        float w2=(float)(w/Math.PI*180.0f);
        Transform3D tf=new Transform3D();
        tf.setRotation(new AxisAngle4f(1.0f,0.0f,0.0f,w));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
}
class MatMult{
    public static void multleft(Transform3D original,Transform3D mult){
        float[]a=new float[16];
        mult.get(a);
        float[][]a2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                a2[i][j]=a[i*4+j];
            }
        }
        float[]b=new float[16];
        original.get(b);
        float[][]b2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                b2[i][j]=b[i*4+j];
            }
        }
        float[][]c2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                for(int k=0;k<4;k++){
                    c2[i][j]=c2[i][j]+a2[i][k]*b2[k][j];
                }
            }
        }
        float[]c=new float[16];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                c[i*4+j]=c2[i][j];
            }
        }
        original.set(c);
    }
}
class Vektor{
    short x;
    short y;
    short z;
    public Vektor(int x,int y,int z){
        this.x=(short)x;
        this.y=(short)y;
        this.z=(short)z;
    }
}
class Projection{
    public static float[] convert(float[][]pro){
        float[]ret=new float[16];
        ret[0]=pro[0][0];
        ret[1]=pro[0][1];
        ret[2]=pro[0][2];
        ret[3]=pro[0][3];
        ret[4]=pro[1][0];
        ret[5]=pro[1][1];
        ret[6]=pro[1][2];
        ret[7]=pro[1][3];
        ret[8]=pro[2][0];
        ret[9]=pro[2][1];
        ret[10]=pro[2][2];
        ret[11]=pro[2][3];
        ret[12]=pro[3][0];
        ret[13]=pro[3][1];
        ret[14]=pro[3][2];
        ret[15]=pro[3][3];
        return ret;
    }
    public static float[] normalize(float[]v){
        float[]ret=new float[3];
        float len=(float)Math.sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]);
        ret[0]=v[0]/len;
        ret[1]=v[1]/len;
        ret[2]=v[2]/len;
        return ret;
    }
    public static float[] vectorproduct(float[]a,float[]b){
        float[]ret=new float[3];
        ret[0]=a[1]*b[2]-a[2]*b[1];
        ret[1]=a[2]*b[0]-a[0]*b[2];
        ret[2]=a[0]*b[1]-a[1]*b[0];
        return ret;
    }
    public static float[][] projection(float eyex,float eyey,float eyez,float centerx,float centery,float centerz,float upx,float upy,float upz){
        float[]f=new float[3];
        f[0]=centerx-eyex;
        f[1]=centery-eyey;
        f[2]=centerz-eyez;
        float[]f2=normalize(f);
        float[]up=new float[3];
        up[0]=upx;
        up[1]=upy;
        up[2]=upz;
        float[]up2=normalize(up);
        float[]s=vectorproduct(f2,up2);
        float[]u=vectorproduct(s,f2);
        float[][]ret=new float[4][4];
        ret[0][0]=s[0];
        ret[0][1]=s[1];
        ret[0][2]=s[2];
        ret[0][3]=0;
        ret[1][0]=u[0];
        ret[1][1]=u[1];
        ret[1][2]=u[2];
        ret[1][3]=0;
        ret[2][0]=-f2[0];
        ret[2][1]=-f2[1];
        ret[2][2]=-f2[2];
        ret[2][3]=0;
        ret[3][0]=0;
        ret[3][1]=0;
        ret[3][2]=0;
        ret[3][3]=1;
        return ret;
    }
}
class MatMult2{
    public static void multleft(Transform3D original,Transform3D mult){
        float[]a=new float[16];
        mult.get(a);
        float[][]a2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                a2[i][j]=a[i*4+j];
            }
        }
        float[]b=new float[16];
        original.get(b);
        float[][]b2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                b2[i][j]=b[i*4+j];
            }
        }
        float[][]c2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                for(int k=0;k<4;k++){
                    c2[i][j]=c2[i][j]+a2[i][k]*b2[k][j];
                }
            }
        }
        float[]c=new float[16];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                c[i*4+j]=c2[i][j];
            }
        }
        original.set(c);
    }
}
class KeyboardMapperAppletSwing extends JPanel implements ActionListener,KeyListener,MouseListener{
    JLabel info;
    ListBox l;
    JButton remove;
    JButton addspecial;
    JButton apply;
    JButton cancel;
    JButton dontapply;
    boolean cancelb=false;
    boolean applyb=false;
    boolean closed=false;
    int kstatus=0;
    int aliasx=0;
    KeyMapperTable kmt;
    JApplet applet;
    int[]alias=new int[0];
    int[]key=new int[0];
    boolean[]special=new boolean[0];
    private static final long serialVersionUID = 5772434866526097156L;
    public KeyboardMapperAppletSwing(JApplet applet){
        setSize(400,400);
        setLayout(null);
        this.applet=applet;
        info=new JLabel("");
        l=new ListBox();
        remove=new JButton("remove");
        addspecial=new JButton("add special key");
        apply=new JButton("apply");
        cancel=new JButton("cancel");
        dontapply=new JButton("don't apply");
        add(info);
        add(l);
        add(remove);
        add(addspecial);
        add(apply);
        add(cancel);
        add(dontapply);
        info.setBounds(10,10,380,27);
        l.setBounds(10,40,380,170);
        remove.setBounds(10,250,80,27);
        addspecial.setBounds(10,280,380,27);
        apply.setBounds(10,310,80,27);
        cancel.setBounds(210,310,80,27);
        dontapply.setBounds(10,340,160,27);
        kmt=new KeyMapperTable();
        loadfirst();
        savekmt();
        remove.addActionListener(this);
        addspecial.addActionListener(this);
        apply.addActionListener(this);
        cancel.addActionListener(this);
        dontapply.addActionListener(this);
        addKeyListener(this);
        addMouseListener(this);
        info.setOpaque(true);
        info.setBackground(Color.white);
    }
    public InputStream getInputStream(String filename){
        try{
            InputStream is=applet.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
        }
        return null;
    }
    public synchronized void mousePressed(MouseEvent me) {
        requestFocus();
        l.click(me.getX()-10,me.getY()-40);
        l.repaint();
    }
    public synchronized void mouseReleased(MouseEvent e) {
    }
    public synchronized void mouseExited(MouseEvent e) {
    }
    public synchronized void mouseEntered(MouseEvent e) {
    }
    public synchronized void mouseClicked(MouseEvent e) {
    }
    public int getKeyCode(int a){
        int n=alias.length;
        for(int i=0;i<n;i++){
            if(alias[i]==a){
                return key[i];
            }
        }
        return a;
    }
    public void savekmt(){
        alias=kmt.alias;
        key=kmt.key;
        special=kmt.special;
    }
    public void restorekmt(){
        kmt.alias=alias;
        kmt.key=key;
        kmt.special=special;
        l.reset();
        int n=key.length;
        for(int i=0;i<n;i++){
            l.addElement("special key "+alias[i]+" alias for "+key[i]);
        }
        l.repaint();
    }
    public void loadfirst(){
        try{
            FileInputStream fis=new FileInputStream("keymapforus.ini");
            fis.close();
            load("keymapforus.ini");
            info.setText("keymapforus.ini loaded and not applied");
        }
        catch(Exception e){
        }
    }
    public void load(String filename){
        try{
            FileInputStream fis=new FileInputStream(filename);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            String inp=null;
            while((inp=dis.readLine())!=null){
                String inp2=dis.readLine();
                String inp3=dis.readLine();
                kmt.addspecial(inp,inp2);
            }
            dis.close();
            fis.close();
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            int n=alias.length;
            for(int i=0;i<n;i++){
                l.addElement("special key "+alias[i]+" alias for "+key[i]);
            }
            l.repaint();
        }
        catch(Exception e){
            info.setText("File not found: "+filename);
        }
    }
    public void keyTyped(KeyEvent e){
    }
    public synchronized void keyPressed(KeyEvent e){
        requestFocus();
        int ekey=e.getKeyCode();
        if(kstatus==1){
            aliasx=ekey;
            kstatus=2;
            info.setText("type key");
        }
        else if(kstatus==2){
            int keyx=ekey;
            kstatus=0;
            info.setText("special key added");
            info.setBackground(Color.white);
            kmt.addspecial(""+aliasx,""+keyx);
            l.addElement("special key "+aliasx+" alias for "+keyx);
            l.repaint();
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void actionPerformed(ActionEvent evt){
        if(evt.getSource()==remove){
            int ind=l.getSelectedIndex();
            if(ind!=-1){
                l.removeElementAt(ind);
                kmt.remove(ind);
                l.repaint();
            }
        }
        if(evt.getSource()==addspecial){
            info.setText("type alias");
            kstatus=1;
            info.setBackground(Color.yellow);
            requestFocus();
        }
        if(evt.getSource()==apply){
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            applyb=true;
            closed=true;
            setVisible(false);
        }
        if(evt.getSource()==cancel){
            restorekmt();
            cancelb=true;
            closed=true;
            setVisible(false);
        }
        if(evt.getSource()==dontapply){
            applyb=false;
            info.setText("KeyboardMapper isn't applied");
        }
    }
}
class KeyMapperTable{
    int[]alias=new int[0];
    int[]key=new int[0];
    boolean[]special=new boolean[0];
    public KeyMapperTable(){
    }
    public void reset(){
        alias=new int[0];
        key=new int[0];
        special=new boolean[0];
    }
    public void addspecial(String a,String b){
        int n=alias.length;
        int[]aliasb=new int[n+1];
        int[]keyb=new int[n+1];
        boolean[]specialb=new boolean[n+1];
        for(int i=0;i<n;i++){
            aliasb[i]=alias[i];
            keyb[i]=key[i];
            specialb[i]=special[i];
        }
        try{
            aliasb[n]=new Integer(a).intValue();
            keyb[n]=new Integer(b).intValue();
        }
        catch(Exception exc){
        }
        specialb[n]=true;
        alias=aliasb;
        key=keyb;
        special=specialb;
    }
    public void remove(int ind){
        int n=alias.length;
        if(n>0){
            int[]aliasb=new int[n-1];
            int[]keyb=new int[n-1];
            boolean[]specialb=new boolean[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind){
                }
                else{
                    aliasb[ib]=alias[i];
                    keyb[ib]=key[i];
                    specialb[ib]=special[i];
                    ib=ib+1;
                }
            }
            alias=aliasb;
            key=keyb;
            special=specialb;
        }
    }
}
class ListBox extends JPanel{
    String[]thestrings=new String[0];
    GetImgKeyboardMapper gikm;
    Image img;
    int uppest=0;
    int n=0;
    int ind=-1;
    private static final long serialVersionUID = -457533304480165971L;
    public ListBox(){
        setLayout(null);
        gikm=new GetImgKeyboardMapper();
        img=gikm.img;
        repaint();
    }
    public synchronized void reset(){
        thestrings=new String[0];
        n=0;
        uppest=0;
        ind=-1;
    }
    public synchronized void setListData(String[]str){
        thestrings=str;
        n=thestrings.length;
    }
    public synchronized void addElement(String s){
        String[]thestrings2=new String[n+1];
        for(int i=0;i<n;i++){
            thestrings2[i]=thestrings[i];
        }
        thestrings2[n]=s;
        n=n+1;
        thestrings=thestrings2;
        uppest=n-8;
        if(uppest<0){
            uppest=0;
        }
    }
    public synchronized void removeElementAt(int ind2){
        int n=thestrings.length;
        if(n>0){
            if(ind==ind2){
                ind=-1;
            }
            else if(ind>ind2){
                ind=ind-1;
            }
            String[]thestrings2=new String[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind2){
                }
                else{
                    thestrings2[ib]=thestrings[i];
                    ib=ib+1;
                }
            }
            thestrings=thestrings2;
            this.n=n-1;
            if(uppest+8>=n){
                uppest=uppest-1;
                if(uppest<0){
                    uppest=0;
                }
            }
        }
    }
    public synchronized int getSelectedIndex(){
        return ind;
    }
    public synchronized void click(int x,int y){
        if(x>=10&&x<370&&y>=5&&y<5+16){
            uppest=uppest-1;
            if(uppest<0){
                uppest=0;
            }
        }
        if(x>=10&&x<370&&y>=5+9*16&&y<5+9*16+16){
            uppest=uppest+1;
            if(uppest+8>n){
                uppest=uppest-1;
            }
        }
        if(x>=10&&x<370&&y>=5+16&&y<5+8*16+16){
            int ind2=(y-5-16)/16+uppest;
            if(ind2>=0&&ind2<n){
                ind=ind2;
            }
        }
    }
    public synchronized void paint(Graphics g){
        Graphics h=img.getGraphics();
        h.setColor(Color.white);
        h.fillRect(0,0,380,170);
        h.setColor(Color.black);
        for(int i=0;i<10;i++){
            h.setColor(Color.black);
            if(ind==uppest+i-1&&ind!=-1&&i!=0&&i!=9){
                h.setColor(Color.green);
            }
            h.drawRect(10,5+i*16,360,15);
        }
        h.setColor(Color.black);
        if(uppest==0){
            h.setColor(Color.red);
        }
        h.drawString("UP",12,5+14);
        h.setColor(Color.black);
        if(uppest+8>=n){
            h.setColor(Color.red);
        }
        h.drawString("DOWN",12,5+9*16+14);
        h.setColor(Color.black);
        for(int i=0;i<8;i++){
            h.setColor(Color.black);
            if(ind==uppest+i&&ind!=-1){
                h.setColor(Color.green);
            }
            int theindex=uppest+i;
            if(theindex<n){
                h.drawString(thestrings[theindex],12,5+16+i*16+14);
            }
        }
        g.drawImage(img,0,0,this);
    }
}
class GetImgKeyboardMapper extends JFrame{
    Image img;
    private static final long serialVersionUID = -8478639040178665797L;
    public GetImgKeyboardMapper(){
        pack();
        img=createImage(380,170);
    }
}
