import java.awt.*;
import java.io.*;
import java.net.*;
import java.applet.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.*;
public class Darkworld3 extends JApplet implements Runnable,KeyListener,MouseListener,MouseMotionListener,ActionListener{
    Thread t;
    Vector<String> lcontent;
    JList<String> l;
    JScrollPane spl;
    JButton select;
    JPanel p;
    String slev="";
    boolean running=true;
    boolean rune=false;
    MediaTracker tracker;
    XPanelDarkworld3 xp;
    static Darkworld3 app;
    private static final long serialVersionUID = 1269960984936458274L;
    public void init(){
        app=this;
        setSize(640,520);
        setLayout(null);
        p=new JPanel();
        p.setLayout(null);
        lcontent=new Vector<String>();
        l=new JList<String>();
        spl=new JScrollPane(l);
        select=new JButton("start");
        p.add(spl);
        p.add(select);
        spl.setBounds(10,40,380,300);
        select.setBounds(10,350,380,27);
        add(p);
        p.setBounds(0,0,400,440);
        loadLevs();
        setVisible(true);
        setFocusable(true);
        requestFocus();
        addKeyListener(this);
        addMouseListener(this);
        addMouseMotionListener(this);
        select.addActionListener(this);
        t=new Thread(this);
        t.start();
    }
    public void run(){
        while(running){
            try{
                Thread.sleep(100);
                if(rune){
                    rune=false;
                    xp=new XPanelDarkworld3(this,slev);
                    p.setVisible(false);
                    add(xp);
                    xp.setBounds(0,40,640,480);
                }
            }
            catch(Exception e){
            }
        }
    }
    public void loadLevs(){
        try{
            InputStream fis=getInputStream("levs.ini");
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            String s="";
            while((s=dis.readLine())!=null){
                lcontent.addElement(s);
            }
            dis.close();
            fis.close();
            l.setListData(lcontent);
        }
        catch(Exception e){
        }
    }
    public static Image getImage(String filename){
        try{
            URL url=app.getClass().getResource("/"+filename);
            Image img=app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public static InputStream getInputStream(String filename){
        return app.getClass().getResourceAsStream("/"+filename);
    }
    public static void main(String[]args){
        new Darkworld3();
    }
    public void actionPerformed(ActionEvent ae){
            if(ae.getSource()==select){
                int ind=l.getSelectedIndex();
                if(ind!=-1&&ind<lcontent.size()){
                    rune=true;
                    slev=lcontent.elementAt(ind);
                }
            }
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        int key=e.getKeyCode();
        if(key>0){
            process(e);
        }
//System.out.println("kpressed"+key);
    }
    public void keyReleased(KeyEvent e){
    }
    public void mousePressed(MouseEvent me) {
        requestFocus();
        mprocess(me);
    }
    public void mouseReleased(MouseEvent e) {
    }
    public void mouseEntered(MouseEvent e) {
    }
    public void mouseExited(MouseEvent e) {
    }
    public void mouseClicked(MouseEvent e) {
    }
    public void mouseDragged(MouseEvent e){
    }
    public void mouseMoved(MouseEvent evt){
        requestFocus();
        mmprocess(evt);
    }
    public void process(KeyEvent evt){
        int key=evt.getKeyCode();
            if(key==27||key==KeyEvent.VK_ESCAPE){
                xp.running=false;
                remove(xp);
                p.setVisible(true);
            }
    }
    public void mmprocess(MouseEvent me){
        if(xp!=null&&xp.xc!=null){
            xp.xc.mousex=me.getX();
            xp.xc.mousey=me.getY()-40;
        }
    }
    public void mprocess(MouseEvent me){
        if(xp!=null&&xp.xc!=null){
            if(xp.xc.lifes<=0){
                return;
            }
            int diffx=me.getX()-320;
            int diffy=me.getY()-280;
            double alpha=Math.atan((double)diffy/(double)diffx);
            if(diffx<0){
                alpha=alpha+Math.PI;
            }
            xp.xc.addkugelb(xp.xc.xpos,xp.xc.ypos,Math.cos(alpha)*13,Math.sin(alpha)*13,true);
        }
    }
}
class XPanelDarkworld3 extends JPanel implements Runnable{
    Enemy start;
    Enemy end;
    EnemyInstance estart;
    EnemyInstance eend;
    BPicture bstart;
    BPicture bend;
    PicInstance pstart;
    PicInstance pend;
    String lev;
    Darkworld3 dw;
    Thread t;
    boolean running=true;
    XCanvasDarkworld3 xc;
    int sx;
    int sy;
    int enemies=0;
    String background;
    private static final long serialVersionUID = -5989157101128906986L;
    public XPanelDarkworld3(Darkworld3 dw,String lev){
        setLayout(null);
        this.dw=dw;
        this.lev=lev;
        t=new Thread(this);
        t.start();
    }
    public void addEnemy(String file){
        Enemy nen=new Enemy(dw);
        nen.load(file);
        if(nen.ok){
            if(start==null){
                start=nen;
                end=nen;
            }
            else{
                end.next=nen;
                end=end.next;
            }
        }
    }
    public void addInst(String file,int x,int y){
        Enemy cur=start;
        while(cur!=null&&!file.equals(cur.file)){
            cur=cur.next;
        }
        if(cur!=null){
            EnemyInstance en=new EnemyInstance(cur,x,y);
            if(estart==null){
                estart=en;
                eend=en;
            }
            else{
                eend.next=en;
                eend=eend.next;
            }
        }
    }
    public void addpic(String file){
        BPicture nen=new BPicture(dw,file);
        if(nen.ok){
            if(bstart==null){
                bstart=nen;
                bend=nen;
            }
            else{
                bend.next=nen;
                bend=bend.next;
            }
        }
    }
    public void addpicinst(String file,int x,int y){
        BPicture bcur=bstart;
        while(bcur!=null&&!file.equals(bcur.bname)){
            bcur=bcur.next;
        }
        if(bcur!=null){
            PicInstance en=new PicInstance(bcur,x,y);
            if(pstart==null){
                pstart=en;
                pend=en;
            }
            else{
                pend.next=en;
                pend=pend.next;
            }
        }
    }
    public void loadLev(){
        try{
            InputStream fis=Darkworld3.getInputStream(lev);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            if("darkwarhorizontal level".equals(dis.readLine())){
                start=null;
                estart=null;
                String s=dis.readLine();
                background=dis.readLine();
                s=dis.readLine();
                sx=Integer.parseInt(dis.readLine());
                s=dis.readLine();
                sy=Integer.parseInt(dis.readLine());
                s=dis.readLine();
                while(("enemyname".equals(s=dis.readLine()))){
                    addEnemy(dis.readLine());
                }
                while("enemy".equals(s)){
                    enemies++;
                    String efile=dis.readLine();
                    s=dis.readLine();
                    int xv=Integer.parseInt(dis.readLine());
                    s=dis.readLine();
                    int yv=Integer.parseInt(dis.readLine());
                    addInst(efile,xv,yv);
                    s=dis.readLine();
                }
                while("picname".equals(s=dis.readLine())){
                    addpic(dis.readLine());
                }
                while("pic".equals(s)){
                    String pfile=dis.readLine();
                    s=dis.readLine();
                    int xv=Integer.parseInt(dis.readLine());
                    s=dis.readLine();
                    int yv=Integer.parseInt(dis.readLine());
                    addpicinst(pfile,xv,yv);
                    s=dis.readLine();
                }
            }
            dis.close();
            fis.close();
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
    }
    public void run(){
        Darkworld3.app.tracker=new MediaTracker(this);
        loadLev();
        xc=new XCanvasDarkworld3(this);
        add(xc);
        xc.setBounds(0,0,640,480);
        while(running){
            try{
                Thread.sleep(100);
                xc.painted=false;
                xc.repaint();
            }
            catch(Exception e){
                e.printStackTrace(System.out);
            }
        }
    }
}
class Kugel{
    double x;
    double y;
    double xdrift;
    double ydrift;
    boolean yours;
    int count=25;
    public Kugel(double x,double y,double xdrift,double ydrift,boolean yours){
        this.x=x;
        this.y=y;
        this.xdrift=xdrift;
        this.ydrift=ydrift;
        this.yours=yours;
    }
}
class XCanvasDarkworld3 extends JPanel{
    XPanelDarkworld3 xp;
    boolean painted=true;
    Image img;
    Graphics h;
    int framex;
    int framey;
    double xpos;
    double ypos;
    double xdrift=0;
    double ydrift=0;
    Image player;
    int mousex=320;
    int mousey=240;
    boolean loso=false;
    int framex0;
    int framey0;
    int bw=0;
    int bh=0;
    int enemies=0;
    int lifes=10;
    Kugel[]kugel=new Kugel[1000];
    Image background;
    private static final long serialVersionUID = 2438158236450546932L;
    public XCanvasDarkworld3(XPanelDarkworld3 xp){
        this.xp=xp;
        framex=xp.sx-320;
        framey=xp.sy-240;
        framex0=framex;
        framey0=framey;
        xpos=xp.sx;
//System.out.println("xp.sx: "+xp.sx+" xpos: "+xpos);
        ypos=xp.sy;
        player=Darkworld3.getImage("yours.gif");
        background=Darkworld3.getImage(xp.background);
        Darkworld3.app.tracker.addImage(player,0);
        Darkworld3.app.tracker.addImage(background,0);
        try{
            Darkworld3.app.tracker.waitForID(0);
        }
        catch(Exception me){
        }
        while(bw<=0||bh<=0){
            try{
                bw=background.getWidth(this);
                bh=background.getHeight(this);
            }
            catch(Exception exc){
            }
        }
        ImFrameDarkworld3 im=new ImFrameDarkworld3();
        img=im.img;
        h=img.getGraphics();
    }
    public void addkugel(double x,double y,double xdrift,double ydrift,boolean yours){
        int pos=0;
        while(pos<1000&&kugel[pos]!=null){
            pos++;
        }
        if(pos==1000){
            pos=(int)(Math.random()*1000);
        }
        kugel[pos]=new Kugel(x,y,xdrift,ydrift,yours);
    }
    public synchronized void addkugelb(double x,double y,double xdrift,double ydrift,boolean yours){
        int pos=0;
        while(pos<1000&&kugel[pos]!=null){
            pos++;
        }
        if(pos==1000){
            pos=(int)(Math.random()*1000);
        }
        kugel[pos]=new Kugel(x,y,xdrift,ydrift,yours);
    }
//    public void paint(Graphics g){
//    }
    public synchronized void paint(Graphics g){
        if(painted){
            return;
        }
        double alpha=Math.PI/2;
        if(mousey-240<0){
            alpha=3*Math.PI/2;
        }
        if(mousex-320!=0){
            alpha=Math.atan(((double)mousey-240)/(mousex-320));
        }
        if(mousex-320<0){
            alpha=alpha+Math.PI;
        }
        xdrift=Math.cos(alpha);
        ydrift=Math.sin(alpha);
        xpos=xpos+xdrift*8;
        ypos=ypos+ydrift*8;
//System.out.println("xpos: "+xpos+" xdrift: "+xdrift);
        framex=(int)(xpos-320);
        framey=(int)(ypos-240);
        int framexs=framex0;
        int frameys=framey0;
        while(framexs>framex){
            framexs=framexs-bw;
        }
        while(framexs<framex){
            framexs=framexs+bw;
        }
        framexs=framexs-bw;
        while(frameys>framey){
            frameys=frameys-bh;
        }
        while(frameys<framey){
            frameys=frameys+bh;
        }
        frameys=frameys-bh;
        h.setColor(Color.black);
        h.fillRect(0,0,480+200,480+200);
        int wd=2*(640+200)/bw;
        int hd=2*(480+200)/bh;
        for(int i=0;i<wd+1;i++){
            for(int j=0;j<hd+1;j++){
                h.drawImage(background,framexs+bw*i-framex+100,frameys+bh*j-framey+100,this);
            }
        }
        PicInstance pcur=xp.pstart;
        while(pcur!=null){
            if(pcur.x-framex>=-pcur.origin.pic.getWidth(this)&&pcur.x-framex<640&&pcur.y-framey>=-pcur.origin.pic.getWidth(this)&&pcur.y-framey<480){
                h.drawImage(pcur.origin.pic,pcur.x-framex+100,pcur.y-framey+100,this);
            }
            pcur=pcur.next;
        }
        EnemyInstance cur=xp.estart;
        while(cur!=null){
            if(cur.origin.art>=3){
                cur.x=cur.x+cur.xdrift;
                cur.y=cur.y+cur.ydrift;
            }
            double entf=Math.sqrt((cur.x-xpos)*(cur.x-xpos)+(cur.y-ypos)*(cur.y-ypos));
            if(entf<20){
                loso=true;
            }
            if(entf>1000||cur.origin.art>=4){
                cur.xdrift=(xpos-cur.x)/entf*3;
                cur.ydrift=(ypos-cur.y)/entf*3;
            }
            if(cur.origin.art>=1){
                int m=(int)(Math.random()*120);
                if(m<=cur.origin.art){
                    double xd=xpos-cur.x;
                    double yd=ypos-cur.y;
                    double alp=Math.atan(yd/xd);
                    if(xd<0){
                        alp=alp+Math.PI;
                    }
                    addkugel(cur.x,cur.y,Math.cos(alp)*6,Math.sin(alp)*6,false);
                }
            }
            for(int i=0;i<1000;i++){
                if(kugel[i]!=null&&kugel[i].yours&&cur.status==0){
                    double entfb=Math.sqrt((cur.x-kugel[i].x)*(cur.x-kugel[i].x)+(cur.y-kugel[i].y)*(cur.y-kugel[i].y));
                    if(entfb<20){
                        cur.shield--;
                        if(cur.shield<0){
                            cur.status=1;
                            kugel[i]=null;
                            enemies++;
                        }
                    }
                }
            }
            if(cur.x-framex>=-100&&cur.x-framex<640&&cur.y-framey>=-100&&cur.y-framey<480){
                if(cur.status==0){
                    h.drawImage(cur.origin.pimg,(int)cur.x-framex+100,(int)cur.y-framey+100,this);
                }
                else if(cur.status==1){
                    h.drawImage(cur.origin.fimg1,(int)cur.x-framex+100,(int)cur.y-framey+100,this);
                }
                else if(cur.status==2){
                    h.drawImage(cur.origin.fimg2,(int)cur.x-framex+100,(int)cur.y-framey+100,this);
                }
                else if(cur.status==3){
                    h.drawImage(cur.origin.fimg3,(int)cur.x-framex+100,(int)cur.y-framey+100,this);
                }
                if(cur.status==0){
                    double xd=xpos-cur.x;
                    double yd=ypos-cur.y;
                    double alp=Math.atan(yd/xd);
                    if(xd<0){
                        alp=alp+Math.PI;
                    }
                    h.setColor(Color.black);
                    h.drawLine((int)cur.x-framex+120,(int)cur.y-framey+120,(int)cur.x-framex+(int)(Math.cos(alp)*20)+120,(int)cur.y-framey+(int)(Math.sin(alp)*20)+120);
                }
            }
            if(cur.status>=1&&cur.status<4){
                cur.status++;
            }
            cur=cur.next;
        }
        for(int i=0;i<1000;i++){
            if(kugel[i]!=null&&kugel[i].count>=0){
                kugel[i].count--;
                kugel[i].x=kugel[i].x+kugel[i].xdrift;
                kugel[i].y=kugel[i].y+kugel[i].ydrift;
                if(kugel[i].yours&&kugel[i].x>=framex&&kugel[i].x<framex+640&&kugel[i].y>=framey&&kugel[i].y<framey+480){
                    h.setColor(Color.yellow);
                    h.fillOval(100+(int)kugel[i].x-framex-2,100+(int)kugel[i].y-framey-2,4,4);
                }
                else{
                    if(kugel[i].x>=framex&&kugel[i].x<framex+640&&kugel[i].y>=framey&&kugel[i].y<framey+480){
                        h.setColor(Color.red);
                        h.fillOval(100+(int)kugel[i].x-framex-2,100+(int)kugel[i].y-framey-2,4,4);
                    }
                    double entf=Math.sqrt((kugel[i].x-xpos)*(kugel[i].x-xpos)+(kugel[i].y-ypos)*(kugel[i].y-ypos));
                    if(entf<40){
                        loso=true;
                        kugel[i]=null;
                    }
                }
            }
        }
        if(loso){
            loso=false;
            lifes--;
            xpos=xp.sx;
            ypos=xp.sy;
        }
        h.setColor(Color.blue);
        if(lifes<=0){
            h.drawString("You have lost! enemies: "+enemies+"/"+xp.enemies,120,120);
        }
        else if(enemies==xp.enemies){
            h.drawString("You have won! enemies: "+enemies+" lifes: "+lifes,120,120);
        }
        else{
            h.drawString("enemies: "+enemies+"/"+xp.enemies+" lifes: "+lifes,120,120);
        }
        h.drawImage(player,320+100-20,240+100-20,this);
        h.drawLine(320+100,240+100,320+100+(int)(xdrift*20),240+100+(int)(ydrift*20));
        g.drawImage(img,-100,-100,this);
//        paint(g);
        painted=true;
    }
}
class ImFrameDarkworld3 extends JFrame{
    Image img;
    private static final long serialVersionUID = 8840869525645597058L;
    public ImFrameDarkworld3(){
        pack();
        img=createImage(480+200,480+200);
    }
}
class EnemyInstance{
    EnemyInstance next;
    Enemy origin;
    double x;
    double y;
    double xdrift;
    double ydrift;
    int status=0;
    int shield;
    public EnemyInstance(Enemy origin,int x,int y){
        this.origin=origin;
        this.x=x;
        this.y=y;
        xdrift=origin.xdrift;
        ydrift=origin.ydrift;
        shield=origin.shield;
        if(origin.randomspeed==1){
            double db=Math.random()*(origin.alphamax-origin.alphamin)+origin.alphamin;
            xdrift=Math.cos(db)*3;
            ydrift=Math.sin(db)*3;
        }
    }
}
class Enemy{
    Enemy next;
    String file;
    int art;
    int shield;
    int torpedoart;
    double torpedospeed;
    int w;
    int h;
    double xdrift;
    double ydrift;
    double speed;
    int randomspeed;
    double alphamin;
    double alphamax;
    String picture;
    String fire1;
    String fire2;
    String fire3;
    Image pimg;
    Image fimg1;
    Image fimg2;
    Image fimg3;
    boolean ok=false;
    Applet f;
    public Enemy(Applet f){
        this.f=f;
    }
    public void load(String file){
        this.file=file;
        try{
            InputStream fis=Darkworld3.getInputStream(file);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            art=Integer.parseInt(dis.readLine());
            shield=Integer.parseInt(dis.readLine());
            torpedoart=Integer.parseInt(dis.readLine());
            torpedospeed=Double.parseDouble(dis.readLine());
            w=Integer.parseInt(dis.readLine());
            h=Integer.parseInt(dis.readLine());
            xdrift=Double.parseDouble(dis.readLine());
            ydrift=Double.parseDouble(dis.readLine());
            speed=Double.parseDouble(dis.readLine());
            randomspeed=Integer.parseInt(dis.readLine());
            alphamin=Double.parseDouble(dis.readLine());
            alphamax=Double.parseDouble(dis.readLine());
            picture=dis.readLine();
            fire1=dis.readLine();
            fire2=dis.readLine();
            fire3=dis.readLine();
            dis.close();
            fis.close();
            if(picture!=null&&!"".equals(picture)){
                pimg=Darkworld3.getImage(picture);
                Darkworld3.app.tracker.addImage(pimg,0);
            }
            if(fire1!=null&&!"".equals(fire1)){
                fimg1=Darkworld3.getImage(fire1);
                Darkworld3.app.tracker.addImage(fimg1,0);
            }
            if(fire2!=null&&!"".equals(fire2)){
                fimg2=Darkworld3.getImage(fire2);
                Darkworld3.app.tracker.addImage(fimg2,0);
            }
            if(fire3!=null&&!"".equals(fire3)){
                fimg3=Darkworld3.getImage(fire3);
                Darkworld3.app.tracker.addImage(fimg3,0);
            }
            ok=true;
        }
        catch(Exception e){
            System.out.println("enemy load error");
            e.printStackTrace(System.out);
        }
    }
}
class BPicture{
    BPicture next;
    String bname;
    Image pic;
    int w;
    int h;
    boolean ok=false;
    public BPicture(Applet f,String bname){
        this.bname=bname;
        try{
            pic=Darkworld3.getImage(bname);
            Darkworld3.app.tracker.addImage(pic,0);
            w=pic.getWidth(f);
            h=pic.getHeight(f);
            ok=true;
        }
        catch(Exception e){
            System.out.println("bpicture error: "+bname);
        }
    }
}
class PicInstance{
    PicInstance next;
    BPicture origin;
    int x;
    int y;
    public PicInstance(BPicture origin,int x,int y){
        this.origin=origin;
        this.x=x;
        this.y=y;
    }
}
