import java.applet.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;
import javax.media.j3d.*;
import javax.swing.*;
import javax.vecmath.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.behaviors.vp.*;
import com.sun.j3d.utils.image.*;
public class XRace3DForTwoTex extends JApplet implements Runnable,KeyListener{
    static JApplet app;;
    JLabel l1;
    JLabel l2;
    GameXRace3DForTwoTex g;
    EngineXRace3DForTwoTex eng;
    EngineXRace3DForTwoTex eng2;
    boolean clearb=false;
    Thread t;
    LoaderXRace3DForTwoTex loa;
    Group gr;
    KeyboardMapperAppletSwing km=null;
    private static final long serialVersionUID = -9183504476829067507L;
    public void init(){
        setSize(800,520);
        setLayout(null);
        l2=new JLabel("(1): cursor keys, delete, enter, space (2): s y x c q w d");
        l1=new JLabel("info");
        add(l1);
        add(l2);
        l1.setBounds(10,5,180,27);
        l2.setBounds(210,5,420,27);
        app=this;
        setVisible(true);
        setFocusable(true);
        requestFocus();
        addKeyListener(this);
        t=new Thread(this);
        t.start();
    }
    public void run(){
        km=new KeyboardMapperAppletSwing(this);
        add(km);
        km.setBounds(0,40,400,400);
        km.setVisible(true);
        while(!km.closed){
            try{
                Thread.sleep(100);
            }
            catch(Exception e){
            }
        }
        loa=new LoaderXRace3DForTwoTex(this);
        boolean running=true;
        while(running){
            try{
                Thread.sleep(100);
            }
            catch(Exception e){
            }
            if(clearb){
                clearb=false;
                clear();
            }
        }
    }
    public void destroy(){
        try{
            g.running=false;
            g.t.join();
            g=null;
            eng=null;
            eng2=null;
            loa=null;
            System.gc();
        }
        catch(Exception e){
        }
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        int key=e.getKeyCode();
        if(km!=null&&km.applyb){
            key=km.getKeyCode(key);
        }
        if(key==27||key==KeyEvent.VK_ESCAPE){
            clearb=true;
        }
        if(key!=0&&g!=null){
            eng.keycode=key;
        }
//System.out.println("kpressed"+key);
    }
    public void keyReleased(KeyEvent e){
    }
    public void clear(){
        try{
            if(g!=null){
                g.running=false;
                g.t.join();
//System.out.println("bremo");
                eng.remo();
                eng2.remo();
                remove(g.canvas);
                remove(g.canvas2);
                g=null;
            }
            loa=null;
            eng=null;
            eng2=null;
            l1.setText("reloading");
            System.gc();
            loa=new LoaderXRace3DForTwoTex(this);
//            loa.setTitle("recorded");
        }
        catch(Exception e){
        }
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public static Image getImage(String filename){
        try{
            URL url=app.getClass().getResource("/"+filename);
            Image img=app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
}
class LoaderXRace3DForTwoTex extends JDialog implements ActionListener{
    Vector<String> lcontent;
    JList<String> l;
    JScrollPane spl;
    JLabel levlabel;
    JLabel reclabel;
    Vector<String> l2content;
    JList<String> l2;
    JScrollPane spl2;
    JLabel recfile;
    JTextField filename;
    JButton select;
    XRace3DForTwoTex m;
    private static final long serialVersionUID = -879067923054747505L;
    public LoaderXRace3DForTwoTex(XRace3DForTwoTex m){
        super(new Frame(),"select level",false);
        pack();
        setSize(440,360);
        setLayout(null);
        this.m=m;
        lcontent=new Vector<String>();
        l=new JList<String>(lcontent);
        spl=new JScrollPane(l);
        levlabel=new JLabel("level: ");
        l2content=new Vector<String>();
        l2=new JList<String>(l2content);
        reclabel=new JLabel("play against: ");
        recfile=new JLabel("save as: ");
        filename=new JTextField("game.rac");
        select=new JButton("select");
        add(spl);
        add(levlabel);
//        add(l2);
//        add(reclabel);
//        add(recfile);
//        add(filename);
        add(select);
        levlabel.setBounds(10,40,380,27);
        spl.setBounds(10,70,380,150);
//        reclabel.reshape(10,230,380,27);
//        l2.reshape(10,260,380,150);
//        recfile.reshape(10,420,380,27);
//        filename.reshape(10,450,180,27);
        select.setBounds(10,230,380,27);
        loadFiles();
        select.addActionListener(this);
        setVisible(true);
    }
    public void loadFiles(){
        try{
            InputStream is=XRace3DForTwoTex.getInputStream("levs.ini");
            String ins="";
            while((ins=readLine(is))!=null){
                lcontent.addElement(ins);
            }
            l.setListData(lcontent);
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
    }
    public void reload(){
        try{
        }
        catch(Exception e){
        }
    }
    public static String readLine(InputStream is){
        String ret="";
        boolean bol=true;
        try{
            int in=0;
            while((in=is.read())!=-1&&in!=13){
                byte[]by=new byte[1];
                by[0]=(byte)in;
                bol=false;
                ret=ret+new String(by);
            }
            in=is.read();
        }
        catch(Exception e){
        }
        if(bol)return null;
        return ret;
    }
    public void actionPerformed(ActionEvent evt){
        if(evt.getSource()==select){
            int i1=l.getSelectedIndex();
//System.out.println("i1: "+i1+" "+i2);
            if(i1>=0&&i1<lcontent.size()){
                String name=lcontent.elementAt(i1);
//                String rac=l2.getItem(i2);
                String tfs=filename.getText();
                new GameXRace3DForTwoTex(m,name,tfs,"",true);
                setVisible(false);
            }
        }
    }
}
class ByteHolder{
    int number;
    byte[]by;
    public ByteHolder(int number,byte[]by){
        this.number=number;
        this.by=by;
    }
}
class RecordStore{
    static RecordStore[]recordstores=new RecordStore[0];
    static String[]recordstorenames=new String[0];
    ByteHolder[]bh=new ByteHolder[0];
    String name;
    int number=1;
    public RecordStore(String name){
        this.name=name;
    }
    public static String[] listRecordStores(){
        return recordstorenames;
    }
    public static void deleteRecordStore(String name){
    }
    public void closeRecordStore(){
    }
    public static RecordStore openRecordStore(String name,boolean create){
        RecordStore ret=new RecordStore(name);
        int n=recordstores.length;
        for(int i=0;i<n;i++){
            if(name.equals(recordstores[i].name)){
                return recordstores[i];
            }
        }
        RecordStore[]recordstores2=new RecordStore[n+1];
        String[]recordstorenames2=new String[n+1];
        for(int i=0;i<n;i++){
            recordstores2[i]=recordstores[i];
            recordstorenames2[i]=recordstorenames[i];
        }
        recordstores2[n]=ret;
        recordstorenames2[n]=name;
        recordstores=recordstores2;
        recordstorenames=recordstorenames2;
        return ret;
    }
    public void addRecord(byte[]by,int begin, int end){
        int m=end-begin;
        byte[]b=new byte[m];
        for(int i=0;i<m;i++){
            b[i]=by[begin+i];
        }
        ByteHolder bhb=new ByteHolder(number,by);
        number++;
        int n=bh.length;
        ByteHolder[]bh2=new ByteHolder[n+1];
        for(int i=0;i<n;i++){
            bh2[i]=bh[i];
        }
        bh2[n]=bhb;
        bh=bh2;
    }
    public byte[] getRecord(int num){
        int n=bh.length;
        for(int i=0;i<n;i++){
            if(bh[i].number==num){
                return bh[i].by;
            }
        }
        return new byte[0];
    }
}
class XCanvasXRace3DForTwoTex extends JPanel{
    BufferedImage img;
    private static final long serialVersionUID = -6436181171966521977L;
//    public void paint(Graphics g){
//    }
    public void paint(Graphics g){
        g.drawImage(img,0,0,this);
//        paint(g);
    }
}
class GameXRace3DForTwoTex implements Runnable{
    Thread t;
    XRace3DForTwoTex m;
    String level;
//    Engine eng;
    Image p1front;
    Image p1back;
    Image p1side;
    Image p2back;
    Image p2front;
    Image p2side;
    Image wand;
    Image boden;
    Image dach;
    int[][]screen=new int[30][18];
    Polygon[]polygon=new Polygon[0];
    Group g;
    Group g2;
    Group g3;
    Group g4;
    double axpos=0;
    double aypos=0;
    double azpos=128;
    double xpos=0;
    double ypos=0;
    double zpos=128;
    double alpha=Math.PI/2;
    double beta=-Math.PI/2;
    double alpha2=Math.PI/2;
    double beta2=-Math.PI/2;
    boolean running=true;
    double palpha=0;
    double pbeta=0;
    double dist=128;
    double dist2=128;
    double power=0;
    boolean race=true;
    String reco;
    String rac;
    boolean racen=false;
    double axpos2=0;
    double aypos2=0;
    double azpos2=128;
    double xpos2=0;
    double ypos2=0;
    double zpos2=128;
    double palpha2=0;
    double pbeta2=0;
    double power2=0;
    int rnum=1;
    int laps=0;
    int laps2=0;
    boolean half;
    boolean half2;
    int adist=30*256;
    int adist2=30*256;
    boolean race2=true;
    boolean loadb=false;
    XCanvasXRace3DForTwoTex canvas;
    XCanvasXRace3DForTwoTex canvas2;
    public GameXRace3DForTwoTex(XRace3DForTwoTex m,String level,String rac,String reco,boolean racen){
        this.m=m;
//        this.loa=loa;
        this.level=level;
        this.reco=reco;
        this.rac=rac;
        this.racen=racen;
        m.repaint();
        canvas=new XCanvasXRace3DForTwoTex();
        canvas2=new XCanvasXRace3DForTwoTex();
        m.g=this;
        m.add(canvas);
        m.add(canvas2);
        canvas.setBounds(0,40,400,400);
        canvas2.setBounds(400,40,400,400);
        m.eng=new EngineXRace3DForTwoTex();
        m.eng2=new EngineXRace3DForTwoTex();
        try{
            p1front=XRace3DForTwoTex.getImage("p1front.png");
//System.out.println(p1front);
            p1back=XRace3DForTwoTex.getImage("p1back.png");
//System.out.println(p1back);
            p1side=XRace3DForTwoTex.getImage("p1side.png");
//System.out.println(p1side);
            p2back=XRace3DForTwoTex.getImage("p2back.png");
//System.out.println(p2back);
            p2front=XRace3DForTwoTex.getImage("p2front.png");
//System.out.println(p2front);
            p2side=XRace3DForTwoTex.getImage("p2side.png");
//System.out.println(p2side);
            wand=XRace3DForTwoTex.getImage("wand.png");
//System.out.println(wand);
            boden=XRace3DForTwoTex.getImage("boden.png");
//System.out.println("boden: "+boden);
            dach=XRace3DForTwoTex.getImage("dach.png");
//System.out.println("ok");
        }
        catch(Exception e){
System.out.println("e: "+e);
        }
//System.out.println("rac: "+rac+" reco: "+reco);
        if(true&&!"".equals(rac)){
            t=new Thread(this);
            t.start();
        }
        else{
//            Display disp=Display.getDisplay(m);
//            disp.setCurrent((Displayable)loa);
        }
    }
    public void run(){
        m.repaint();
//System.out.println("level: "+level);
        try{
            InputStream is=XRace3DForTwoTex.getInputStream(""+level);
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    screen[i][j]=is.read();
                    if(screen[i][j]==3){
                        xpos=i*256+128;
                        zpos=j*256+128;
                        axpos=i*256+128;
                        azpos=j*256+128;
                        ypos=128;
                        aypos=128;
                    }
                    if(screen[i][j]==3){
                        xpos2=i*256+128;
                        zpos2=j*256+128;
                        axpos2=i*256+128;
                        azpos2=j*256+128;
                        ypos2=128;
                        aypos2=128;
                    }
                }
            }
            is.close();
            Group gr=new Group();
            Group gr2=new Group();
            for(int i=0;i<30;i++){
                m.l1.setText("loading line: "+i);
//                eng.repaint();
                for(int j=0;j<18;j++){
//System.out.println("i: "+i+" j: "+j+" sc: "+screen[i][j]);
                    if(screen[i][j]!=0&&screen[i][j]!=2){
                        Vektor v1=new Vektor(i*256,0,j*256);
                        Vektor v2=new Vektor(i*256+256,0,j*256);
                        Vektor v3=new Vektor(i*256+256,0,j*256+256);
                        Vektor v4=new Vektor(i*256,0,j*256+256);
                        Polygon pol=new Polygon(v1,v2,v3,v4,dach);
                        gr.add(pol);
                        add(pol);

                        Vektor v12=new Vektor(i*256,0,j*256);
                        Vektor v22=new Vektor(i*256+256,0,j*256);
                        Vektor v32=new Vektor(i*256+256,0,j*256+256);
                        Vektor v42=new Vektor(i*256,0,j*256+256);
                        Polygon pol2=new Polygon(v12,v22,v32,v42,dach);
                        gr2.add(pol2);

                        Vektor v1b=new Vektor(i*256,256,j*256);
                        Vektor v2b=new Vektor(i*256+256,256,j*256);
                        Vektor v3b=new Vektor(i*256+256,256,j*256+256);
                        Vektor v4b=new Vektor(i*256,256,j*256+256);
                        Polygon polb=new Polygon(v1b,v2b,v3b,v4b,boden);
                        gr.add(polb);
                        add(polb);

                        Vektor v1b2=new Vektor(i*256,256,j*256);
                        Vektor v2b2=new Vektor(i*256+256,256,j*256);
                        Vektor v3b2=new Vektor(i*256+256,256,j*256+256);
                        Vektor v4b2=new Vektor(i*256,256,j*256+256);
                        Polygon polb2=new Polygon(v1b2,v2b2,v3b2,v4b2,boden);
                        gr2.add(polb2);
                        if(i==0||screen[i-1][j]==0){
                            Vektor v1c=new Vektor(i*256,256,j*256);
                            Vektor v2c=new Vektor(i*256,256,j*256+256);
                            Vektor v3c=new Vektor(i*256,0,j*256+256);
                            Vektor v4c=new Vektor(i*256,0,j*256);
                            Polygon polc=new Polygon(v1c,v2c,v3c,v4c,wand);
                            gr.add(polc);
                            add(polc);

                            Vektor v1c2=new Vektor(i*256,256,j*256);
                            Vektor v2c2=new Vektor(i*256,256,j*256+256);
                            Vektor v3c2=new Vektor(i*256,0,j*256+256);
                            Vektor v4c2=new Vektor(i*256,0,j*256);
                            Polygon polc2=new Polygon(v1c2,v2c2,v3c2,v4c2,wand);
                            gr2.add(polc2);
                        }
                        if(j==0||screen[i][j-1]==0){
                            Vektor v1d=new Vektor(i*256,256,j*256);
                            Vektor v2d=new Vektor(i*256+256,256,j*256);
                            Vektor v3d=new Vektor(i*256+256,0,j*256);
                            Vektor v4d=new Vektor(i*256,0,j*256);
                            Polygon pold=new Polygon(v1d,v2d,v3d,v4d,wand);
                            gr.add(pold);
                            add(pold);

                            Vektor v1d2=new Vektor(i*256,256,j*256);
                            Vektor v2d2=new Vektor(i*256+256,256,j*256);
                            Vektor v3d2=new Vektor(i*256+256,0,j*256);
                            Vektor v4d2=new Vektor(i*256,0,j*256);
                            Polygon pold2=new Polygon(v1d2,v2d2,v3d2,v4d2,wand);
                            gr2.add(pold2);
                        }
                        if(i==29||screen[i+1][j]==0){
                            Vektor v1e=new Vektor(i*256+256,256,j*256);
                            Vektor v2e=new Vektor(i*256+256,256,j*256+256);
                            Vektor v3e=new Vektor(i*256+256,0,j*256+256);
                            Vektor v4e=new Vektor(i*256+256,0,j*256);
                            Polygon pole=new Polygon(v1e,v2e,v3e,v4e,wand);
                            gr.add(pole);
                            add(pole);

                            Vektor v1e2=new Vektor(i*256+256,256,j*256);
                            Vektor v2e2=new Vektor(i*256+256,256,j*256+256);
                            Vektor v3e2=new Vektor(i*256+256,0,j*256+256);
                            Vektor v4e2=new Vektor(i*256+256,0,j*256);
                            Polygon pole2=new Polygon(v1e2,v2e2,v3e2,v4e2,wand);
                            gr2.add(pole2);
                        }
                        if(j==17||screen[i][j+1]==0){
                            Vektor v1f=new Vektor(i*256,256,j*256+256);
                            Vektor v2f=new Vektor(i*256+256,256,j*256+256);
                            Vektor v3f=new Vektor(i*256+256,0,j*256+256);
                            Vektor v4f=new Vektor(i*256,0,j*256+256);
                            Polygon polf=new Polygon(v1f,v2f,v3f,v4f,wand);
                            gr.add(polf);
                            add(polf);

                            Vektor v1f2=new Vektor(i*256,256,j*256+256);
                            Vektor v2f2=new Vektor(i*256+256,256,j*256+256);
                            Vektor v3f2=new Vektor(i*256+256,0,j*256+256);
                            Vektor v4f2=new Vektor(i*256,0,j*256+256);
                            Polygon polf2=new Polygon(v1f2,v2f2,v3f2,v4f2,wand);
                            gr2.add(polf2);
                        }
                    }
                }
            }
            m.eng.add(gr);
            m.eng2.add(gr2);
            g=new Group();
            g3=new Group();
            Vektor v1p=new Vektor(-32,-16,-16);
            Vektor v2p=new Vektor(-32,16,-16);
            Vektor v3p=new Vektor(-32,16,16);
            Vektor v4p=new Vektor(-32,-16,16);
            Polygon backpol=new Polygon(v1p,v2p,v3p,v4p,p1back);

            Vektor v1p2=new Vektor(-32,-16,-16);
            Vektor v2p2=new Vektor(-32,16,-16);
            Vektor v3p2=new Vektor(-32,16,16);
            Vektor v4p2=new Vektor(-32,-16,16);
            Polygon backpol2=new Polygon(v1p2,v2p2,v3p2,v4p2,p1back);

            Vektor v5=new Vektor(32,-16,-16);
            Vektor v6=new Vektor(-32,-16,-16);
            Vektor v7=new Vektor(-32,16,-16);
            Vektor v8=new Vektor(32,16,-16);
            Polygon s1=new Polygon(v5,v6,v7,v8,p1side);

            Vektor v52=new Vektor(32,-16,-16);
            Vektor v62=new Vektor(-32,-16,-16);
            Vektor v72=new Vektor(-32,16,-16);
            Vektor v82=new Vektor(32,16,-16);
            Polygon s12=new Polygon(v52,v62,v72,v82,p1side);

            Vektor v9=new Vektor(32,-16,16);
            Vektor v10=new Vektor(-32,-16,16);
            Vektor v11=new Vektor(-32,16,16);
            Vektor v12=new Vektor(32,16,16);
            Polygon s2=new Polygon(v9,v10,v11,v12,p1side);

            Vektor v92=new Vektor(32,-16,16);
            Vektor v102=new Vektor(-32,-16,16);
            Vektor v112=new Vektor(-32,16,16);
            Vektor v122=new Vektor(32,16,16);
            Polygon s22=new Polygon(v92,v102,v112,v122,p1side);

            Vektor v13=new Vektor(32,-16,-16);
            Vektor v14=new Vektor(-32,-16,-16);
            Vektor v15=new Vektor(-32,-16,16);
            Vektor v16=new Vektor(32,-16,16);
            Polygon s3=new Polygon(v13,v14,v15,v16,p1side);

            Vektor v132=new Vektor(32,-16,-16);
            Vektor v142=new Vektor(-32,-16,-16);
            Vektor v152=new Vektor(-32,-16,16);
            Vektor v162=new Vektor(32,-16,16);
            Polygon s32=new Polygon(v132,v142,v152,v162,p1side);

            Vektor v17=new Vektor(32,16,-16);
            Vektor v18=new Vektor(-32,16,-16);
            Vektor v19=new Vektor(-32,16,16);
            Vektor v20=new Vektor(32,16,16);
            Polygon s4=new Polygon(v17,v18,v19,v20,p1side);

            Vektor v172=new Vektor(32,16,-16);
            Vektor v182=new Vektor(-32,16,-16);
            Vektor v192=new Vektor(-32,16,16);
            Vektor v202=new Vektor(32,16,16);
            Polygon s42=new Polygon(v172,v182,v192,v202,p1side);

            Vektor vb1=new Vektor(32,16,16);
            Vektor vc1=new Vektor(32,-16,16);
            Vektor vd1=new Vektor(48,0,0);
            Polygon h1=new Polygon(vb1,vc1,vd1,p1front);

            Vektor vb12=new Vektor(32,16,16);
            Vektor vc12=new Vektor(32,-16,16);
            Vektor vd12=new Vektor(48,0,0);
            Polygon h12=new Polygon(vb12,vc12,vd12,p1front);

            Vektor vb2=new Vektor(32,16,-16);
            Vektor vc2=new Vektor(32,-16,-16);
            Vektor vd2=new Vektor(48,0,0);
            Polygon h2=new Polygon(vb2,vc2,vd2,p1front);

            Vektor vb22=new Vektor(32,16,-16);
            Vektor vc22=new Vektor(32,-16,-16);
            Vektor vd22=new Vektor(48,0,0);
            Polygon h22=new Polygon(vb22,vc22,vd22,p1front);

            Vektor vb3=new Vektor(32,16,16);
            Vektor vc3=new Vektor(32,16,-16);
            Vektor vd3=new Vektor(48,0,0);
            Polygon h3=new Polygon(vb3,vc3,vd3,p1front);

            Vektor vb32=new Vektor(32,16,16);
            Vektor vc32=new Vektor(32,16,-16);
            Vektor vd32=new Vektor(48,0,0);
            Polygon h32=new Polygon(vb32,vc32,vd32,p1front);

            Vektor vb4=new Vektor(32,-16,16);
            Vektor vc4=new Vektor(32,-16,-16);
            Vektor vd4=new Vektor(48,0,0);
            Polygon h4=new Polygon(vb4,vc4,vd4,p1front);

            Vektor vb42=new Vektor(32,-16,16);
            Vektor vc42=new Vektor(32,-16,-16);
            Vektor vd42=new Vektor(48,0,0);
            Polygon h42=new Polygon(vb42,vc42,vd42,p1front);

            g.add(backpol);
            g.add(s1);
            g.add(s2);
            g.add(s3);
            g.add(s4);
            g.add(h1);
            g.add(h2);
            g.add(h3);
            g.add(h4);
            g.transform((short)xpos,(short)ypos,(short)zpos);
            m.eng.add(g);

            g3.add(backpol2);
            g3.add(s12);
            g3.add(s22);
            g3.add(s32);
            g3.add(s42);
            g3.add(h12);
            g3.add(h22);
            g3.add(h32);
            g3.add(h42);
            g3.transform((short)xpos,(short)ypos,(short)zpos);
            m.eng2.add(g3);

            if(true){
                g2=new Group();
                g4=new Group();
                Vektor v12b=new Vektor(-32,-16,-16);
                Vektor v22=new Vektor(-32,16,-16);
                Vektor v32=new Vektor(-32,16,16);
                Vektor v42=new Vektor(-32,-16,16);
                Polygon back2=new Polygon(v12b,v22,v32,v42,p2back);
                g2.add(back2);

                Vektor v12b2=new Vektor(-32,-16,-16);
                Vektor v222=new Vektor(-32,16,-16);
                Vektor v322=new Vektor(-32,16,16);
                Vektor v422=new Vektor(-32,-16,16);
                Polygon back22=new Polygon(v12b2,v222,v322,v422,p2back);
                g4.add(back22);

                Vektor v52x=new Vektor(32,-16,-16);
                Vektor v62x=new Vektor(-32,-16,-16);
                Vektor v72x=new Vektor(-32,16,-16);
                Vektor v82x=new Vektor(32,16,-16);
                Polygon s12x=new Polygon(v52x,v62x,v72x,v82x,p2side);
                g2.add(s12x);

                Vektor v522=new Vektor(32,-16,-16);
                Vektor v622=new Vektor(-32,-16,-16);
                Vektor v722=new Vektor(-32,16,-16);
                Vektor v822=new Vektor(32,16,-16);
                Polygon s122=new Polygon(v522,v622,v722,v822,p2side);
                g4.add(s122);

                Vektor v92x=new Vektor(32,-16,16);
                Vektor v102x=new Vektor(-32,-16,16);
                Vektor v112x=new Vektor(-32,16,16);
                Vektor v122x=new Vektor(32,16,16);
                Polygon s22x=new Polygon(v92x,v102x,v112x,v122x,p2side);
                g2.add(s22x);

                Vektor v922=new Vektor(32,-16,16);
                Vektor v1022=new Vektor(-32,-16,16);
                Vektor v1122=new Vektor(-32,16,16);
                Vektor v1222=new Vektor(32,16,16);
                Polygon s222=new Polygon(v922,v1022,v1122,v1222,p2side);
                g4.add(s222);

                Vektor v132x=new Vektor(32,-16,-16);
                Vektor v142x=new Vektor(-32,-16,-16);
                Vektor v152x=new Vektor(-32,-16,16);
                Vektor v162x=new Vektor(32,-16,16);
                Polygon s32x=new Polygon(v132x,v142x,v152x,v162x,p2side);
                g2.add(s32x);

                Vektor v1322=new Vektor(32,-16,-16);
                Vektor v1422=new Vektor(-32,-16,-16);
                Vektor v1522=new Vektor(-32,-16,16);
                Vektor v1622=new Vektor(32,-16,16);
                Polygon s322=new Polygon(v1322,v1422,v1522,v1622,p2side);
                g4.add(s322);

                Vektor v172x=new Vektor(32,16,-16);
                Vektor v182x=new Vektor(-32,16,-16);
                Vektor v192x=new Vektor(-32,16,16);
                Vektor v202x=new Vektor(32,16,16);
                Polygon s42x=new Polygon(v172x,v182x,v192x,v202x,p2side);
                g2.add(s42x);

                Vektor v1722=new Vektor(32,16,-16);
                Vektor v1822=new Vektor(-32,16,-16);
                Vektor v1922=new Vektor(-32,16,16);
                Vektor v2022=new Vektor(32,16,16);
                Polygon s422=new Polygon(v1722,v1822,v1922,v2022,p2side);
                g4.add(s422);

                Vektor vb12x=new Vektor(32,16,16);
                Vektor vc12x=new Vektor(32,-16,16);
                Vektor vd12x=new Vektor(48,0,0);
                Polygon h12x=new Polygon(vb12x,vc12x,vd12x,p2front);
                g2.add(h12x);

                Vektor vb122=new Vektor(32,16,16);
                Vektor vc122=new Vektor(32,-16,16);
                Vektor vd122=new Vektor(48,0,0);
                Polygon h122=new Polygon(vb122,vc122,vd122,p2front);
                g4.add(h122);

                Vektor vb22x=new Vektor(32,16,-16);
                Vektor vc22x=new Vektor(32,-16,-16);
                Vektor vd22x=new Vektor(48,0,0);
                Polygon h22x=new Polygon(vb22x,vc22x,vd22x,p2front);
                g2.add(h22x);

                Vektor vb222=new Vektor(32,16,-16);
                Vektor vc222=new Vektor(32,-16,-16);
                Vektor vd222=new Vektor(48,0,0);
                Polygon h222=new Polygon(vb222,vc222,vd222,p2front);
                g4.add(h222);

                Vektor vb32x=new Vektor(32,16,16);
                Vektor vc32x=new Vektor(32,16,-16);
                Vektor vd32x=new Vektor(48,0,0);
                Polygon h32x=new Polygon(vb32x,vc32x,vd32x,p2front);
                g2.add(h32x);

                Vektor vb322=new Vektor(32,16,16);
                Vektor vc322=new Vektor(32,16,-16);
                Vektor vd322=new Vektor(48,0,0);
                Polygon h322=new Polygon(vb322,vc322,vd322,p2front);
                g4.add(h322);

                Vektor vb42x=new Vektor(32,-16,16);
                Vektor vc42x=new Vektor(32,-16,-16);
                Vektor vd42x=new Vektor(48,0,0);
                Polygon h42x=new Polygon(vb42x,vc42x,vd42x,p2front);
                g2.add(h42x);
                m.eng.add(g2);
                g2.transform((short)xpos2,(short)ypos2,(short)zpos2);

                Vektor vb422=new Vektor(32,-16,16);
                Vektor vc422=new Vektor(32,-16,-16);
                Vektor vd422=new Vektor(48,0,0);
                Polygon h422=new Polygon(vb422,vc422,vd422,p2front);
                g4.add(h422);
                m.eng2.add(g4);
                g4.transform((short)xpos2,(short)ypos2,(short)zpos2);
            }
        }
        catch(Exception e){
        }
        int rcount=0;
        int rcount2=0;
        m.l1.setText("XRace3DForTwoTex");
    int winW=400;
    int winH=400;
    Screen3D sc=m.eng.getScreen3D();
    sc.setSize(winW,winH);
    sc.setPhysicalScreenWidth(0.8);
    sc.setPhysicalScreenHeight(0.6);
    Screen3D scz=m.eng2.getScreen3D();
    scz.setSize(winW,winH);
    scz.setPhysicalScreenWidth(0.8);
    scz.setPhysicalScreenHeight(0.6);
        while(running){
            try{
                double alphab=alpha;
                double betab=beta;
                if(power==0){
                    power=1.1;
                }
                double zw=-Math.sin(Math.PI/2-palpha)*power;
                double zd=-Math.cos(Math.PI/2-palpha)*power;
                double xd=-Math.cos(-pbeta)*zw;
                double yd=Math.sin(-pbeta)*zw;
                axpos=xpos;
                aypos=ypos;
                azpos=zpos;
                if(power!=1.1){
                    xpos=xpos+xd;
                    ypos=ypos+yd;
                    zpos=zpos+zd;
                }
                double xv=xpos;
                double yv=ypos;
                double zv=zpos;
                if(power!=0){
                    xv=xpos+xd/power*48;
                    yv=ypos+yd/power*48;
                    zv=zpos+zd/power*48;
                }
                if(power==1.1){
                    power=0;
                }
                int xi=(int)xv/256;
                int yi=(int)zv/256;
                boolean track=false;
                if(xi>=0&&yi>=0&&xi<30&&yi<18){
                    if(screen[xi][yi]>=1&&screen[xi][yi]<=5&&screen[xi][yi]!=2){
                        track=true;
                    }
                    if(screen[xi][yi]==5){
                        half=true;
                    }
                    if(screen[xi][yi]==3||screen[xi][yi]==4){
                        if(half){
                            laps++;
                            half=false;
                        }
                    }
                    if(yv<0||yv>=256){
                        track=false;
                    }
                }
                short diffx=(short)((short)xpos-(short)axpos);
                short diffy=(short)((short)ypos-(short)aypos);
                short diffz=(short)((short)zpos-(short)azpos);
                if(track){
                    g.transform(diffx,diffy,diffz);
                    g3.transform(diffx,diffy,diffz);
                }
                else{
                    xpos=axpos;
                    ypos=aypos;
                    zpos=azpos;
                    power=0;
                }
                if(laps==1){
                    m.l2.setText("lap 1 completed!");
                }
                if(laps==2){
                    m.l2.setText("You have won!");
                    laps2=0;
                }
                if(laps2==2){
                    m.l2.setText("You have lost!");
                    laps=0;
                }



                if(true){
                    if(power2==0){
                        power2=1.1;
                    }
                    double zw2=-Math.sin(Math.PI/2-palpha2)*power2;
                    double zd2=-Math.cos(Math.PI/2-palpha2)*power2;
                    double xd2=-Math.cos(-pbeta2)*zw2;
                    double yd2=Math.sin(-pbeta2)*zw2;
                    axpos2=xpos2;
                    aypos2=ypos2;
                    azpos2=zpos2;
                    if(power2!=1.1){
                        xpos2=xpos2+xd2;
                        ypos2=ypos2+yd2;
                        zpos2=zpos2+zd2;
                    }
                    double xv2=xpos2;
                    double yv2=ypos2;
                    double zv2=zpos2;
                    if(power2!=0){
                        xv2=xpos2+xd2/power2*48;
                        yv2=ypos2+yd2/power2*48;
                        zv2=zpos2+zd2/power2*48;
                    }
                    if(power2==1.1){
                        power2=0;
                    }
                    int xi2=(int)xv2/256;
                    int yi2=(int)zv2/256;
                    boolean track2=false;
                    if(xi2>=0&&yi2>=0&&xi2<30&&yi2<18){
                        if(screen[xi2][yi2]>=1&&screen[xi2][yi2]<=5&&screen[xi2][yi2]!=2){
                            track2=true;
                        }
                        if(screen[xi2][yi2]==5){
                            half2=true;
                        }
                        if(screen[xi2][yi2]==3||screen[xi2][yi2]==4){
                            if(half2){
                                laps2++;
                                half2=false;
                            }
                        }
                        if(yv2<0||yv2>=256){
                            track2=false;
                        }
                    }
                    short diffx2=(short)((short)xpos2-(short)axpos2);
                    short diffy2=(short)((short)ypos2-(short)aypos2);
                    short diffz2=(short)((short)zpos2-(short)azpos2);
                    if(track2){
                         g2.transform(diffx2,diffy2,diffz2);
                         g4.transform(diffx2,diffy2,diffz2);
                    }
                    else{
                        xpos2=axpos2;
                        ypos2=aypos2;
                        zpos2=azpos2;
                        power2=0;
                    }
                }
//System.out.println("xtrans: "+xtrans+" xpos: "+xpos);

                Vektor camerapos=new Vektor(0,0,(short)zpos);
                Vektor cameraposplus=new Vektor(0,0,0);
                camerapos.x=(short)xpos;
                camerapos.y=(short)ypos;
                double w=Math.sin(beta)*dist;
                cameraposplus.x=(short)(Math.cos(alpha)*w);
                cameraposplus.y=(short)(Math.cos(beta)*dist);
                cameraposplus.z=(short)(Math.sin(alpha)*w);
                double xtrans=camerapos.x-cameraposplus.x;
                double ytrans=camerapos.y-cameraposplus.y;
                double ztrans=camerapos.z-cameraposplus.z;

                double bd=Math.PI/4;
                double ad=Math.PI/4;
	        float yf=(float)Math.cos(-(float)bd);
             	float wf=(float)Math.sin(-(float)bd);
	        float zf=(float)(Math.sin((float)(ad+Math.PI))*wf);
	        float xf=(float)(Math.cos((float)(ad+Math.PI))*wf);


                Vektor vt=new Vektor((int)(xtrans),(int)(ytrans),(int)(ztrans));
                m.eng.setCam(vt,(float)(alphab+Math.PI),(float)(-betab));
                if(adist>0){
                    adist=adist-128;
                    vt=new Vektor((int)(xtrans-adist*xf),(int)(ytrans-adist*yf),(int)(ztrans-adist*zf));
                    m.eng.setCam(vt,(float)(Math.PI+ad),(float)(-bd));
                }


                double alphab2=alpha2;
                double betab2=beta2;

                Vektor camerapos2=new Vektor(0,0,(short)zpos2);
                Vektor cameraposplus2=new Vektor(0,0,0);
                camerapos2.x=(short)xpos2;
                camerapos2.y=(short)ypos2;
                double w2=Math.sin(beta2)*dist2;
                cameraposplus2.x=(short)(Math.cos(alpha2)*w2);
                cameraposplus2.y=(short)(Math.cos(beta2)*dist2);
                cameraposplus2.z=(short)(Math.sin(alpha2)*w2);
                double xtrans2=camerapos2.x-cameraposplus2.x;
                double ytrans2=camerapos2.y-cameraposplus2.y;
                double ztrans2=camerapos2.z-cameraposplus2.z;

                double bd2=Math.PI/4;
                double ad2=Math.PI/4;
	        float yf2=(float)Math.cos(-(float)bd2);
             	float wf2=(float)Math.sin(-(float)bd2);
	        float zf2=(float)(Math.sin((float)(ad2+Math.PI))*wf2);
	        float xf2=(float)(Math.cos((float)(ad2+Math.PI))*wf2);


                Vektor vt2=new Vektor((int)(xtrans2),(int)(ytrans2),(int)(ztrans2));
                m.eng2.setCam(vt2,(float)(alphab2+Math.PI),(float)(-betab2));
                if(adist2>0){
                    adist2=adist2-128;
                    vt2=new Vektor((int)(xtrans2-adist2*xf2),(int)(ytrans2-adist2*yf2),(int)(ztrans2-adist2*zf2));
                    m.eng2.setCam(vt2,(float)(Math.PI+ad2),(float)(-bd2));
                }


//                eng.repaint();
            ImageComponent2D buff=new ImageComponent2D(ImageComponent2D.FORMAT_RGBA,new BufferedImage(winW,winH,BufferedImage.TYPE_INT_ARGB));
            m.eng.setOffScreenBuffer(buff);
            m.eng.renderOffScreenBuffer();
            m.eng.waitForOffScreenRendering();
            canvas.img=m.eng.getOffScreenBuffer().getImage();
            canvas.repaint();
            ImageComponent2D buff2=new ImageComponent2D(ImageComponent2D.FORMAT_RGBA,new BufferedImage(winW,winH,BufferedImage.TYPE_INT_ARGB));
            m.eng2.setOffScreenBuffer(buff2);
            m.eng2.renderOffScreenBuffer();
            m.eng2.waitForOffScreenRendering();
            canvas2.img=m.eng2.getOffScreenBuffer().getImage();
            canvas2.repaint();
                Thread.sleep(100);

                int key=m.eng.getKeyCode();
                int key2=m.eng2.getKeyCode();
                if(key==0&&key2!=0){
                    key=key2;
                }
                if(key==0){
                    rcount++;
                }
                if(key!=0){
//System.out.println("key: "+key);
                    if(key==27){
//                        loadb=true;
//                        running=false;
                    }
                    if(race){
                        if(key==37){
                            g.transform((short)(-xpos),(short)(-ypos),(short)(-zpos));
                            g.rotUp((float)(-(pbeta-0)));
                            palpha=palpha-Math.PI/15;
                            g.rotLeft(-(float)(Math.PI/15));
                            g.rotUp((float)(pbeta-0));
                            g.transform((short)(xpos),(short)(ypos),(short)(zpos));

                            g3.transform((short)(-xpos),(short)(-ypos),(short)(-zpos));
                            g3.rotUp((float)(-(pbeta-0)));
//                            palpha=palpha-Math.PI/15;
                            g3.rotLeft(-(float)(Math.PI/15));
                            g3.rotUp((float)(pbeta-0));
                            g3.transform((short)(xpos),(short)(ypos),(short)(zpos));
                        }
                        else if(key==39){
                            g.transform((short)(-xpos),(short)(-ypos),(short)(-zpos));
                            g.rotUp((float)(-(pbeta-0)));
                            palpha=palpha+Math.PI/15;
                            g.rotLeft((float)(Math.PI/15));
                            g.rotUp((float)(pbeta-0));
                            g.transform((short)(xpos),(short)(ypos),(short)(zpos));

                            g3.transform((short)(-xpos),(short)(-ypos),(short)(-zpos));
                            g3.rotUp((float)(-(pbeta-0)));
//                            palpha=palpha+Math.PI/15;
                            g3.rotLeft((float)(Math.PI/15));
                            g3.rotUp((float)(pbeta-0));
                            g3.transform((short)(xpos),(short)(ypos),(short)(zpos));
                        }
                        else if(key==40&&false){
                            g.transform((short)(-xpos),(short)(-ypos),(short)(-zpos));
                            g.rotLeft((float)(-palpha));
                            pbeta=pbeta-Math.PI/15;
                            g.rotUp((float)(-Math.PI/15));
                            g.rotLeft((float)palpha);
                            g.transform((short)(xpos),(short)(ypos),(short)(zpos));
                        }
                        else if(key==38&&false){
                            g.transform((short)(-xpos),(short)(-ypos),(short)(-zpos));
                            g.rotLeft((float)(-palpha));
                            pbeta=pbeta+Math.PI/15;
                            g.rotUp((float)(Math.PI/15));
                            g.rotLeft((float)palpha);
                            g.transform((short)xpos,(short)ypos,(short)(zpos));
                        }
                        else if(key==10){
                            power=power+1;
                        }
                        else if(key==127){
                            power=power-1;
                        }
                        else if(key==32){
                            race=false;
                        }
                    }
                    else{
                        if(key==37){
                            alpha=alpha-Math.PI/15;
                        }
                        else if(key==39){
                            alpha=alpha+Math.PI/15;
                        }
                        else if(key==40){
                            beta=beta-Math.PI/15;
                        }
                        else if(key==38){
                            beta=beta+Math.PI/15;
                        }
                        else if(key==10){
                            dist=dist+10;
                        }
                        else if(key==127){
                            dist=dist-10;
                        }
                        else if(key==32){
                            race=true;
                        }
                    }
                }


                if(racen){
                    if(key!=0){
                        if(race2){
                            if(key==89){
                                g2.transform((short)(-xpos2),(short)(-ypos2),(short)(-zpos2));
                                g2.rotUp((float)(-(pbeta2-0)));
                                palpha2=palpha2-Math.PI/15;
                                g2.rotLeft(-(float)(Math.PI/15));
                                g2.rotUp((float)(pbeta2-0));
                                g2.transform((short)(xpos2),(short)(ypos2),(short)(zpos2));

                                g4.transform((short)(-xpos2),(short)(-ypos2),(short)(-zpos2));
                                g4.rotUp((float)(-(pbeta2-0)));
//                                palpha2=palpha2-Math.PI/15;
                                g4.rotLeft(-(float)(Math.PI/15));
                                g4.rotUp((float)(pbeta2-0));
                                g4.transform((short)(xpos2),(short)(ypos2),(short)(zpos2));
                            }
                            else if(key==67){
                                g2.transform((short)(-xpos2),(short)(-ypos2),(short)(-zpos2));
                                g2.rotUp((float)(-(pbeta2-0)));
                                palpha2=palpha2+Math.PI/15;
                                g2.rotLeft((float)(Math.PI/15));
                                g2.rotUp((float)(pbeta2-0));
                                g2.transform((short)(xpos2),(short)(ypos2),(short)(zpos2));

                                g4.transform((short)(-xpos2),(short)(-ypos2),(short)(-zpos2));
                                g4.rotUp((float)(-(pbeta2-0)));
//                                palpha2=palpha2+Math.PI/15;
                                g4.rotLeft((float)(Math.PI/15));
                                g4.rotUp((float)(pbeta2-0));
                                g4.transform((short)(xpos2),(short)(ypos2),(short)(zpos2));
                            }
                            else if(key==81){
                                power2=power2+1;
                            }
                            else if(key==87){
                                power2=power2-1;
                            }
                            else if(key==68){
                                race2=false;
                            }
                    }
                    else{
                        if(key==89){
                            alpha2=alpha2-Math.PI/15;
                        }
                        else if(key==67){
                            alpha2=alpha2+Math.PI/15;
                        }
                        else if(key==88){
                            beta2=beta2-Math.PI/15;
                        }
                        else if(key==83){
                            beta2=beta2+Math.PI/15;
                        }
                        else if(key==81){
                            dist2=dist2+10;
                        }
                        else if(key==87){
                            dist2=dist2-10;
                        }
                        else if(key==68){
                            race2=true;
                        }
                    }
                    }
                }
            }
            catch(Exception e){
                e.printStackTrace();
            }
        }
        if(loadb){
            m.clearb=true;
        }
    }
    public void add(Polygon pol){
        int n=polygon.length;
        Polygon[]polygon2=new Polygon[n+1];
        for(int i=0;i<n;i++){
            polygon2[i]=polygon[i];
        }
        polygon2[n]=pol;
        polygon=polygon2;
    }
}
class EngineXRace3DForTwoTex extends Canvas3D{
    Group start;
    Group end;
    int w;
    int h;
    boolean keypressed=false;
    int keycode=0;
    Group direct;
    String status="";
    TransformGroup world2;
    BranchGroup world;
    BranchGroup temp;
//    AWTBehavior behavior;
    AmbientLight ambientlight;
    SimpleUniverse simplu;
    Node disp;
    View view;
    Transform3D trans;
    ViewPlatform vp;
//    ViewPlatformBehavior vpb;
    TransformGroup vpcontainer;
    private static final long serialVersionUID = 4640490087660365062L;
    public void remo(){
        Group cur=start;
        while(cur!=null){
            remove(cur);
//System.out.println(cur);
            cur=cur.next;
        }
//        direct.delete();
        start=null;
        end=null;
        direct=null;
        world2=null;
        world=null;
        temp=null;
//        behavior=null;
    }
    public EngineXRace3DForTwoTex(){
        super(SimpleUniverse.getPreferredConfiguration(),true);
        direct=new Group();
        world2=new TransformGroup();
        ambientlight=new AmbientLight();
        world=new BranchGroup();
        world.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
        world.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
        world.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
        world.setCapability(BranchGroup.ALLOW_DETACH);
        world.addChild(world2);
        world.addChild(ambientlight);
//        behavior=new AWTBehavior(this);
        disp=world.cloneTree();
        temp=new BranchGroup();
        temp.addChild(disp);
        simplu=new SimpleUniverse(this);
        view=getView();
        view.setBackClipDistance(33000.0f);
        view.setFieldOfView(50.0f/180.0f*Math.PI);
        vp=new ViewPlatform();
        view.attachViewPlatform(vp);
        vpcontainer=new TransformGroup();
        vpcontainer.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        vpcontainer.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        vpcontainer.addChild(vp);
        BranchGroup bg=new BranchGroup();
        bg.addChild(vpcontainer);
//        bg.addChild(behavior);
        simplu.addBranchGraph(bg);
        simplu.addBranchGraph(world);
    }
    public void repaint2(){
        simplu=new SimpleUniverse(this);
        disp=world.cloneTree();
        temp=new BranchGroup();
        temp.addChild(disp);
        view=getView();
        view.setBackClipDistance(33000.0f);
        view.setFieldOfView(50.0f/180.0f*Math.PI);
        simplu.addBranchGraph(temp);
    }
    public void setCam(Vektor campos,float wx,float wy){
	float y=(float)Math.cos(wy);
	float w=(float)Math.sin(wy);
	float z=(float)Math.sin(wx)*w;
	float x=(float)Math.cos(wx)*w;
        double wy2=wy+Math.PI/2;
        double wx2=wx;
	float y2=(float)Math.cos(wy2);
	float w2=(float)Math.sin(wy2);
	float z2=(float)Math.sin(wx2)*w2;
	float x2=(float)Math.cos(wx2)*w2;
        trans=new Transform3D();
        trans.lookAt(new Point3d(campos.x,campos.y,campos.z),new Point3d(campos.x+x,campos.y+y,campos.z+z),new Vector3d(x2,y2,z2));
        trans.invert();
        vpcontainer.setTransform(trans);
    }
    public void paintb(Graphics g){
        if(world==null){
            return;
        }
        if(!"".equals(status)){
            g.setColor(Color.black);
            g.fillRect(0,0,w,15);
            g.setColor(Color.white);
            g.drawLine(0,15,w,15);
            g.drawString(status,10,0);
        }
    }
    public void setStatus(String status){
        this.status=status;
    }
    public int getKeyCode(){
        int key=keycode;
        keycode=0;
        return key;
    }
    public void add(Polygon pol){
        if(pol.mesh!=null){
            world.addChild(pol.bg);
            direct.add(pol);
        }
    }
    public void add(Kugel kugel){
        if(kugel.mesh!=null){
            world.addChild(kugel.bg);
            direct.add(kugel);
        }
    }
    public void remove(Polygon pol){
        direct.remove(pol);
        if(pol.mesh!=null){
            world.removeChild(pol.bg);
//            pol.bg.removeChild(pol.mesh);
        }
    }
    public void remove(Kugel kugel){
        direct.remove(kugel);
        if(kugel.mesh!=null){
            world.removeChild(kugel.bg);
//            kugel.bg.removeChild(kugel.mesh);
        }
    }
    public void add(Group g){
        if(start==null){
            start=g;
            end=g;
        }
        else{
            end.next=g;
            end=end.next;
        }
        Polygon cur=g.start;
        while(cur!=null){
            if(cur.mesh!=null){
                world.addChild(cur.bg);
            }
            cur=cur.next;
        }
        Kugel curb=g.startb;
        while(curb!=null){
            if(curb.mesh!=null){
                world.addChild(curb.bg);
            }
            curb=curb.next;
        }
    }
    public void remove(Group g){
        Group cur=start;
        Group fore=null;
        while(cur!=null){
            boolean b=true;
            if(cur==g){
                if(fore==null){
                    if(end==start){
                        end=null;
                        start=null;
                    }
                    else{
                        start=start.next;
                    }
                }
                else{
                    fore.next=cur.next;
                    b=false;
                }
            }
            if(b){
                fore=cur;
                cur=cur.next;
            }
            else{
                cur=cur.next;
            }
        }
        Polygon curb=g.start;
        while(curb!=null){
            if(curb.mesh!=null){
//                curb.bg.removeChild(curb.mesh);
                world.removeChild(curb.bg);
            }
            curb=curb.next;
        }
        Kugel curb2=g.startb;
        while(curb2!=null){
            if(curb2.mesh!=null){
//                curb2.bg.removeChild(curb2.mesh);
                world.removeChild(curb2.bg);
            }
            curb2=curb2.next;
        }
    }
    public void transform(float x,float y,float z){
        Group cur=start;
        while(cur!=null){
            cur.transform(x,y,z);
            cur=cur.next;
        }
        direct.transform(x,y,z);
    }
    public void rotLeft(float w){
        Group cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
        direct.rotLeft(w);
    }
    public void rotUp(float w){
        Group cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
        direct.rotUp(w);
    }
}
class Group{
    Polygon start;
    Polygon end;
    Kugel startb;
    Kugel endb;
    Group next;
    public Group(){
    }
    public void add(Polygon pol){
        if(start==null){
            start=pol;
            end=pol;
        }
        else{
            end.next=pol;
            end=end.next;
        }
    }
    public void remove(Polygon pol){
        Polygon cur=start;
        Polygon fore=null;
        while(cur!=null){
            boolean b=true;
            if(cur==pol){
                if(fore==null){
                    if(end==start){
                        end=null;
                        start=null;
                    }
                    else{
                        start=start.next;
                    }
                }
                else{
                    fore.next=cur.next;
                    b=false;
                }
            }
            if(b){
                fore=cur;
                cur=cur.next;
            }
            else{
                cur=cur.next;
            }
        }
    }
    public void add(Kugel kugel){
        if(startb==null){
            startb=kugel;
            endb=kugel;
        }
        else{
            endb.next=kugel;
            endb=endb.next;
        }
    }
    public void remove(Kugel kugel){
        Kugel curb=startb;
        Kugel fore=null;
        while(curb!=null){
            boolean b=true;
            if(curb==kugel){
                if(fore==null){
                    if(endb==startb){
                        endb=null;
                        startb=null;
                    }
                    else{
                        startb=startb.next;
                    }
                }
                else{
                    fore.next=curb.next;
                    b=false;
                }
            }
            if(b){
                fore=curb;
                curb=curb.next;
            }
            else{
                curb=curb.next;
            }
        }
    }
    public void delete(){
        Polygon cur=start;
        while(cur!=null){
            cur.delete();
            cur=cur.next;
        }
        Kugel curb=startb;
        while(curb!=null){
            curb.delete();
            curb=curb.next;
        }
    }
    public void transform(float x,float y,float z){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(x,y,z);
            cur=cur.next;
        }
        Kugel curb=startb;
        while(curb!=null){
            curb.transform(x,y,z);
            curb=curb.next;
        }
    }
    public void rotLeft(float w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
        Kugel curb=startb;
        while(curb!=null){
            curb.rotLeft(w);
            curb=curb.next;
        }
    }
    public void rotUp(float w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
        Kugel curb=startb;
        while(curb!=null){
            curb.rotUp(w);
            curb=curb.next;
        }
    }
}
class Polygon{
    Polygon next;
    Vektor v1;
    Vektor v2;
    Vektor v3;
    Vektor v4;
    TransformGroup mesh;
    BufferedImage img;
    Transform3D transform;
    TriangleArray meshb;
    Shape3D meshc;
    boolean triangle=false;
    float[]pos;
    float[]texval;
    Texture2D tex;
    BranchGroup bg;
    Frame f;
    public Polygon(Vektor v1,Vektor v2,Vektor v3,Vektor v4,Image img){
        this.v1=v1;
        this.v2=v2;
        this.v3=v3;
        this.v4=v4;
        f=new Frame();
        int w=img.getWidth(f);
        int h=img.getHeight(f);
        while(w==-1||h==-1){
            try{
                w=img.getWidth(f);
                h=img.getHeight(f);
                Thread.yield();
            }
            catch(Exception e){
            }
        }
        TextureLoader tl=new TextureLoader(img,f);
        int bw=1;
        while(bw<w){
            bw=bw*2;
        }
        int bh=1;
        while(bh<h){
            bh=bh*2;
        }
        ImageComponent2D image = tl.getScaledImage(bw,bh);
        tex=new Texture2D();
        int form=tex.getFormat();
        int base=tex.getMipMapMode();
        tex = new Texture2D(base,form,bw,bh);
        tex.setImage(0,image);
        buildq();
    }
    public Polygon(Vektor v1,Vektor v2,Vektor v3,Image img){
        triangle=true;
        this.v1=v1;
        this.v2=v2;
        this.v3=v3;
        f=new Frame();
        int w=img.getWidth(f);
        int h=img.getHeight(f);
        while(w==-1||h==-1){
            try{
                w=img.getWidth(f);
                h=img.getHeight(f);
                Thread.yield();
            }
            catch(Exception e){
            }
        }
        TextureLoader tl=new TextureLoader(img,f);
        int bw=1;
        while(bw<w){
            bw=bw*2;
        }
        int bh=1;
        while(bh<h){
            bh=bh*2;
        }
        ImageComponent2D image = tl.getScaledImage(bw,bh);
        tex=new Texture2D();
        int form=tex.getFormat();
        int base=tex.getMipMapMode();
        tex = new Texture2D(base,form,bw,bh);
        tex.setImage(0,image);
        buildt();
    }
    public void delete(){
        tex=null;
        bg.removeChild(mesh);
        mesh=null;
        bg=null;
    }
    public void buildt(){
        try{
            pos=new float[9];
            pos[0]=v1.x;
            pos[1]=v1.y;
            pos[2]=v1.z;
            pos[3]=v2.x;
            pos[4]=v2.y;
            pos[5]=v2.z;
            pos[6]=v3.x;
            pos[7]=v3.y;
            pos[8]=v3.z;
            texval=new float[6];
            texval[0]=0.0f;
            texval[1]=0.0f;
            texval[2]=1.0f;
            texval[3]=0.0f;
            texval[4]=0.0f;
            texval[5]=1.0f;
            meshb=new TriangleArray(3,GeometryArray.COORDINATES|GeometryArray.TEXTURE_COORDINATE_2);
            meshb.setCoordinates(0,pos,0,3);
            meshb.setTextureCoordinates(0,0,texval,0,3);
            meshc=new Shape3D(meshb);
            Appearance app=new Appearance();
            PolygonAttributes pa=new PolygonAttributes();
            pa.setCullFace(PolygonAttributes.CULL_NONE);
            app.setPolygonAttributes(pa);
            mesh=new TransformGroup();
            mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
            mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
            app.setTexture(tex);
            meshc.setAppearance(app);
            mesh.addChild(meshc);
            transform=new Transform3D();
            mesh.setTransform(transform);
            bg=new BranchGroup();
            bg.setCapability(BranchGroup.ALLOW_DETACH);
            bg.addChild(mesh);
        }
        catch(Exception e){
        }
    }
    public void buildq(){
        try{
            pos=new float[18];
            pos[0]=v1.x;
            pos[1]=v1.y;
            pos[2]=v1.z;
            pos[3]=v2.x;
            pos[4]=v2.y;
            pos[5]=v2.z;
            pos[6]=v4.x;
            pos[7]=v4.y;
            pos[8]=v4.z;
            pos[9]=v2.x;
            pos[10]=v2.y;
            pos[11]=v2.z;
            pos[12]=v3.x;
            pos[13]=v3.y;
            pos[14]=v3.z;
            pos[15]=v4.x;
            pos[16]=v4.y;
            pos[17]=v4.z;
            texval=new float[12];
            texval[0]=0.0f;
            texval[1]=0.0f;
            texval[2]=1.0f;
            texval[3]=0.0f;
            texval[4]=0.0f;
            texval[5]=1.0f;
            texval[6]=1.0f;
            texval[7]=0.0f;
            texval[8]=1.0f;
            texval[9]=1.0f;
            texval[10]=0.0f;
            texval[11]=1.0f;
            meshb=new TriangleArray(6,GeometryArray.COORDINATES|GeometryArray.TEXTURE_COORDINATE_2);
            meshb.setCoordinates(0,pos,0,6);
            meshb.setTextureCoordinates(0,0,texval,0,6);
            meshc=new Shape3D(meshb);
            Appearance app=new Appearance();
            PolygonAttributes pa=new PolygonAttributes();
            pa.setCullFace(PolygonAttributes.CULL_NONE);
            app.setPolygonAttributes(pa);
            mesh=new TransformGroup();
            mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
            mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
            app.setTexture(tex);
            meshc.setAppearance(app);
            mesh.addChild(meshc);
            transform=new Transform3D();
            mesh.setTransform(transform);
            bg=new BranchGroup();
            bg.setCapability(BranchGroup.ALLOW_DETACH);
            bg.addChild(mesh);
        }
        catch(Exception e){
        }
    }
    public void transform(float x,float y,float z){
        Transform3D tf=new Transform3D();
        tf.setTranslation(new Vector3f(x,y,z));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
    public void rotLeft(float w){
        float w2=(float)(w*180/Math.PI);
        Transform3D tf=new Transform3D();
        tf.setRotation(new AxisAngle4f(0.0f,1.0f,0.0f,w));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
    public void rotUp(float w){
        float w2=(float)(w*180/Math.PI);
        Transform3D tf=new Transform3D();
        tf.setRotation(new AxisAngle4f(0.0f,0.0f,1.0f,w));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
}
class Kugel{
    Kugel next;
    float[]pos=new float[3*3*2*256];
    Transform3D transform;
    TriangleArray meshb;
    Shape3D meshc;
    TransformGroup mesh;
    short radius;
    double[]posf=new double[3*3*2*256];
    BranchGroup bg;
    public Kugel(Vektor middle,int radiusb,int r,int g,int b){
        radius=(short)radiusb;
        for(int i=0;i<16;i++){
            for(int j=0;j<16;j++){
                double wx=((double)i/16.0)*Math.PI*2;
                double wy=((double)j/16.0)*Math.PI-Math.PI/2;
                double wxp=((double)(i+1)/16.0)*Math.PI*2;
                double wyp=((double)(j+1)/16.0)*Math.PI-Math.PI/2;
                double zu=Math.sin(wyp)*radius;
                double zd=Math.sin(wy)*radius;
                double hu=Math.cos(wyp)*radius;
                if(hu<0){
                    hu=-hu;
                }
                double hd=Math.cos(wy)*radius;
                if(hd<0){
                    hd=-hd;
                }
                double xuu=Math.cos(wxp)*hu;
                double yuu=Math.sin(wxp)*hu;
                double xdd=Math.cos(wx)*hd;
                double ydd=Math.sin(wx)*hd;
                double xud=Math.cos(wx)*hu;
                double yud=Math.sin(wx)*hu;
                double zud=zu;
                double xdu=Math.cos(wxp)*hd;
                double ydu=Math.sin(wxp)*hd;
                double zdu=zd;
                posf[(i*16+j)*18]=xdd;
                posf[(i*16+j)*18+1]=ydd;
                posf[(i*16+j)*18+2]=zd;
                posf[(i*16+j)*18+3]=xuu;
                posf[(i*16+j)*18+4]=yuu;
                posf[(i*16+j)*18+5]=zu;
                posf[(i*16+j)*18+6]=xud;
                posf[(i*16+j)*18+7]=yud;
                posf[(i*16+j)*18+8]=zud;

                posf[(i*16+j)*18+9]=xdd;
                posf[(i*16+j)*18+10]=ydd;
                posf[(i*16+j)*18+11]=zd;
                posf[(i*16+j)*18+12]=xuu;
                posf[(i*16+j)*18+13]=yuu;
                posf[(i*16+j)*18+14]=zu;
                posf[(i*16+j)*18+15]=xdu;
                posf[(i*16+j)*18+16]=ydu;
                posf[(i*16+j)*18+17]=zdu;
            }
        }
        for(int i=0;i<3*3*2*16*16;i++){
            pos[i]=(float)posf[i];
        }
        meshb=new TriangleArray(3*2*16*16,GeometryArray.COORDINATES|GeometryArray.COLOR_3);
        meshb.setCoordinates(0,pos,0,3*2*16*16);
        byte[]colbyte=new byte[3*3*2*16*16];
        for(int i=0;i<3*2*16*16;i++){
            colbyte[i*3]=(byte)r;
            colbyte[i*3+1]=(byte)g;
            colbyte[i*3+2]=(byte)b;
        }
        meshb.setColors(0,colbyte);
        meshc=new Shape3D(meshb);
        Appearance app=new Appearance();
        PolygonAttributes pa=new PolygonAttributes();
        pa.setCullFace(PolygonAttributes.CULL_NONE);
        app.setPolygonAttributes(pa);
        meshc.setAppearance(app);
        transform=new Transform3D();
        transform.setTranslation(new Vector3f(middle.x,middle.y,middle.z));
        mesh=new TransformGroup();
        mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        mesh.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        mesh.addChild(meshc);
        mesh.setTransform(transform);
        bg=new BranchGroup();
        bg.setCapability(BranchGroup.ALLOW_DETACH);
        bg.addChild(mesh);
    }
    public void delete(){
        bg.removeChild(mesh);
        mesh=null;
        bg=null;
    }
    public void transform(float x,float y,float z){
        Transform3D tf=new Transform3D();
        tf.setTranslation(new Vector3f(x,y,z));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
    public void rotLeft(float w){
        float w2=(float)(w/Math.PI*180.0f);
        Transform3D tf=new Transform3D();
        tf.setRotation(new AxisAngle4f(0.0f,1.0f,0.0f,w));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
    public void rotUp(float w){
        float w2=(float)(w/Math.PI*180.0f);
        Transform3D tf=new Transform3D();
        tf.setRotation(new AxisAngle4f(0.0f,0.0f,1.0f,w));
        MatMult.multleft(transform,tf);
        mesh.setTransform(transform);
    }
}
class MatMult{
    public static void multleft(Transform3D original,Transform3D mult){
        float[]a=new float[16];
        mult.get(a);
        float[][]a2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                a2[i][j]=a[i*4+j];
            }
        }
        float[]b=new float[16];
        original.get(b);
        float[][]b2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                b2[i][j]=b[i*4+j];
            }
        }
        float[][]c2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                for(int k=0;k<4;k++){
                    c2[i][j]=c2[i][j]+a2[i][k]*b2[k][j];
                }
            }
        }
        float[]c=new float[16];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                c[i*4+j]=c2[i][j];
            }
        }
        original.set(c);
    }
}
class Vektor{
    short x;
    short y;
    short z;
    public Vektor(int x,int y,int z){
        this.x=(short)x;
        this.y=(short)y;
        this.z=(short)z;
    }
}
class Projection{
    public static float[] convert(float[][]pro){
        float[]ret=new float[16];
        ret[0]=pro[0][0];
        ret[1]=pro[0][1];
        ret[2]=pro[0][2];
        ret[3]=pro[0][3];
        ret[4]=pro[1][0];
        ret[5]=pro[1][1];
        ret[6]=pro[1][2];
        ret[7]=pro[1][3];
        ret[8]=pro[2][0];
        ret[9]=pro[2][1];
        ret[10]=pro[2][2];
        ret[11]=pro[2][3];
        ret[12]=pro[3][0];
        ret[13]=pro[3][1];
        ret[14]=pro[3][2];
        ret[15]=pro[3][3];
        return ret;
    }
    public static float[] normalize(float[]v){
        float[]ret=new float[3];
        float len=(float)Math.sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]);
        ret[0]=v[0]/len;
        ret[1]=v[1]/len;
        ret[2]=v[2]/len;
        return ret;
    }
    public static float[] vectorproduct(float[]a,float[]b){
        float[]ret=new float[3];
        ret[0]=a[1]*b[2]-a[2]*b[1];
        ret[1]=a[2]*b[0]-a[0]*b[2];
        ret[2]=a[0]*b[1]-a[1]*b[0];
        return ret;
    }
    public static float[][] projection(float eyex,float eyey,float eyez,float centerx,float centery,float centerz,float upx,float upy,float upz){
        float[]f=new float[3];
        f[0]=centerx-eyex;
        f[1]=centery-eyey;
        f[2]=centerz-eyez;
        float[]f2=normalize(f);
        float[]up=new float[3];
        up[0]=upx;
        up[1]=upy;
        up[2]=upz;
        float[]up2=normalize(up);
        float[]s=vectorproduct(f2,up2);
        float[]u=vectorproduct(s,f2);
        float[][]ret=new float[4][4];
        ret[0][0]=s[0];
        ret[0][1]=s[1];
        ret[0][2]=s[2];
        ret[0][3]=0;
        ret[1][0]=u[0];
        ret[1][1]=u[1];
        ret[1][2]=u[2];
        ret[1][3]=0;
        ret[2][0]=-f2[0];
        ret[2][1]=-f2[1];
        ret[2][2]=-f2[2];
        ret[2][3]=0;
        ret[3][0]=0;
        ret[3][1]=0;
        ret[3][2]=0;
        ret[3][3]=1;
        return ret;
    }
}
class MatMult2{
    public static void multleft(Transform3D original,Transform3D mult){
        float[]a=new float[16];
        mult.get(a);
        float[][]a2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                a2[i][j]=a[i*4+j];
            }
        }
        float[]b=new float[16];
        original.get(b);
        float[][]b2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                b2[i][j]=b[i*4+j];
            }
        }
        float[][]c2=new float[4][4];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                for(int k=0;k<4;k++){
                    c2[i][j]=c2[i][j]+a2[i][k]*b2[k][j];
                }
            }
        }
        float[]c=new float[16];
        for(int i=0;i<4;i++){
            for(int j=0;j<4;j++){
                c[i*4+j]=c2[i][j];
            }
        }
        original.set(c);
    }
}
class KeyboardMapperAppletSwing extends JPanel implements ActionListener,KeyListener,MouseListener{
    JLabel info;
    ListBox l;
    JButton remove;
    JButton addspecial;
    JButton apply;
    JButton cancel;
    JButton dontapply;
    boolean cancelb=false;
    boolean applyb=false;
    boolean closed=false;
    int kstatus=0;
    int aliasx=0;
    KeyMapperTable kmt;
    JApplet applet;
    int[]alias=new int[0];
    int[]key=new int[0];
    boolean[]special=new boolean[0];
    private static final long serialVersionUID = 5772434866526097156L;
    public KeyboardMapperAppletSwing(JApplet applet){
        setSize(400,400);
        setLayout(null);
        this.applet=applet;
        info=new JLabel("");
        l=new ListBox();
        remove=new JButton("remove");
        addspecial=new JButton("add special key");
        apply=new JButton("apply");
        cancel=new JButton("cancel");
        dontapply=new JButton("don't apply");
        add(info);
        add(l);
        add(remove);
        add(addspecial);
        add(apply);
        add(cancel);
        add(dontapply);
        info.setBounds(10,10,380,27);
        l.setBounds(10,40,380,170);
        remove.setBounds(10,250,80,27);
        addspecial.setBounds(10,280,380,27);
        apply.setBounds(10,310,80,27);
        cancel.setBounds(210,310,80,27);
        dontapply.setBounds(10,340,160,27);
        kmt=new KeyMapperTable();
        loadfirst();
        savekmt();
        remove.addActionListener(this);
        addspecial.addActionListener(this);
        apply.addActionListener(this);
        cancel.addActionListener(this);
        dontapply.addActionListener(this);
        addKeyListener(this);
        addMouseListener(this);
        info.setOpaque(true);
        info.setBackground(Color.white);
    }
    public InputStream getInputStream(String filename){
        try{
            InputStream is=applet.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
        }
        return null;
    }
    public synchronized void mousePressed(MouseEvent me) {
        requestFocus();
        l.click(me.getX()-10,me.getY()-40);
        l.repaint();
    }
    public synchronized void mouseReleased(MouseEvent e) {
    }
    public synchronized void mouseExited(MouseEvent e) {
    }
    public synchronized void mouseEntered(MouseEvent e) {
    }
    public synchronized void mouseClicked(MouseEvent e) {
    }
    public int getKeyCode(int a){
        int n=alias.length;
        for(int i=0;i<n;i++){
            if(alias[i]==a){
                return key[i];
            }
        }
        return a;
    }
    public void savekmt(){
        alias=kmt.alias;
        key=kmt.key;
        special=kmt.special;
    }
    public void restorekmt(){
        kmt.alias=alias;
        kmt.key=key;
        kmt.special=special;
        l.reset();
        int n=key.length;
        for(int i=0;i<n;i++){
            l.addElement("special key "+alias[i]+" alias for "+key[i]);
        }
        l.repaint();
    }
    public void loadfirst(){
        try{
            FileInputStream fis=new FileInputStream("keymapforus.ini");
            fis.close();
            load("keymapforus.ini");
            info.setText("keymapforus.ini loaded and not applied");
        }
        catch(Exception e){
        }
    }
    public void load(String filename){
        try{
            FileInputStream fis=new FileInputStream(filename);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            String inp=null;
            while((inp=dis.readLine())!=null){
                String inp2=dis.readLine();
                String inp3=dis.readLine();
                kmt.addspecial(inp,inp2);
            }
            dis.close();
            fis.close();
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            int n=alias.length;
            for(int i=0;i<n;i++){
                l.addElement("special key "+alias[i]+" alias for "+key[i]);
            }
            l.repaint();
        }
        catch(Exception e){
            info.setText("File not found: "+filename);
        }
    }
    public void keyTyped(KeyEvent e){
    }
    public synchronized void keyPressed(KeyEvent e){
        requestFocus();
        int ekey=e.getKeyCode();
        if(kstatus==1){
            aliasx=ekey;
            kstatus=2;
            info.setText("type key");
        }
        else if(kstatus==2){
            int keyx=ekey;
            kstatus=0;
            info.setText("special key added");
            info.setBackground(Color.white);
            kmt.addspecial(""+aliasx,""+keyx);
            l.addElement("special key "+aliasx+" alias for "+keyx);
            l.repaint();
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void actionPerformed(ActionEvent evt){
        if(evt.getSource()==remove){
            int ind=l.getSelectedIndex();
            if(ind!=-1){
                l.removeElementAt(ind);
                kmt.remove(ind);
                l.repaint();
            }
        }
        if(evt.getSource()==addspecial){
            info.setText("type alias");
            kstatus=1;
            info.setBackground(Color.yellow);
            requestFocus();
        }
        if(evt.getSource()==apply){
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            applyb=true;
            closed=true;
            setVisible(false);
        }
        if(evt.getSource()==cancel){
            restorekmt();
            cancelb=true;
            closed=true;
            setVisible(false);
        }
        if(evt.getSource()==dontapply){
            applyb=false;
            info.setText("KeyboardMapper isn't applied");
        }
    }
}
class KeyMapperTable{
    int[]alias=new int[0];
    int[]key=new int[0];
    boolean[]special=new boolean[0];
    public KeyMapperTable(){
    }
    public void reset(){
        alias=new int[0];
        key=new int[0];
        special=new boolean[0];
    }
    public void addspecial(String a,String b){
        int n=alias.length;
        int[]aliasb=new int[n+1];
        int[]keyb=new int[n+1];
        boolean[]specialb=new boolean[n+1];
        for(int i=0;i<n;i++){
            aliasb[i]=alias[i];
            keyb[i]=key[i];
            specialb[i]=special[i];
        }
        try{
            aliasb[n]=new Integer(a).intValue();
            keyb[n]=new Integer(b).intValue();
        }
        catch(Exception exc){
        }
        specialb[n]=true;
        alias=aliasb;
        key=keyb;
        special=specialb;
    }
    public void remove(int ind){
        int n=alias.length;
        if(n>0){
            int[]aliasb=new int[n-1];
            int[]keyb=new int[n-1];
            boolean[]specialb=new boolean[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind){
                }
                else{
                    aliasb[ib]=alias[i];
                    keyb[ib]=key[i];
                    specialb[ib]=special[i];
                    ib=ib+1;
                }
            }
            alias=aliasb;
            key=keyb;
            special=specialb;
        }
    }
}
class ListBox extends JPanel{
    String[]thestrings=new String[0];
    GetImgKeyboardMapper gikm;
    Image img;
    int uppest=0;
    int n=0;
    int ind=-1;
    private static final long serialVersionUID = -457533304480165971L;
    public ListBox(){
        setLayout(null);
        gikm=new GetImgKeyboardMapper();
        img=gikm.img;
        repaint();
    }
    public synchronized void reset(){
        thestrings=new String[0];
        n=0;
        uppest=0;
        ind=-1;
    }
    public synchronized void setListData(String[]str){
        thestrings=str;
        n=thestrings.length;
    }
    public synchronized void addElement(String s){
        String[]thestrings2=new String[n+1];
        for(int i=0;i<n;i++){
            thestrings2[i]=thestrings[i];
        }
        thestrings2[n]=s;
        n=n+1;
        thestrings=thestrings2;
        uppest=n-8;
        if(uppest<0){
            uppest=0;
        }
    }
    public synchronized void removeElementAt(int ind2){
        int n=thestrings.length;
        if(n>0){
            if(ind==ind2){
                ind=-1;
            }
            else if(ind>ind2){
                ind=ind-1;
            }
            String[]thestrings2=new String[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind2){
                }
                else{
                    thestrings2[ib]=thestrings[i];
                    ib=ib+1;
                }
            }
            thestrings=thestrings2;
            this.n=n-1;
            if(uppest+8>=n){
                uppest=uppest-1;
                if(uppest<0){
                    uppest=0;
                }
            }
        }
    }
    public synchronized int getSelectedIndex(){
        return ind;
    }
    public synchronized void click(int x,int y){
        if(x>=10&&x<370&&y>=5&&y<5+16){
            uppest=uppest-1;
            if(uppest<0){
                uppest=0;
            }
        }
        if(x>=10&&x<370&&y>=5+9*16&&y<5+9*16+16){
            uppest=uppest+1;
            if(uppest+8>n){
                uppest=uppest-1;
            }
        }
        if(x>=10&&x<370&&y>=5+16&&y<5+8*16+16){
            int ind2=(y-5-16)/16+uppest;
            if(ind2>=0&&ind2<n){
                ind=ind2;
            }
        }
    }
    public synchronized void paint(Graphics g){
        Graphics h=img.getGraphics();
        h.setColor(Color.white);
        h.fillRect(0,0,380,170);
        h.setColor(Color.black);
        for(int i=0;i<10;i++){
            h.setColor(Color.black);
            if(ind==uppest+i-1&&ind!=-1&&i!=0&&i!=9){
                h.setColor(Color.green);
            }
            h.drawRect(10,5+i*16,360,15);
        }
        h.setColor(Color.black);
        if(uppest==0){
            h.setColor(Color.red);
        }
        h.drawString("UP",12,5+14);
        h.setColor(Color.black);
        if(uppest+8>=n){
            h.setColor(Color.red);
        }
        h.drawString("DOWN",12,5+9*16+14);
        h.setColor(Color.black);
        for(int i=0;i<8;i++){
            h.setColor(Color.black);
            if(ind==uppest+i&&ind!=-1){
                h.setColor(Color.green);
            }
            int theindex=uppest+i;
            if(theindex<n){
                h.drawString(thestrings[theindex],12,5+16+i*16+14);
            }
        }
        g.drawImage(img,0,0,this);
    }
}
class GetImgKeyboardMapper extends JFrame{
    Image img;
    private static final long serialVersionUID = -8478639040178665797L;
    public GetImgKeyboardMapper(){
        pack();
        img=createImage(380,170);
    }
}
